/*
 * FXpV3ser.c
 *
 * FX example module for pV3 Interactive Server Rev 1 & 2
 *
 * Copyright 1999 - 2000, Massachusetts Institute of Technology.
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include "pV3ser.h"


#ifdef PREFIX
#undef PREFIX
#endif


#ifdef WIN32

#define PREFIX __stdcall

#else

#define PREFIX

#ifdef UNDERSCORE
#define XFTNSDIALFUN xftnsdialfun_
#else
#define XFTNSDIALFUN xftnsdialfun
#endif

#endif


  /* globals */

  static int FXnDisc = 0, *FXvc, *FXsf, *FXsa;


  /* externals */

  extern void PREFIX XFTNSDIALFUN(void *win, int *x, int *y, int *active,
                                  int *outline);



/* pV3 programmed events routine */

void PREFIX
PVEVENTS(void **win, int *type, int *xe, int *ye, int *state)
{
  int   i, idisc = 0, zero = 0;
  int   ivec[3];
  float rvec[4];
  char  string[20];
  static void *winid2, *winid3, *winidd;
  static int  first = 1, lineout = 1;

  /* initialization */

  if (first == 1) {
    i = 2;
    PV_GETPOINTER(&i, &winid2);
    i = 3;
    PV_GETPOINTER(&i, &winid3);
    i = 4;
    PV_GETPOINTER(&i, &winidd);
    first = 0;
  }

  /* get current discipline */
  if (FXnDisc > 1) {
    i = 22;
    PV_GETSTATE(&i, ivec, rvec, string, 20);
    idisc = ivec[0];
  }

  /* 2D window additions */

  if (*win == winid2) {
    if ((*type == 4) && (*state == 2)) {
      XFTNSDIALFUN(win, xe, ye, state, &lineout);
      *win = 0;
    }
    if ((*type == 5) && (*state == 2)) {
      XFTNSDIALFUN(win, xe, ye, &zero, &lineout);
      *win = 0;
    }
    /* replace middle mouse with "s" */
    if ((*type == 2) && (*state == 's')) {
      *type  = 4;
      *state = 2;
    }
  }

  /* 3D window additions */

  if (*win == winid3) {
    if ((*type == 4) && (*state == 2)) {
      i = 3;
      XFTNSDIALFUN(win, xe, ye, &i, &lineout);
      *win = 0;
    }
    if ((*type == 5) && (*state == 2)) {
      XFTNSDIALFUN(win, xe, ye, &zero, &lineout);
      *win = 0;
    }

    if (FXnDisc != 0) 
      if (FXsf[idisc] != -1)
        if ((*type == 2) && (*state == 'S')) {
          if (FXsf[idisc] == 1) {
            printf(" Shocks Off!\n");
            FXsf[idisc] = 0;
          } else {
            printf(" Shocks On!\n");
            FXsf[idisc] = 1;
          }
          printf("\n");
        }

    if (FXnDisc != 0)
      if (FXvc[idisc] != -1)
        if ((*type == 2) && (*state == 'V')) {
          if (FXvc[idisc] == 1) {
            printf(" Votrex Core Off!\n");
            FXvc[idisc] = 0;
          } else {
            printf(" Votrex Core On!\n");
            FXvc[idisc] = 1;
          }
          printf("\n");
        }

    if (FXnDisc != 0)
      if (FXsa[idisc] != -1)
        if ((*type == 2) && (*state == 'L')) {
          if (FXsa[idisc] != 0) {
            printf(" Separation & Attachment Lines Off!\n");
            FXsa[idisc] = 0;
          } else {
            printf(" Separation & Attachment Lines On!\n");
            FXsa[idisc] = -99999;
          }
          printf("\n");
        }

  }

  /* Dial window additions */

  if (*win == winidd) {
    if ((*type == 2) && (*state == 'O')) {
      lineout++;
      if (lineout >  1) lineout = 0;
      if (lineout == 0) {
        printf("Outline mode: Off!\n");
      } else {
        printf("Outline mode: On!\n");
      }
      printf("\n");
    }
  }

}


/* render routine for Shocks */

void
pV_RenderSF(int *stat, int *exn, int *mask, int *cid, int *cnt,
            int *len0, void *sub0, int *len1, void *sub1, int *len2, void *sub2,
            int *len3, void *sub3, int *len4, void *sub4, int *len5, void *sub5,
            int *len6, void *sub6, int *len7, void *sub7, int *len8, void *sub8,
            int *len9, void *sub9, int *lenA, void *subA, int *lenB, void *subB)
{
  int   itype = 1, icolor = 0;
  float dummy[2];

  if ((*mask == 0) || (*len0 < 3)) return;

  PV_OBJECT3D(&itype, &icolor, (float *) sub0, dummy, dummy, len0);

}


static void
pVRegisterSF(int idisc)
{
  int  num, index = 102;
  int  type[] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  size[] = { 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  opt[]  = { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  loc[]  = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 };
  char name[] = "Shocks              ";

#ifdef WIN32
  PV_REGISTER(&index, name, 20, type, size, opt, loc, pV_RenderSF, &num);
#else
  PV_REGISTER(&index, name, type, size, opt, loc, pV_RenderSF, &num, 20);
#endif
  if (num < 0) {
    printf(" pV_Register Error for Shocks -- discipline %d (%d)\n",
           idisc, num);
    FXsf[idisc] = -1;
  } else {
    FXsf[idisc] =  0;
  }
}


/* render routine for Votrex Cores */

void
pV_RenderVC(int *stat, int *exn, int *mask, int *cid, int *cnt,
            int *len0, void *sub0, int *len1, void *sub1, int *len2, void *sub2,
            int *len3, void *sub3, int *len4, void *sub4, int *len5, void *sub5,
            int *len6, void *sub6, int *len7, void *sub7, int *len8, void *sub8,
            int *len9, void *sub9, int *lenA, void *subA, int *lenB, void *subB)
{
  int   i, m, n, *segs, itline = 4, white = -1;
  float dummy[2], *vcoor;

  if ((*mask == 0) || (*len0 < 2)) return;

  vcoor = (float *) sub0;
  segs  = (int *)   sub1;
 
  for (m = i = 0; i < *len1; i++) {
    n = segs[i] - m;
    PV_OBJECT3D(&itline, &white, &vcoor[3*m], dummy, dummy, &n);
    m = segs[i];
  }

}


static void
pVRegisterVC(int idisc)
{
  int  num, index = 101;
  int  type[] = { 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  size[] = { 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  opt[]  = { 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  loc[]  = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 };
  char name[] = "Vortex Cores        ";

#ifdef WIN32
  PV_REGISTER(&index, name, 20, type, size, opt, loc, pV_RenderVC, &num);
#else
  PV_REGISTER(&index, name, type, size, opt, loc, pV_RenderVC, &num, 20);
#endif
  if (num < 0) {
    printf(" pV_Register Error for Vortex Cores -- discipline %d (%d)\n",
           idisc, num);
    FXvc[idisc] = -1;
  } else {
    FXvc[idisc] =  0;
  }
}


/* render routine for Separation & Attachment lines */

void
pV_RenderSA(int *stat, int *exn, int *mask, int *cid, int *cnt,
            int *len0, void *sub0, int *len1, void *sub1, int *len2, void *sub2,
            int *len3, void *sub3, int *len4, void *sub4, int *len5, void *sub5,
            int *len6, void *sub6, int *len7, void *sub7, int *len8, void *sub8,
            int *len9, void *sub9, int *lenA, void *subA, int *lenB, void *subB)
{
  int   itline = 3, white = -1, grey = 0;
  float dummy[2], *scoor, *acoor;

  if (*mask == 0) return;

  scoor = (float *) sub0;
  acoor = (float *) sub1;

  if (*len0 > 1) 
    PV_OBJECT3D(&itline, &white, scoor, dummy, dummy, len0);

  if (*len1 > 1)
    PV_OBJECT3D(&itline, &grey,  acoor, dummy, dummy, len1);

}


static void
pVRegisterSA(int idisc)
{
  int  num, index = 103;
  int  type[] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  size[] = { 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  opt[]  = { 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  int  loc[]  = {-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1 };
  char name[] = "Sep & Att Lines     ";

#ifdef WIN32
  PV_REGISTER(&index, name, 20, type, size, opt, loc, pV_RenderSA, &num);
#else
  PV_REGISTER(&index, name, type, size, opt, loc, pV_RenderSA, &num, 20);
#endif
  if (num < 0) {
    printf(" pV_Register Error for Sep & Att Lines -- discipline %d (%d)\n",
           idisc, num);
    FXsa[idisc] = -1;
  } else {
    FXsa[idisc] =  0;
  }
}


void PREFIX
PVSAFE()
{
  int   ivec[3], i, j, isave;
  float rvec[4];
  char  string[20];
  static int first = 1;

  /* register the extracts at initialization -- first time through */

  if (first == 1) {
    printf(" Modified Server includes:\n");
    printf("    Shock Finder\n");
    printf("    Vortex Core Finder\n");
    printf("    Separation & Attachment Lines\n");
    printf("    Cursor-based 3D/2D Movement\n");

    i = 22;
    PV_GETSTATE(&i, ivec, rvec, string, 20);
    isave   = ivec[0];
    FXnDisc = ivec[1];

    FXsf = (int *) malloc(FXnDisc*sizeof(int));
    FXvc = (int *) malloc(FXnDisc*sizeof(int));
    FXsa = (int *) malloc(FXnDisc*sizeof(int));
    if ((FXsf == NULL) || (FXvc == NULL) || (FXsa == NULL)) {
      printf(" Malloc ERROR for discipline storage!\n\n");
      if (FXsf != NULL) free(FXsf);
      if (FXvc != NULL) free(FXvc);
      if (FXsa != NULL) free(FXsa);
      FXnDisc = first = 0;
      return;
    }

   /* register extract for each possible discipline */

    for (j = 0; j < FXnDisc; j++) {
      if (FXnDisc != 1) {
        ivec[0] = j;
        ivec[1] = 0;
        PV_SETSTATE(&i, ivec, rvec, string, 20);
      }
      pVRegisterSF(j);
      pVRegisterVC(j);
      pVRegisterSA(j);
    }
    if (FXnDisc != 1) {
      ivec[0] = isave;
      ivec[1] = 0;
      PV_SETSTATE(&i, ivec, rvec, string, 20);
    }

    printf("\n");
    first = 0;
  }

}


void PREFIX
PVSETEXTRACT(int *index, int *exnum, int *plotmask, int *reqmask,
             int *iv,  float *rv)
{
  int   ivec[11], i, n, type, num, idisc;
  float rvec[12];
  void  *ex, *nex;
  char  string[20], name[20];

  if (FXnDisc == 0) return;

  i = 22;
  PV_GETSTATE(&i, ivec, rvec, string, 20);
  idisc = ivec[0];

  /* Vortex Core */

  if (*index == 101) {

    /* set to eigen-vector of real val */
    *iv = 1;

    *plotmask = *reqmask = 0;
    if (FXvc[idisc] == 1) {
      *plotmask = 1;
      *reqmask  = 3;
    }
  }

  /* Shock Finder */

  if (*index == 102) {

    /* min number of nodes = 4,  min delta press = 0.1 */
    *iv = 4;
    *rv = 0.1;

                          *plotmask = *reqmask = 0;
    if (FXsf[idisc] == 1) *plotmask = *reqmask = 1;
  }

  /* Separation & Attachment Lines */

  if (*index == 103) {

    *plotmask = *reqmask = 0;
    if (FXsa[idisc] == 0) return;

    /* get surface global index */
    i = 10;
    PV_GETSTATE(&i, ivec, rvec, string, 20);
    *iv = 0;
    ex  = NULL;
    do {
#ifdef WIN32
      PV_GETEXTRACT(&ex, &type, &num, ivec, rvec, name, 20, &nex);
#else
      PV_GETEXTRACT(&ex, &type, &num, ivec, rvec, name, &nex, 20);
#endif
      for (n = i = 0; i < 20; i++) if (string[i] != name[i]) n++;
      if (n == 0) {
        *iv = num;
        break;
      }
      ex = nex;
    } while (ex != NULL);

    if (*iv == 0) {
      printf(" pVSetExtract: Surface \n");
      for (i = 0; i < 20; i++)  printf("%c", string[i]);
      printf(" NOT Found!\n");
      return;
    }
    *plotmask = 1;
    *reqmask  = 3;

    /* clear twice, if change of surface */
    i = *iv;
    if (FXsa[idisc] !=  i) *reqmask |= (1 << 31);

    if (FXsa[idisc] == -i) {
      FXsa[idisc] =  i;
    } else if (FXsa[idisc] != i) {
      FXsa[idisc] = -i;
    }
  }

}
