	program Visual3
c
c	reads a structured grid and flow data from the command line
c	  creates the Visual3 information from the plot3d data sets
c
c	notes:  (1) if the 3 argument is anything this reads a single
c		    block
c		(2) memory is allocated in this program based on the
c			problem's size
c
        parameter (nkeys = 8)
c
        integer      keytyp(nkeys), ikeys(nkeys), kblk(3,128)
	integer      ii(128), jj(128), kk(128), nn
        real         flims(2,nkeys)
        character*16 tkeys(nkeys)
	character*80 titl, grid, state
	logical      single, flag
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
c
	data titl/'          PLOT3D Wrapper for Visual3'/
c
c       key bindings
        data tkeys / 'Density         ',
     &               'Pressure        ',
     &               'Mach number     ',
     &               'Stag. pressure  ',
     &               'Stag. enthalpy  ',
     &               'Entropy         ',
     &               'Temperature     ',
     &               'Flow Vectors    '/
        data keytyp/ 7*1, 2/
        data ikeys/100,112,109,120,104,115,116,102/
        data flims/ 14*0.0,  0.01,0.0 /
c
	write(*,*) ' '
	write(*,*) titl
	nvcp    = 0
	nvc     = 0
	ptensor = 0
c
c------ Read arguments
c
	call getarg(3, grid)
	single = grid .ne. ' '
        call getarg(1, grid)
	if(grid .eq. ' ') stop 'NO Grid File!'
        call getarg(2, state)
	if(state .eq. ' ') stop 'NO Flow File!'
	nn  = 1
	nnl = 1
c
c	get sizes
	open(11, file=grid, form='unformatted')
	if(.not. single) read(11) nn
	if(nn .gt. 128) stop 'Too many blocks!'
	read(11) (ii(i),jj(i),kk(i),i=1,nn)
	write(*,*) ' '
	write(*,*) nn
	open(12, file=state, form='unformatted')
        if(.not. single) read(12) nnl
	write(*,*) nnl
	read(12) (il(i),jl(i),kl(i),i=1,nn)
	if(nn.ne.nnl) stop 'Grid mismatch 1!'
	do i = 1, nn
	  if(ii(i).ne.il(i).or.jj(i).ne.jl(i).or.kk(i).ne.kl(i)) then
	      stop 'Grid mismatch 2!'
	  endif
	enddo
c
c	get pointers to enough memory
c
	knode = 0
        do i=1, nn
	   knode = knode + il(i)*jl(i)*kl(i)
	enddo  
	write(*,*) 'Nodes:', knode
	pq   = mallocV3(5*knode*4)
	if(pq   .eq. 0) stop 'MALLOC Error on Q!'
	pgrd = mallocV3(3*knode*4)
	if(pgrd .eq. 0) stop 'MALLOC Error on Grid!'
c
c---- Read plot3d flow file
c
	knod = 0
	write(*,*) 'Solution File:'
	do j = 1, nn
	   inod = il(j)*jl(j)*kl(j)
	   read(12) fmach, alpha, re, time
	   write(*,*) ' Reading block:', j, il(j), jl(j), kl(j)
	   read(12) (q(i        ), i = knod+1, knod+inod),
     &              (q(i+  knode), i = knod+1, knod+inod),
     &              (q(i+2*knode), i = knod+1, knod+inod),
     &              (q(i+3*knode), i = knod+1, knod+inod),
     &              (q(i+4*knode), i = knod+1, knod+inod)
	   knod = knod + inod
	enddo
	write(*,*) 'Solution File Complete!'
	close(12)
	gam = 1.4
c
c---- Read plot3d grid data
c
	knod = 0
	write(*,*) 'Grid File:'
	do j = 1, nn
	   write(*,*) ' Reading Block:', j
	   inod = il(j)*jl(j)*kl(j)
	   read(11) (grd(i        ), i = knod+1, knod+inod),
     &              (grd(i+  knode), i = knod+1, knod+inod),
     &              (grd(i+2*knode), i = knod+1, knod+inod)
	   knod = knod + inod
	enddo
	write(*,*) 'Grid Complete!'
	close(11)
	
c
c-----  set up Visual3 constants
c
	keq = 0
	if(.not. single) then
	  open(1,file='equiv.dat')
	  read(1,*) keq
	  close(1)
	endif
	write(*,*) ' # Equivalance nodes =', keq
	inquire(file='vissurf.dat', exist=flag)
	knsurf  = 4
	if(.not. flag) knsurf = nn*6
 	ksurf   = 0
	knodes  = 0 
	mirror  = 0
	kcel1   = 0
	kcel2   = 0
	kcel3   = 0
	kcel4   = 0
	knptet  = 0
	kptet   = 0
	knblk   = nn
	do i = 1, nn
	   kblk(1,i) = il(i)
	   kblk(2,i) = jl(i)
	   kblk(3,i) = kl(i)
	enddo
c
	write(*,*) 'Start Initialization'
        call V3_Init(titl, 0, 'spec.col', 99, .true.,
     &               nkeys, ikeys, tkeys, keytyp, flims,
     &               mirror, knodes, keq, kcel1, kcel2, kcel3, kcel4,
     &               knptet, kptet, knblk, kblk, ksurf, knsurf)
c
	stop
	end



	subroutine V3Surface(nsurf, surf, scel, tsurf)
c
c	use node numbers to define surfaces
c
	integer      surf(*), scel(4,*), nsurf(2,*)
	character*20 tsurf(*)
	character*20 titles(9)
	data titles /'Block Interface  ',
	2     'Viscous wall     ',
	3     'Something        ',
	4     'Symmetry Plane   ',
	5     'Five             ',
	6     'Six              ',
	7     'Seven            ',
	8     'Outflow          ',
	9     'Freestream Inflow'/


c		nsurf	- pointers to the end of each surface group and
c			  flag to indicate if surface is on
c		surf	- pointers to cells+faces that make the surfaces
c		scel    - node numbers for surfaces
c		tsurf	- surface group title (optional)
c
c	Note: Change the routine to reflect the surfaces of interest
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
C up to 500 faces allowed
	integer surfcnt(9), data(500,7), icnt
	logical flag
c
	write(*,*) 'Start Surfaces'
	inquire(file='vissurf.dat', exist=flag)
	if(.not. flag) go to 1
c
	open(1,file='vissurf.dat')
	ifacs=0
	do i=1,9
	   read(1,*) surfcnt(i)
	   ifacs=ifacs + surfcnt(i)
	end do
	if (ifacs.gt.500) stop 'too many faces'

	icnt=0
	do i=1,9
	   do j=1,surfcnt(i)
	      icnt=icnt+1
	      read(1,*)(data(icnt,k),k=1,7)
	   end do
	end do


	ksurf = 0
	isurf = 0
	
	icnt=0
	do n=1,9
	   do ifacs=1,surfcnt(n)
	      icnt=icnt+1
	      iblk=data(icnt,1)
	      imin=data(icnt,2)+1
	      jmin=data(icnt,3)+1
	      kmin=data(icnt,4)+1
	      imax=data(icnt,5)+1
	      jmax=data(icnt,6)+1
	      kmax=data(icnt,7)+1
	      if(imin.eq.imax)then
		 do k=kmin,kmax-1
		    do j=jmin,jmax-1
		       ksurf=ksurf+1
		       scel(1,ksurf)=noden(iblk,imin,j,k)
		       scel(2,ksurf)=noden(iblk,imin,j,k+1)
		       scel(3,ksurf)=noden(iblk,imin,j+1,k+1)
		       scel(4,ksurf)=noden(iblk,imin,j+1,k)
		    end do
		 end do
	      end if
	      if(jmin.eq.jmax)then
		 do k=kmin,kmax-1
		    do i=imin,imax-1
		       ksurf=ksurf+1
		       scel(1,ksurf)=noden(iblk,i,jmin,k)
		       scel(2,ksurf)=noden(iblk,i,jmin,k+1)
		       scel(3,ksurf)=noden(iblk,i+1,jmin,k+1)
		       scel(4,ksurf)=noden(iblk,i+1,jmin,k)
		    end do
		 end do
	      end if
	      if(kmin.eq.kmax)then
		 do j=jmin,jmax-1
		    do i=imin,imax-1
		       ksurf=ksurf+1
		       scel(1,ksurf)=noden(iblk,i,j,kmin)
		       scel(2,ksurf)=noden(iblk,i,j+1,kmin)
		       scel(3,ksurf)=noden(iblk,i+1,j+1,kmin)
		       scel(4,ksurf)=noden(iblk,i+1,j,kmin)
		    end do
		 end do
	      end if
	   end do
	   if(surfcnt(n).gt.0)then
	      isurf=isurf+1
	      nsurf(1,isurf)=ksurf
	      nsurf(2,isurf)=1
	      tsurf(isurf)=titles(n)	   
	   end if
	end do
	
	write(*,*) ksurf
100	continue
	go to 2
c
c	no surface file
 1	ksurf = 0
	kns   = 0
	nsrf  = 0
	do kb = 1, nnl
	  jplane = il(kb)
	  kplane = jplane*jl(kb)
c
c	  surface 1
	  do k = 1, kl(kb)-1
	    do  j = 1, jl(kb)-1
	      ksurf = ksurf + 1
	      kn = kns + 1 + (j-1)*jplane + (k-1)*kplane
	      scel(1,ksurf) = kn
	      scel(2,ksurf) = kn + jplane
	      scel(3,ksurf) = kn + jplane + kplane
	      scel(4,ksurf) = kn          + kplane
	    enddo
	  enddo
	  nsrf = nsrf + 1
	  nsurf(1,nsrf) = ksurf
c	  render on
	  nsurf(2,nsrf) = 1
	  write(tsurf(nsrf),1000) kb,'I = 1'
 1000	  format(i3,' ',a)
c
c	  surface 2
	  do k = 1, kl(kb)-1
	    do j = 1, jl(kb)-1
	      ksurf = ksurf + 1
	      kn = kns + j*jplane + (k-1)*kplane
	      scel(1,ksurf) = kn
	      scel(2,ksurf) = kn + jplane
	      scel(3,ksurf) = kn + jplane + kplane
	      scel(4,ksurf) = kn          + kplane
	    enddo
	  enddo
	  nsrf = nsrf + 1
	  nsurf(1,nsrf) = ksurf
	  nsurf(2,nsrf) = 0
	  write(tsurf(nsrf),1000) kb,'I = Max'
c
c	  surface 3
	  do j = 1, jl(kb)-1
	    do i = 1, il(kb)-1
	      ksurf = ksurf + 1
	      kn = kns + i + (j-1)*jplane
	      scel(1,ksurf) = kn
	      scel(2,ksurf) = kn + 1
	      scel(3,ksurf) = kn + 1 + jplane
	      scel(4,ksurf) = kn     + jplane
	    enddo
	  enddo
	  nsrf = nsrf + 1
	  nsurf(1,nsrf) = ksurf
c	  render on
	  nsurf(2,nsrf) = 1
	  write(tsurf(nsrf),1000) kb,'K = 1'
c
c	  surface 4
	  do j = 1, jl(kb)-1
	    do i = 1, il(kb)-1
	      ksurf = ksurf + 1
	      kn = kns + i + (j-1)*jplane + (kl(kb)-1)*kplane
	      scel(1,ksurf) = kn
	      scel(2,ksurf) = kn + 1
	      scel(3,ksurf) = kn + 1 + jplane
	      scel(4,ksurf) = kn     + jplane
	    enddo
	  enddo
	  nsrf = nsrf + 1
	  nsurf(1,nsrf) = ksurf
	  nsurf(2,nsrf) = 0
	  write(tsurf(nsrf),1000) kb,'K = Max'
c
c	  surface 5
	  do k = 1, kl(kb)-1
	    do i = 1, il(kb)-1
	      ksurf = ksurf + 1
	      kn = kns + i + (k-1)*kplane
	      scel(1,ksurf) = kn
	      scel(2,ksurf) = kn + 1
	      scel(3,ksurf) = kn + 1 + kplane
	      scel(4,ksurf) = kn     + kplane
	    enddo
	  enddo
	  nsrf = nsrf + 1
	  nsurf(1,nsrf) = ksurf
c	  render on
	  nsurf(2,nsrf) = 1
	  write(tsurf(nsrf),1000) kb,'J = 1'
c
c	  surface 6
	  do k = 1, kl(kb)-1
	    do i = 1, il(kb)-1
	      ksurf = ksurf + 1
	      kn = kns + i + (jl(kb)-1)*jplane + (k-1)*kplane
	      scel(1,ksurf) = kn
	      scel(2,ksurf) = kn + 1
	      scel(3,ksurf) = kn + 1 + kplane
	      scel(4,ksurf) = kn     + kplane
	    enddo
	  enddo
	  nsrf = nsrf + 1
	  nsurf(1,nsrf) = ksurf
	  nsurf(2,nsrf) = 0
	  write(tsurf(nsrf),1000) kb,'J = Max'
c
	  kns = kns + kl(kb)*kplane
	enddo
c
 2	write(*,*) 'End Surfaces!'
	return
	end


	subroutine V3Grid(xyz)
c
c	pass the coordinate triads to Visual3
c
	real xyz(3,*)
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
c
c	fill xyz values
c
	write(*,*) 'Start Grid:'
	do i = 1, knode
	   xyz(1,i) = grd(i)
	   xyz(2,i) = grd(i+  knode)
	   xyz(3,i) = grd(i+2*knode)
	enddo
c
	write(*,*) 'End Grid!'
	return
	end


	subroutine V3Scal(key, v)
c
c	return the field scalar in "v" based on the key hit
c
	real v(*)
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
c
	real              tensor(9,1)
	pointer (ptensor, tensor)
	common /tensrx/ ptensor
c
	real            grad(3,1),    vec(3,1),    vol(1)
	pointer (pgrad, grad), (pvec, vec), (pvol, vol)
	real    direc(3)
c
        gm1 = gam - 1.
c
	go to (1, 2, 3, 4, 5, 6, 7), key
c
c       density
 1      do 11 k = 1, knode
          v(k) = q(k)
 11     continue
        return
c
c       pressure
 2      do 21 k = 1, knode
          v(k) = gm1*(q(k+4*knode) -
     &           0.5*(q(k+  knode)*q(k+  knode)+
     &                q(k+2*knode)*q(k+2*knode)+
     &                q(k+3*knode)*q(k+3*knode))/q(k))
 21     continue
        return
c
c       mach number
 3      do 31 k = 1, knode
	  v2   = (q(k+  knode)*q(k+  knode)+q(k+2*knode)*q(k+2*knode)+
     &            q(k+3*knode)*q(k+3*knode))/q(k)
          p    = gm1*(q(k+4*knode) - 0.5*v2)
          v(k) = sqrt(v2/(gam*p))
 31     continue
        return
c
c       stagnation pressure
 4      do 41 k = 1, knode
	  v2    = (q(k+  knode)*q(k+  knode)+q(k+2*knode)*q(k+2*knode)+
     &             q(k+3*knode)*q(k+3*knode))/q(k)
	  p     = gm1*(q(k+4*knode) - 0.5*v2)
	  xmach = sqrt(v2/(gam*p))
	  v(k)  = gam*p*(1.0+0.5*gm1*xmach*xmach)**(gam/gm1)
 41     continue
        return
c
c       stagnation enthalapy
 5      do 51 k = 1, knode
          rr   = 1./q(k)
	  v2   = (q(k+  knode)*q(k+  knode)+q(k+2*knode)*q(k+2*knode)+
     &            q(k+3*knode)*q(k+3*knode))*rr*rr
          v(k) = gm1*gam*(q(k+4*knode)*rr - 0.5*v2) + 0.5*v2
 51     continue
        return
c
c       entropy
 6      do 61 k = 1, knode
	  v2   = (q(k+  knode)*q(k+  knode)+q(k+2*knode)*q(k+2*knode)+
     &            q(k+3*knode)*q(k+3*knode))/q(k)
          p    = gm1*(q(k+4*knode) - 0.5*v2)
          v(k) = alog(gam*p) - gam*alog(q(k))
 61     continue
        return
c
c       temperature
 7      do 71 k = 1, knode
          rr   = 1./q(k)
	  v2   = (q(k+  knode)*q(k+  knode)+q(k+2*knode)*q(k+2*knode)+
     &            q(k+3*knode)*q(k+3*knode))*rr
          v(k) = gam*gm1*(q(k+4*knode)-0.5*v2)*rr
 71     continue
        return
c
        end


        subroutine V3Vect(key, v)
c
c	return the field vector in "v" based on the key hit
c
        dimension v(3,*)
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
c
        do 1 k = 1, knode
          v(1,k) = q(k+  knode)/q(k)
          v(2,k) = q(k+2*knode)/q(k)
          v(3,k) = q(k+3*knode)/q(k)
 1      continue
c
	return
	end


c ********************************************************************
c	Routines for Programmed Cut Planes
c ********************************************************************



	subroutine V3ZPrime(flag,xyz,knode,zp,zprime,xpc,ypc,halfw)
c
c	return z-prime for programmer defined cutting surfaces
c
c		this routine is called when the programmed cutting plane
c		function key is hit to set up the surface data.
c		the operator may be queried in this routine.
c	        Note: this is call is NOT locked out in unsteady usage!
c
c	where:	flag	- .true. first call
c			  .false. grid change (unsteady - iopt > 1)
c			  only ask user questions when flag = .true.
c		xyz	- coordinate triads for all the 3-D nodes.
c			  this is the same data as set in V3GRID
c		knode   - the number of 3-D nodes.   this is the same
c			  value as set in the call to V3_INIT
c
c		note: flag, xyz and knode must not be modified!
c
c		the following paramters are returned by this routine:
c
c		zp	- the calculated z-prime values for the 3-D nodes.
c			  this vector must be completely filled
c		zprime	- the starting z-prime value
c		xpc	- the starting x-prime center value for 
c			  the 2-D window
c		ypc	- the starting y-prime center value for 
c			  the 2-D window
c		halfw	- the starting 1/2 width for the 2-D window in
c			  x-prime/y-prime space.
c
	logical flag
	integer knode
	real    xyz(3,knode), zp(knode), zprime, xpc, ypc, halfw
c
c	common blocks may be used to communicate data between this
c	routine and others (including the main program)
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knodx, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knodx, nnl
	common /prime/ itype
c
c
	if(flag) then
	  call V3_Cursor(.true.)
 1	  write(*,*) 'Enter 1 - R Plane, 2 - Theta Plane or 3 - X Plane'
	  read(*,*,err=1,end=1) id
	  itype = id
	else
	  id = -itype
	endif
c
	if(id .gt. 0) then
	   rave = 0.0
	   tave = 0.0
	   xave = 0.0
	   yave = 0.0
	   zave = 0.0
	   do i = 1, knode
	      rave = rave + sqrt(xyz(3,i)*xyz(3,i) + xyz(2,i)*xyz(2,i))
	      tave = tave + atan2(xyz(2,i), xyz(3,i))
	      xave = xave + xyz(1,i)
	      yave = yave + xyz(2,i)
	      zave = zave + xyz(3,i)
	   enddo
	   rave = rave/float(knode)
	   tave = tave/float(knode)
	   xave = xave/float(knode)
	   yave = yave/float(knode)
	   zave = zave/float(knode)
c       
	   rdev = 0.0
	   tdev = 0.0
	   xdev = 0.0
	   ydev = 0.0
	   zdev = 0.0
	   do 2 i = 1, knode
	      rdev = rdev + abs(sqrt(xyz(3,i)*xyz(3,i)+xyz(2,i)*xyz(2,i))
	1	   -rave)
	      tdev = tdev + abs(atan2(xyz(2,i),xyz(3,i))-tave)
	      xdev = xdev + abs(xyz(1,i)-xave)
	      ydev = ydev + abs(xyz(2,i)-yave)
	      zdev = zdev + abs(xyz(3,i)-zave)
 2	   continue
        endif
c       
        if(itype .eq. 1) then
	   do 3 i = 1, knode
	      zp(i) = sqrt(xyz(3,i)*xyz(3,i)+xyz(2,i)*xyz(2,i))
 3	   continue
	   if(id.gt.0) then
	      zprime = rave
	      ypc    = tave*rave
	      xpc    = xave
	      halfw  = (rave*tdev+xdev)/float(knode)
	   endif
        endif
        if(itype .eq. 2) then
	   do 4 i = 1, knode
	      zp(i) = atan2(xyz(2,i),xyz(3,i))
 4	   continue
	   if(id.gt.0) then
	      zprime = tave
	      xpc    = rave
	      ypc    = xave
	      halfw  = (rdev+xdev)/float(knode)
	   endif
        endif
	if(itype .eq. 3) then
	   do 5 i = 1, knode
	      zp(i) = xyz(1,i)
 5	   continue
	   if(id.gt.0) then
	      zprime = xave
	      xpc    = zave
	      ypc    = yave
	      halfw  = (zdev+ydev)/float(knode)
	   endif
        endif
	
	return
	end


	subroutine V3XYPrime(zprime, kn, xyz, n, xyp)
c
c	return x-prime and y-prime for programmer defined cutting surface
c
c		this routine is called during the data-collection phase
c		of the program defined surfaces.  this routine may be
c		called many times during this phase.
c		there is no ordering of the nodes in kn, infact kn
c		may contain the same node more than once in a single call.
c
c	where:	zprime	- the current z-prime value
c		kn	- a vector of indices for the nodes to be
c			  transformed
c		xyz	- coordinate triads for 3-D nodes.
c			  this is the same data as set in V3GRID
c		n	- the number of nodes to be transformed.
c
c		note: zprime, kn, xyz and n must not be modified!
c
c		the following paramter is returned by this routine:
c
c		xyp	- the calculated x-prime and y-prime values for 
c                         the 3-D nodes
c
	integer kn(n)
	real    zprime, xyz(3,*), xyp(2,n)
c
c	common blocks may be used to communicate data between this
c	routine and others (including the main program)
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
	common /prime/ itype
c

	if(itype .eq. 1) then
          do 1 i = 1, n
            k = kn(i)
            xyp(1,i) = xyz(1,k)
            xyp(2,i) = zprime*atan2(xyz(2,k),xyz(3,k))
 1        continue
        endif
c
        if(itype .eq. 2) then
          do 2 i = 1, n
            k = kn(i)
            xyp(1,i) = sqrt(xyz(3,k)*xyz(3,k) + xyz(2,k)*xyz(2,k))
            xyp(2,i) = xyz(1,k)
 2        continue
        endif
c
        if(itype .eq. 3) then
          do 3 i = 1, n
            k = kn(i)
            xyp(1,i) = xyz(3,k)
            xyp(2,i) = xyz(2,k)
 3        continue
        endif

	return
	end


	integer function noden(blk,in,jn,kn)
c
c	returns the node number given the block and i,j,k
c
	integer blk, in, jn, kn
c
	real           grd(1),    q(1)
	pointer (pgrd, grd), (pq, q)
	integer      il(128),kl(128),jl(128), knode, nnl
	common /grdx/ pgrd,pq, il,jl,kl, gam, knode, nnl
	integer i,j,k,n,cnt
c
	cnt = in + (jn-1)*il(blk) + (kn-1)*il(blk)*jl(blk)
	do n = 1, blk-1
	   cnt = cnt + il(n)*jl(n)*kl(n)
	enddo
c
	noden = cnt
	return
	end

        subroutine V3Equiv(listeq)
        integer listeq(2,*)
c
	write(*,*) 'Start Equiv:'
        open(1,file='equiv.dat')
        read(1,*) inodes
        do i = 1, inodes
           read(1,*) listeq(1,i), listeq(2,i)
        enddo
        close(1)
	write(*,*) 'End Equiv!'
c
	return
	end
