#
PV3DIR  = $(HOME)/pV3
PV3SDIR = $(PV3DIR)/servers/$(PVM_ARCH)

include $(PVM_ARCH)

defaults:	pV3Client pV3Server

pV3Client:	pV3Client.o FXpV3.o ../lib/libFX.a
	$(BUILD) -o pV3Client pV3Client.o FXpV3.o -L../lib -lFX \
		-L$(PV3DIR)/clients/$(PVM_ARCH) -lpV3 \
		-L$(PVM_ROOT)/lib/$(PVM_ARCH) -lgpvm3 -lpvm3 $(LLIBS)

pV3Client.o:	pV3Client.f
	$(FCOMP) -c $(FOPTS) pV3Client.f

FXpV3.o:	FXpV3.c
	$(CCOMP) -c $(COPTS) $(DEFINE) -I../include -I$(PV3DIR)/clients FXpV3.c


pV3Server:	FXpV3ser.o NOdialpV.o
	$(BUILD) -o pV3Server $(PV3SDIR)/pV3Server.o $(PV3SDIR)/netserver.o \
		FXpV3ser.o NOdialpV.o -L$(PV3SDIR) -lpV3ser \
		-L$(PVM_ROOT)/lib/$(PVM_ARCH) -lgpvm3 -lpvm3 $(GLIBS) $(TLIBS)

FXpV3ser.o:	FXpV3ser.c
	$(CCOMP) -c $(COPTS) $(DEFINE) -I$(PV3DIR)/servers FXpV3ser.c

NOdialpV.o:	NOdials.c
	$(CCOMP) -c $(COPTS) $(DEFINE) NOdials.c -DPV3 -o NOdialpV.o

clean:
	-rm pV3Client pV3Server
	-rm pV3Client.o FXpV3.o FXpV3ser.o NOdialpV.o
