/*
 *      FX Include
 *
 *      Fexture eXtraction toolkit include.
 *
 *      Copyright 1999 - 2000, Massachusetts Institute of Technology.
 */

/*
 *      FX.h
 *
 *
$Log$
 */

#ifndef _FX_H_

#define _FX_H_


#ifdef WIN32

#define PREFIX void __stdcall

#else

#define PREFIX void

#ifdef UNDERSCORE

#define FX_INIT         fx_init_
#define FX_UPDATE       fx_update_
#define FX_SHOCKFIND    fx_shockfind_
#define FX_SHOCKSURFACE fx_shocksurface_
#define FX_SHOCKVOLUMES fx_shockvolumes_
#define FX_SHOCKANGLES  fx_shockangles_
#define FX_VORTEXCORE   fx_vortexcore_
#define FX_SEPNLINE     fx_sepnline_
#define FX_RTPARAMS     fx_rtparams_
#define FX_RTTIMESTEP   fx_rttimestep_
#define FX_RTGET        fx_rtget_
#define FX_RTSURFACE    fx_rtsurface_
#define FX_CLOSE        fx_close_

#define FXCELL          fxcell_
#define FXCELLPTR       fxcellptr_
#define FXCELLGET       fxcellget_
#define FXSURFACE       fxsurface_
#define FXSURFACEPTR    fxsurfaceptr_
#define FXGRID          fxgrid_
#define FXGRIDPTR       fxgridptr_
#define FXGRIDP3D       fxgridp3d_
#define FXBLANK         fxblank_
#define FXBLANKPTR      fxblankptr_
#define FXVEL           fxvel_
#define FXVELPTR        fxvelptr_
#define FXVELP3D        fxvelp3d_
#define FXSCAL          fxscal_
#define FXSTRUC         fxstruc_
#define FXMODIFYRT      fxmodifyrt_

#else

#define FX_INIT         fx_init
#define FX_UPDATE       fx_update
#define FX_SHOCKFIND    fx_shockfind
#define FX_SHOCKSURFACE fx_shocksurface
#define FX_SHOCKVOLUMES fx_shockvolumes
#define FX_SHOCKANGLES  fx_shockangles
#define FX_VORTEXCORE   fx_vortexcore
#define FX_SEPNLINE     fx_sepnline
#define FX_RTPARAMS     fx_rtparams
#define FX_RTTIMESTEP   fx_rttimestep
#define FX_RTGET        fx_rtget
#define FX_RTSURFACE    fx_rtsurface
#define FX_CLOSE        fx_close

#define FXCELL          fxcell
#define FXCELLPTR       fxcellptr
#define FXCELLGET       fxcellget
#define FXSURFACE       fxsurface
#define FXSURFACEPTR    fxsurfaceptr
#define FXGRID          fxgrid
#define FXGRIDPTR       fxgridptr
#define FXGRIDP3D       fxgridp3d
#define FXBLANK         fxblank
#define FXBLANKPTR      fxblankptr
#define FXVEL           fxvel
#define FXVELPTR        fxvelptr
#define FXVELP3D        fxvelp3d
#define FXSCAL          fxscal
#define FXSTRUC         fxstruc
#define FXMODIFYRT      fxmodifyrt

#endif
#endif


#ifdef __ProtoGlarp__
#undef __ProtoGlarp__
#endif
#if defined(__STDC__) || defined(__cplusplus) || defined(WIN32)
#define __ProtoGlarp__(x) x
#else
#define __ProtoGlarp__(x) ()
#endif

#ifdef __cplusplus
extern "C" {
#endif

PREFIX	FX_INIT __ProtoGlarp__(( float *gamma, int *iopt,   int *knode,
                                 int *nhalo,   int *ntets,  int *npyra,
                                 int *nprism,  int *nhexa,  int *nblocks,
                                 int *blocks,  int *nhcell, int *nsurf,  
                                 int *nbc,     int *istat ));
PREFIX	FX_UPDATE __ProtoGlarp__(( float *time ));
PREFIX	FX_SHOCKFIND __ProtoGlarp__(( float **test ));
PREFIX	FX_SHOCKSURFACE __ProtoGlarp__(( float *test, int *npts, float **xyz,
                                         int *ntris, int **tris, int **cell ));
PREFIX	FX_SHOCKVOLUMES __ProtoGlarp__(( float *test, int *nvols, float **pvols,
                                         int **pcels, int **cells,
                                         int **pnods, int **nodes ));
PREFIX	FX_SHOCKANGLES __ProtoGlarp__(( float *test, float **angles ));
PREFIX	FX_VORTEXCORE __ProtoGlarp__(( int *type, int *nseg, int **eseg,
                                       float **xyz, float **stren ));
PREFIX	FX_SEPNLINE __ProtoGlarp__(( int *sepind, float **psep,
                                     int *attind, float **patt ));
PREFIX	FX_RTPARAMS __ProtoGlarp__(( int *rtype, float *sm2, float *sm4,
                                     float *kappa ));
PREFIX	FX_RTTIMESTEP __ProtoGlarp__(( float *maxdt ));
PREFIX	FX_RTGET __ProtoGlarp__(( float *rt ));
PREFIX	FX_RTSURFACE __ProtoGlarp__(( float *rt, float *rtv, int *npts, 
                                      float **xyz, int *ntris, int **tris, 
                                      int **cell ));
PREFIX	FX_CLOSE __ProtoGlarp__(( void ));

PREFIX	FXCELL       __ProtoGlarp__(( int *tets,   int *pyras,  int *prisms,
                                      int *hexas,  int *halo ));
PREFIX	FXCELLPTR    __ProtoGlarp__(( int **tets,  int **pyras, int **prisms,
                                      int **hexas, int *halo ));
PREFIX	FXCELLGET    __ProtoGlarp__(( int *index, int *type, int *cell ));
PREFIX	FXSURFACE    __ProtoGlarp__(( int *nsurf, int *scel,  int *surf  ));
PREFIX	FXSURFACEPTR __ProtoGlarp__(( int *nsurf, int **scel, int **surf ));
PREFIX	FXGRID       __ProtoGlarp__(( float *xyz,  float *hxyz ));
PREFIX	FXGRIDPTR    __ProtoGlarp__(( float **xyz, float *hxyz ));
PREFIX	FXGRIDP3D    __ProtoGlarp__(( float **x,   float **y, float **z, 
                                      float *hxyz ));
PREFIX	FXBLANK      __ProtoGlarp__(( int *iblank ));
PREFIX	FXBLANKPTR   __ProtoGlarp__(( int **iblank ));
PREFIX	FXVEL        __ProtoGlarp__(( float *v,   float *hv ));
PREFIX	FXVELPTR     __ProtoGlarp__(( float **v,  float *hv ));
PREFIX	FXVELP3D     __ProtoGlarp__(( float **vx, float **vy, float **vz,
                                      float *hv ));
PREFIX	FXSCAL       __ProtoGlarp__(( int *type, float *s, float *hs ));
PREFIX	FXSTRUC      __ProtoGlarp__(( int *knode,  int *nhalo,
                                       int *ntets,  int *npyra,   int *nprism,
                                       int *nhexa,  int *nblocks, int *blocks,
                                       int *nhcell, int *nsurf,   int *nbc ));
PREFIX	FXMODIFYRT   __ProtoGlarp__(( float *rt, float *drt ));

#ifdef __cplusplus
}
#endif

#endif  /*_FX_H_*/
