/*
 * FX_Utils.c
 *
 * General FX modules.
 *
 * Copyright 1999 - 2000, Massachusetts Institute of Technology.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>


#ifdef WIN32

#define PREFIX __stdcall

#else

#define PREFIX

#ifdef UNDERSCORE

#define FX_MALLOC  fx_malloc_
#define FX_REALLOC fx_realloc_
#define FX_FREE    fx_free_
#define FX_SIZES   fx_sizes_

#else

#define FX_MALLOC  fx_malloc
#define FX_REALLOC fx_realloc
#define FX_FREE    fx_free
#define FX_SIZES   fx_sizes

#endif
#endif



void PREFIX
FX_MALLOC (int *nbytes, void **addr)
{
  *addr = (void *) malloc(*nbytes);
}


void PREFIX
FX_REALLOC (void **addr, int *nbytes, void **naddr)
{
  *naddr = (void *) realloc(*addr, *nbytes);
}


void PREFIX
FX_FREE (void **addr)
{
  free(*addr);
}


void PREFIX
FX_SIZES (int *ints, int *mints, int *ptrs)
{
  typedef struct {
    int *fill;
  } pointer;

  *ints  = sizeof(int);
  *mints = *ints;
  if (*ints != sizeof(float)) {
    fprintf(stderr, "Internal Error. INTEGER/REAL size mismatch!\n");
    exit(1);
  }
  *ptrs = sizeof(pointer);
}
