  /* defines for Vortex Core Algorithms */

#define VCFHUNK 3000
#define VCFSEG   100
#define NOTFILLED -1

  /* adjust this parameter to specify the minumum core length */

#define MINFACE    4


  /* structures for Vortex Core Algorithms */

typedef struct {
  int   node2;          /* 2nd node number for face */
  int   node3;          /* 3rd node number for face */
  float xyz[3];         /* the position in the face for the hit */
  float vort;		/* the vorticity magnitude */
  int   itet[4];        /* cell/tet numbers for neighbors */
  short face[4];        /* face index for the cells */
  int   thread;         /* thread to next face with 1st node number */
} faces;


typedef struct {
  int cell;             /* cell number for tet */
  int tet;              /* tet index in the cell */
  int nface;            /* number of faces */
  int face[4];          /* face indices for the line(s) */
} tets;


typedef struct {
  int order;            /* segment order */
  int start;            /* -2 face terminate, -1 no term, itet terminate */
  int finish;           /* same */
  int nface;            /* number of faces */
  int mface;            /* number of allocated faces */
  int *faces;           /* list of faces */
} segs;


typedef struct {
  int   mfaces;
  int   nfaces;
  faces *table;
  int   *nodes;
  int   mtets;
  int   ntets;
  tets  *tets;
  int   msegs;
  int   nsegs;
  segs  *segs;
} vcf;

