#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#if defined (WIN32) || defined (ABSOFT)
#include <WINSOCK.H>
#include <direct.h>
#else
#include <unistd.h>
#endif
#include "pvm3.h"

#ifdef ABSOFT
#undef WIN32
#endif


/*
  PVM interface for pV3 clients
      pV3 Revision 2.10 beta

  Copyright 1993 - 2003, Massachusetts Institute of Technology.

*/


#ifdef CRAY
#define pV_SERVER      PV_SERVER
#define pV_NETCONTROL  PV_NETCONTROL
#define pV_SETCID      PV_SETCID
#define pV_SERVERSTAT  PV_SERVERSTAT
#define pV_SETCSERVER  PV_SETCSERVER
#define pV_SETMATCH    PV_SETMATCH
#define pV_SENDINIT    PV_SENDINIT
#define pV_SENDMES     PV_SENDMES
#define pV_SENDXI      PV_SENDXI
#define pV_SENDXR      PV_SENDXR
#define pV_SENDXV      PV_SENDXV
#define pV_SENDSLXI    PV_SENDSLXI
#define pV_SENDSLXR    PV_SENDSLXR
#define pV_SENDSV      PV_SENDSV
#define pV_SENDTIME    PV_SENDTIME
#define pV_SENDSTRING  PV_SENDSTRING
#define pV_SENDXFER    PV_SENDXFER
#define pV_SENDXFERACK PV_SENDXFERACK
#define pV_GETSERDATA  PV_GETSERVERDATA
#define pV_GETREQUEST  PV_GETREQUEST
#define pV_GETTREQUEST PV_GETTREQUEST

#define pVSTATE        PVSTATE
#define pVPSTATE       PVPSTATE
#define pV_CELL2NODES  PV_CELL2NODES
#define pV_FILLVCLOUD  PV_FILLVCLOUD
#endif

#ifdef WIN32
#define pV_SERVER      __stdcall PV_SERVER
#define pV_NETCONTROL  __stdcall PV_NETCONTROL
#define pV_SETCID      __stdcall PV_SETCID
#define pV_SERVERSTAT  __stdcall PV_SERVERSTAT
#define pV_SETCSERVER  __stdcall PV_SETCSERVER
#define pV_SETMATCH    __stdcall PV_SETMATCH
#define pV_SENDINIT    __stdcall PV_SENDINIT
#define pV_SENDMES     __stdcall PV_SENDMES
#define pV_SENDXI      __stdcall PV_SENDXI
#define pV_SENDXR      __stdcall PV_SENDXR
#define pV_SENDXV      __stdcall PV_SENDXV
#define pV_SENDSLXI    __stdcall PV_SENDSLXI
#define pV_SENDSLXR    __stdcall PV_SENDSLXR
#define pV_SENDSV      __stdcall PV_SENDSV
#define pV_SENDTIME    __stdcall PV_SENDTIME
#define pV_SENDSTRING  __stdcall PV_SENDSTRING
#define pV_SENDXFER    __stdcall PV_SENDXFER
#define pV_SENDXFERACK __stdcall PV_SENDXFERACK
#define pV_GETSERDATA  __stdcall PV_GETSERVERDATA
#define pV_GETREQUEST  __stdcall PV_GETREQUEST
#define pV_GETTREQUEST __stdcall PV_GETTREQUEST

#define pVSTATE        PVSTATE
#define pVPSTATE       PVPSTATE
#define pV_CELL2NODES  PV_CELL2NODES
#define pV_FILLVCLOUD  PV_FILLVCLOUD
#endif

#ifdef ABSOFT
#define pV_SERVER      __cdecl pv_server
#define pV_NETCONTROL  __cdecl pv_netcontrol
#define pV_SETCID      __cdecl pv_setcid
#define pV_SERVERSTAT  __cdecl pv_serverstat
#define pV_SETCSERVER  __cdecl pv_setcserver
#define pV_SETMATCH    __cdecl pv_setmatch
#define pV_SENDINIT    __cdecl pv_sendinit
#define pV_SENDMES     __cdecl pv_sendmes
#define pV_SENDXI      __cdecl pv_sendxi
#define pV_SENDXR      __cdecl pv_sendxr
#define pV_SENDXV      __cdecl pv_sendxv
#define pV_SENDSLXI    __cdecl pv_sendslxi
#define pV_SENDSLXR    __cdecl pv_sendslxr
#define pV_SENDSV      __cdecl pv_sendsv
#define pV_SENDTIME    __cdecl pv_sendtime
#define pV_SENDSTRING  __cdecl pv_sendstring
#define pV_SENDXFER    __cdecl pv_sendxfer
#define pV_SENDXFERACK __cdecl pv_sendxferack
#define pV_GETSERDATA  __cdecl pv_getserverdata
#define pV_GETREQUEST  __cdecl pv_getrequest
#define pV_GETTREQUEST __cdecl pv_gettrequest

#define pVSTATE        pvstate
#define pVPSTATE       pvpstate
#define pV_CELL2NODES  pv_cell2nodes
#define pV_FILLVCLOUD  pv_fillvcloud
#endif

#ifdef UNDERSCORE
#define pV_SERVER      pv_server_
#define pV_NETCONTROL  pv_netcontrol_
#define pV_SETCID      pv_setcid_
#define pV_SERVERSTAT  pv_serverstat_
#define pV_SETCSERVER  pv_setcserver_
#define pV_SETMATCH    pv_setmatch_
#define pV_SENDINIT    pv_sendinit_
#define pV_SENDMES     pv_sendmes_
#define pV_SENDXI      pv_sendxi_
#define pV_SENDXR      pv_sendxr_
#define pV_SENDXV      pv_sendxv_
#define pV_SENDSLXI    pv_sendslxi_
#define pV_SENDSLXR    pv_sendslxr_
#define pV_SENDSV      pv_sendsv_
#define pV_SENDTIME    pv_sendtime_
#define pV_SENDSTRING  pv_sendstring_
#define pV_SENDXFER    pv_sendxfer_
#define pV_SENDXFERACK pv_sendxferack_
#define pV_GETSERDATA  pv_getserverdata_
#define pV_GETREQUEST  pv_getrequest_
#define pV_GETTREQUEST pv_gettrequest_

#define pVSTATE        pvstate_
#define pVPSTATE       pvpstate_
#define pV_CELL2NODES  pv_cell2nodes_
#define pV_FILLVCLOUD  pv_fillvcloud_
#endif

#ifdef NOUNDERSCORE
#define pV_SERVER      pv_server
#define pV_NETCONTROL  pv_netcontrol
#define pV_SETCID      pv_setcid
#define pV_SERVERSTAT  pv_serverstat
#define pV_SETCSERVER  pv_setcserver
#define pV_SETMATCH    pv_setmatch
#define pV_SENDINIT    pv_sendinit
#define pV_SENDMES     pv_sendmes
#define pV_SENDXI      pv_sendxi
#define pV_SENDXR      pv_sendxr
#define pV_SENDXV      pv_sendxv
#define pV_SENDSLXI    pv_sendslxi
#define pV_SENDSLXR    pv_sendslxr
#define pV_SENDSV      pv_sendsv
#define pV_SENDTIME    pv_sendtime
#define pV_SENDSTRING  pv_sendstring
#define pV_SENDXFER    pv_sendxfer
#define pV_SENDXFERACK pv_sendxferack
#define pV_GETSERDATA  pv_getserverdata
#define pV_GETREQUEST  pv_getrequest
#define pV_GETTREQUEST pv_gettrequest

#define pVSTATE        pvstate
#define pVPSTATE       pvpstate
#define pV_CELL2NODES  pv_cell2nodes
#define pV_FILLVCLOUD  pv_fillvcloud
#endif


#ifdef INTEGERLONG
#define INT long
#else
#define INT int
#define pvm_pkINT pvm_pkint
#define pvm_upkINT pvm_upkint
#endif


#ifdef FLOATDOUBLE
#define FLOAT double
#else
#define FLOAT float
#define pvm_pkFLOAT pvm_pkfloat
#define pvm_upkFLOAT pvm_upkfloat
#endif


#define MAXLEN 262144		/* Maximum buffer size in words */
#define MAXSER      8		/* Maximum number of servers */
#define MAXSERINS 100		/* number of server instances to check */

#define HIPRIO  26729		/* High priority message tag */
#define LOPRIO  27759		/* Low priority message tag */
#define INPRIO  26990		/* Init message tag */


typedef struct {
  int tid;			/* server task ID */
  int kvpa;			/* index for vector fields (particles) */
  int status;			/* 0-exist, 1-startup, 2-running, 3-eof,
				   4-close-up, 5-dead (but not gone) */
} Server;

typedef struct ServerData {
  int   handle;			/* handle index */
  int   mid;			/* message id */
  int   nint;			/* number of ints */
  INT   *ints;			/* pointer to ints */
  int   nfloat;			/* number of floats */
  FLOAT *floats;		/* pointer to floats */
  int   nchar;			/* number of chars */
  char  *chars;			/* pointer to chars */
  struct ServerData *next;	/* pointer to next set of server data */
} ServerData;


/* used by these files */

  static int    pv3_ctid,  pv3_did,   pv3_id,    pv3_nser,  pv3_inmatch = 1;
  static int    pv3_sindx, pv3_stid,  pv3_wstid, pv3_lstid, pv3_lrtid,   pv3_lrindx;
  static int    pv3_lrbuf, pv3_srbuf, pv3_lwbuf, pv3_swbuf, pv3_wrdcnt;
  static int    (*pv3_omatch)(), pv3_sdh = 0;
#ifndef PVM33
  static int    pv3_ctx,   pv3_actx;
#endif
  static char   *pv3_SGroup,          *pv3_CGroup;
  static Server pv3_ser[MAXSER];
  static ServerData *pv3_sd = NULL;


#ifndef NO_PROTO
#ifdef WIN32
extern void __stdcall pVSTATE ( INT *rank, INT *kn, FLOAT *sv );
extern void __stdcall pVPSTATE ( INT *rank, INT *index, INT *kn, FLOAT *sv );
extern void __stdcall pV_CELL2NODES ( INT *kcr, INT *ktet, INT *n, INT *kn );
extern void __stdcall pV_FILLVCLOUD ( INT *isub, INT *rank, FLOAT *cut,
                                      FLOAT *work, INT *kn, FLOAT *out );
static void sleep(int secs)
{
	Sleep(1000*secs);
}
#else
#ifdef ABSOFT
extern void __cdecl pVSTATE ( INT *rank, INT *kn, FLOAT *sv );
extern void __cdecl pVPSTATE ( INT *rank, INT *index, INT *kn, FLOAT *sv );
extern void __cdecl pV_CELL2NODES ( INT *kcr, INT *ktet, INT *n, INT *kn );
extern void __cdecl pV_FILLVCLOUD ( INT *isub, INT *rank, FLOAT *cut,
                                    FLOAT *work, INT *kn, FLOAT *out );
static void sleep(int secs)
{
        Sleep(1000*secs);
}
#else
extern void pVSTATE ( INT *rank, INT *kn, FLOAT *sv );
extern void pVPSTATE ( INT *rank, INT *index, INT *kn, FLOAT *sv );
extern void pV_CELL2NODES ( INT *kcr, INT *ktet, INT *n, INT *kn );
extern void pV_FILLVCLOUD ( INT *isub, INT *rank, FLOAT *cut,
                            FLOAT *work, INT *kn, FLOAT *out );
#endif
#endif
#endif


/* recv comparison function - get all hi prio messages first */

static int
pv_Match(int bid, int tid, int mid)
{
  int t, m, cc, len, hit, i;

  if ((cc = pvm_bufinfo(bid, &len, &m, &t)) < 0) return cc;

  if (tid == -1) {
    hit = 0;
    for (i = 0; i < pv3_nser; i++) if (t == pv3_ser[i].tid) hit++;
    if (hit == 0) return 0;
  } else {
    if (tid != t) return 0;
  }

  if (mid == -1) {
    if ((m == HIPRIO) && (t == pv3_stid)) return 1;
    if  (m == HIPRIO) return 4;
    if ((m == LOPRIO) && (t == pv3_stid)) return 3;
    if  (m == LOPRIO) return 2;
  } else {
    if ((m == mid) && (t == pv3_stid)) return 1;
    if  (m == mid) return 2;
  }

  return 0;
}


/* sets the appropriate write buffer or flushes both */

static void
pv_MesBuffer(int prio)
{
  int mid, stat;

  if (prio == 2) {
    if ((pv3_swbuf == 2) && (pv3_wstid == pv3_stid)) return;
    if  (pv3_swbuf == 2) {
      mid = -1;
      pvm_pkint(&mid, 1, 1);
      stat = pvm_send(pv3_wstid, HIPRIO);
      if (stat != 0) printf(" pV3 Warning: Send Status-> %d to %X\n",
                            stat, pv3_wstid);
    }
    if  (pv3_swbuf == 1) {
      pv3_lwbuf = pvm_setsbuf(0);
      pv3_lstid = pv3_wstid;
    }
    pvm_initsend(PvmDataDefault);
    pvm_pkbyte("pV3#", 4, 1);
    pv3_swbuf = 2;
    pv3_wstid = pv3_stid;
  }

  if (prio == 1) {
    if (pv3_swbuf == 2) {
      mid = -1;
      pvm_pkint(&mid, 1, 1);
      stat = pvm_send(pv3_wstid, HIPRIO);
      if (stat != 0) printf(" pV3 Warning: Send Status-> %d to %X\n",
                            stat, pv3_wstid);
      if (pv3_lwbuf != 0)  {
        pvm_freebuf(pvm_setsbuf(pv3_lwbuf));
        pv3_lwbuf = 0;
        pv3_swbuf = 1;
        pv3_wstid = pv3_lstid;
      } else {
        pv3_swbuf = 0;
      }
    }
    if (pv3_swbuf == 1)
      if ((pv3_wrdcnt >= MAXLEN) || (pv3_wstid != pv3_stid)) {
        mid = -1;
        pvm_pkint(&mid, 1, 1);
        stat = pvm_send(pv3_wstid, LOPRIO);
        if (stat != 0) printf(" pV3 Warning: Send Status-> %d to %X\n",
                              pv3_wstid, stat);
        pv3_swbuf = 0;
      }
    if (pv3_swbuf == 0) {
      pvm_initsend(PvmDataDefault);
      pvm_pkbyte("pV3#", 4, 1);
      pv3_wrdcnt = 0;
      pv3_swbuf  = 1;
      pv3_wstid  = pv3_stid;
    }
  }

  if (prio == 0) {
    if (pv3_swbuf == 2) {
      mid = -1;
      pvm_pkint(&mid, 1, 1);
      stat = pvm_send(pv3_wstid, HIPRIO);
      if (stat != 0) printf(" pV3 Warning: Send Status-> %d to %X\n",
                            pv3_wstid, stat);
      if (pv3_lwbuf != 0)  {
        pvm_freebuf(pvm_setsbuf(pv3_lwbuf));
        pv3_lwbuf = 0;
        pv3_swbuf = 1;
        pv3_wstid = pv3_lstid;
      } else {
        pv3_swbuf = 0;
      }
    }
    if (pv3_swbuf == 1) {
      mid = -1;
      pvm_pkint(&mid, 1, 1);
      stat = pvm_send(pv3_wstid, LOPRIO);
      if (stat != 0) printf(" pV3 Warning: Send Status-> %d to %X\n",
                            pv3_wstid, stat);
      pv3_wrdcnt = 0;
    }
    pv3_swbuf = 0;
    pv3_wstid = 0;
  }

}


/* routines used for long to int message conversion */

#ifdef INTEGERLONG

static void
pvm_pkINT(long *ip, int nitem, int stride)
{
  int i, j;
  long *ptr;

  ptr = ip;
  for (i = 0; i < nitem; i++) {
    j = *ptr;
    pvm_pkint(&j, 1, 1);
    ptr += stride;
  }
}


static void
pvm_upkINT(long *ip, int nitem, int stride)
{
  int i, j;
  long *ptr;

  ptr = ip;
  for (i = 0; i < nitem; i++) {
    pvm_upkint(&j, 1, 1);
    *ptr = j;
    ptr += stride;
  }
}

#endif


/* routines used for double to float message conversion */

#ifdef FLOATDOUBLE

static void
pvm_pkFLOAT(double *ip, int nitem, int stride)
{
  int    i;
  float  j;
  double *ptr;

  ptr = ip;
  for (i = 0; i < nitem; i++) {
    j = *ptr;
    pvm_pkfloat(&j, 1, 1);
    ptr += stride;
  }
}


static void
pvm_upkFLOAT(double *ip, int nitem, int stride)
{
  int    i;
  float  j;
  double *ptr;

  ptr = ip;
  for (i = 0; i < nitem; i++) {
    pvm_upkfloat(&j, 1, 1);
    *ptr = j;
    ptr += stride;
  }
}

#endif


/* first check for server */

void
pV_SERVER (INT *type)
{
  int i, j, hit, gsize, tid, ins;

  /* clean up old server task info */
  if (pv3_nser > 0) {
    if (pvm_gsize(pv3_SGroup) > 0) {
      for (i = 0; i < pv3_nser; i++) 
        if (pvm_pstat(pv3_ser[i].tid) >= 0) {
          pv3_ser[i].status = 4;
        } else {
          pv3_ser[i].status = 5;
        }
      gsize = pv3_nser;
      pv3_nser = 0;
      for (i = 0; i < gsize; i++) 
        if (pv3_ser[i].status == 4) {
          pv3_ser[pv3_nser].tid    = pv3_ser[i].tid;
          pv3_ser[pv3_nser].kvpa   = 0;
          pv3_ser[pv3_nser].status = 4;
          pv3_nser++;
        }
    } else {
      pv3_nser = 0;
    }
  }

  pv3_stid =  0;
  pv3_did  = -1;
  if (*type == 0) {

    /* init and wait for startup */
    while (pv3_stid == 0) {
      gsize = pvm_gsize(pv3_SGroup);
      if (gsize > 0)
        ins = -1;
        i   =  0;
        while ((i < gsize) && (ins < MAXSERINS)) {
          ins++;
          tid = pvm_gettid(pv3_SGroup, ins);
          i++;
          if (tid > 0) {
	    hit = 0;
            for (j = 0; j < pv3_nser; j++) if (pv3_ser[j].tid == tid) hit++;
	    if (hit == 0)
              if ((pvm_pstat(tid) >= 0) && (pv3_nser < MAXSER)) {
	        pv3_stid  = tid;
	        pv3_sindx = pv3_nser;
                pv3_ser[pv3_nser].tid    = tid;
                pv3_ser[pv3_nser].kvpa   = 0;
                pv3_ser[pv3_nser].status = 0;
                pv3_nser++;
              }
          }
        }
      if (pv3_stid == 0) sleep(1);
    }

  } else {

    /* init and don't wait for startup */
    gsize = pvm_gsize(pv3_SGroup);
    if (gsize > 0)
      ins = -1;
      i   =  0;
      while ((i < gsize) && (ins < MAXSERINS)) {
        ins++;
        tid = pvm_gettid(pv3_SGroup, ins);
        i++;
        if (tid > 0) {
          hit = 0;
          for (j = 0; j < pv3_nser; j++) if (pv3_ser[j].tid == tid) hit++;
          if (hit == 0)
            if ((pvm_pstat(tid) >= 0) && (pv3_nser < MAXSER)) {
	      pv3_stid  = tid;
	      pv3_sindx = pv3_nser;
              pv3_ser[pv3_nser].tid    = tid;
              pv3_ser[pv3_nser].kvpa   = 0;
              pv3_ser[pv3_nser].status = 0;
              pv3_nser++;
            }
        }
      }
    if (pv3_stid == 0) {
      *type = -1;
      return;
    }
  }

}


/* init/terminate the network system for the client */

void
pV_NETCONTROL (INT *type)
{
  int    stat, i, len;
  char   *env;
#ifndef PVM33
  int    info, buf;
#endif
#if defined (WIN32) || defined (ABSOFT)
  char   buffer[_MAX_PATH], cdok;
#endif
  static char Server[7] = "Server";
  static char Client[7] = "Client";

  pv3_lrbuf  =  0;
  pv3_srbuf  =  0;
  pv3_lrtid  =  0;
  pv3_lwbuf  =  0;
  pv3_lstid  =  0;
  pv3_swbuf  =  0;
  pv3_wstid  =  0;
  pv3_wrdcnt =  0;
  pv3_did    = -1;

  if (*type == 0) {

    pv3_nser = 0;

#if defined (WIN32) || defined (ABSOFT)
     /* Get the current working directory: */
    cdok = 0;
    if(_getcwd(buffer,_MAX_PATH ) == NULL) cdok = 1;
#endif

    /* set group names */
    env = getenv("pV3_Group");
    if (env == NULL) {
      env = "pV3";
    } else {
      printf("\n pV3 Information: using group prefix = %s\n", env);
    }
    len = strlen(env);
    pv3_CGroup = malloc(len + 7);
    pv3_SGroup = malloc(len + 7);
    for (i = 0; i < len; i++) {
      pv3_CGroup[i] = env[i];
      pv3_SGroup[i] = env[i];
    }
    for (i = 0; i < 7; i++) pv3_CGroup[i+len] = Client[i];
    for (i = 0; i < 7; i++) pv3_SGroup[i+len] = Server[i];

    pv3_ctid = pvm_mytid();
    if (pv3_ctid < 0) {
      printf(" pV3 Error: pvmd Not running!\n");
      *type = -2;
      return;
    }

#ifndef PVM33
    /* set/get context */

    pv3_ctx = pvm_newcontext();
    pvm_initsend(PvmDataDefault);
    pvm_pkint(&pv3_ctx, 1, 1);
    info = pvm_putinfo("pV3context", pvm_getsbuf(), PvmMboxPersistent);
    if (info < 0) {
      pvm_freecontext(pv3_ctx);
      pv3_ctx = -1;
    }
    if ((info == PvmExists) || (info == PvmDenied)) {
      /* must be registered already -- get context */
      buf = pvm_recvinfo("pV3context", 0, PvmMboxFirstAvail);
      if (buf >= 0) {
        pvm_setrbuf(buf);
        pvm_upkint(&pv3_ctx, 1, 1);
      }
    }
    if (pv3_ctx == -1) {
      printf("pV3 Error: Can not get Context!\n");
      *type = -2;
      return;
    }
#endif

    stat = 0;
    if (pvm_getinst(pv3_CGroup, pv3_ctid) < 0)
      stat = pvm_joingroup(pv3_CGroup);
    if (stat < 0) {
      *type = -1;
    } else {
      *type = MAXSER;
    }
#if defined (WIN32) || defined (ABSOFT)
    if (cdok == 0) _chdir(buffer);
#endif
    
  } else {

    if (pv3_inmatch == 0) {
      pvm_recvf(pv3_omatch);
#ifndef PVM33
      pvm_setcontext(pv3_actx);
#endif
    }
    if(*type == 1) {
      pvm_lvgroup(pv3_CGroup);
      pvm_exit();
    }
  }
  pv3_inmatch = 1;
}


/* set client id */

void
pV_SETCID (INT *cid)
{
  pv3_id = *cid;
}


/* return server data */

void
pV_SERVERSTAT (INT *indx, INT *nser, INT *stid, INT *kvpa, INT *stat)
{

  *nser = pv3_nser;
  if (pv3_nser == 0) {
    *indx = 0;
    *stid = 0;
    *kvpa = 0;
    *stat = 0;
  } else {
    *indx = pv3_sindx + 1;
    *stid = pv3_ser[pv3_sindx].tid;
    *kvpa = pv3_ser[pv3_sindx].kvpa;
    *stat = pv3_ser[pv3_sindx].status;
  }
}


/* set server information */

void
pV_SETCSERVER (INT *indx, INT *kvpa, INT *stat)
{
  int i, j, tid, hit, ins, gsize;

  /* indx = -2 -- get new servers */
  if (*indx == -2) {
    gsize = pvm_gsize(pv3_SGroup);
    ins   = -1;
    i     =  0;
    while ((i < gsize) && (ins < MAXSERINS)) {
      ins++;
      tid = pvm_gettid(pv3_SGroup, ins);
      if (tid == PvmNoInst) continue;
      i++;
      if (tid > 0) {
        hit = 0;
        for (j = 0; j < pv3_nser; j++) if (pv3_ser[j].tid == tid) hit++;
        if (hit == 0)
          if ((pvm_pstat(tid) >= 0) && (pv3_nser < MAXSER)) {
            pv3_ser[pv3_nser].tid    = tid;
            pv3_ser[pv3_nser].kvpa   = 0;
            pv3_ser[pv3_nser].status = 0;
            pv3_nser++;
          }
      }
    }
    return;
  }

  /* indx = -1 -- clear up terminated servers */
  if (*indx == -1) {
    for (i = 0; i < pv3_nser; i++) 
      if (pv3_ser[i].status == 4)
        if (pvm_pstat(pv3_ser[i].tid) < 0) pv3_ser[i].status = 5;
    j = pv3_nser;
    pv3_nser = 0;
    for (i = 0; i < j; i++)
      if (pv3_ser[i].status != 5) {
        pv3_ser[pv3_nser].tid    = pv3_ser[i].tid;
        pv3_ser[pv3_nser].kvpa   = pv3_ser[i].kvpa;
        pv3_ser[pv3_nser].status = pv3_ser[i].status;
        pv3_nser++;
      }
    if ((pv3_nser == 0) && (*stat == -1))
      printf(" pV3 Warning: No servers after cleanup!\n");

    gsize = pvm_gsize(pv3_SGroup);
    ins   = -1;
    i     =  0;
    while ((i < gsize) && (ins < MAXSERINS)) {
      ins++;
      tid = pvm_gettid(pv3_SGroup, ins);
      if (tid == PvmNoInst) continue;
      i++;
      if (tid > 0) {
        hit = 0;
        for (j = 0; j < pv3_nser; j++) if (pv3_ser[j].tid == tid) hit++;
        if (hit == 0)
          if ((pvm_pstat(tid) >= 0) && (pv3_nser < MAXSER)) {
            pv3_ser[pv3_nser].tid    = tid;
            pv3_ser[pv3_nser].kvpa   = 0;
            pv3_ser[pv3_nser].status = 0;
            pv3_nser++;
          }
      }
    }

    pv3_sindx = 0;
    pv3_stid  = pv3_ser[pv3_sindx].tid;
    return;
  }

  if ((*indx > 0) && (*indx <= pv3_nser)) {
    pv3_sindx = *indx-1;
    pv3_stid  = pv3_ser[pv3_sindx].tid;
    if (*kvpa != -1) pv3_ser[pv3_sindx].kvpa   = *kvpa;
    if (*stat != -1) pv3_ser[pv3_sindx].status = *stat;
  } else {
    printf(" pV3 Warning: Index out of range (1-%d): %d\n", pv3_nser, *indx);
  }
}


/* change the message matching critera */

void
pV_SETMATCH (INT *type)
{
  int info;

  pv3_inmatch = *type;
  if (*type == 0) {
    pv3_omatch = pvm_recvf(pv_Match);
    if (pv3_omatch == pv_Match) {
      printf(" pV3 Error: Message Critera Sync Error!\n");
      exit(1);
    }
#ifndef PVM33
    pv3_actx = pvm_setcontext(pv3_ctx);
    if ((pv3_actx == pv3_ctx) || (pv3_actx < 0)) {
      printf(" pV3 Error: Context Critera Sync Error %d!\n", pv3_actx);
      exit(1);
    }
#endif
  } else {
    pv_MesBuffer(0);
    if ((pv3_srbuf == 2) && (pv3_lrbuf != 0)) 
      pvm_freebuf(pvm_setrbuf(pv3_lrbuf));
    pv3_srbuf = 0;
    if ((int (*)(int, int, int)) pvm_recvf(pv3_omatch) != pv_Match) {
      printf(" pV3 Error: Message Critera Sync ERROR!\n");
      exit(1);
    }
#ifndef PVM33
    info = pvm_setcontext(pv3_actx);
    if (info != pv3_ctx) {
      printf(" pV3 Error: Context Critera Sync ERROR %d!\n", info);
      exit(1);
    }
#endif
  }
}


/* pack and send init handshake to server */

void
#ifdef T3E
pV_SENDINIT (INT *iopt, INT *npc, char *tc, int tcLEN, INT *mirror,
             FLOAT *repmat, FLOAT *rev, INT *nk, INT *ik, INT *fk,
             FLOAT fl[][2], char *tk, char *tit, int titLEN, char *dtit,
             int dtitLEN, char *ptit, int ptitLEN, FLOAT *xmx, INT *kns,
             INT *ns, char *nt, INT *mblk)
#else
#ifdef WIN32
pV_SENDINIT (INT *iopt, INT *npc, char *tc, int tcLEN, INT *mirror,
             FLOAT *repmat, FLOAT *rev, INT *nk, INT *ik, INT *fk,
             FLOAT fl[][2], char *tk, int tkLEN, char *tit, int titLEN,
             char *dtit, int dtitLEN, char *ptit, int ptitLEN, FLOAT *xmx,
             INT *kns, INT *ns, char *nt, int ntLEN, INT *mblk)
#else
pV_SENDINIT (INT *iopt, INT *npc, char *tc, INT *mirror, FLOAT *repmat,
             FLOAT *rev, INT *nk, INT *ik, INT *fk, FLOAT fl[][2], char *tk,
             char *tit, char *dtit, char *ptit, FLOAT *xmx, INT *kns, INT *ns,
             char *nt, INT *mblk)
#endif
#endif
{
  int stat, ier, i, gsize, l, tid;

  ier = 0;
  gsize = pvm_gsize(pv3_CGroup);
  if (gsize > 0)
    for (i = 0; i < gsize; i++) {
      tid = pvm_gettid(pv3_CGroup,i);
      if (tid > 0) if (pvm_pstat(tid) >= 0) ier++;
    }

  pvm_initsend(PvmDataDefault);
  pvm_pkbyte("pV3#", 4, 1);
  i = 32;
  pvm_pkint(&i, 1, 1);
  pvm_pkint(&pv3_did, 1, 1);
  pvm_pkint(&pv3_id, 1, 1);
  pvm_pkint(&ier, 1, 1);
  pvm_pkINT(kns, 1, 1);
  pvm_pkINT(iopt, 1, 1);

  l = 5 + abs(*nk)*2 + *kns*3;
  pvm_pkint(&l, 1, 1);
  l = 7 + abs(*nk)*2;
  if (*mirror < 0) l += 16;
  pvm_pkint(&l, 1, 1);
  l = 120 + abs(*nk)*32 + *kns*20 + *npc*32;
  pvm_pkint(&l, 1, 1);

  i = 0;                  /* number of clients -- concentrator */
  pvm_pkint(&i, 1, 1);    /* sent only from first init         */
  pvm_pkINT(npc, 1, 1);
  pvm_pkINT(mirror, 1, 1);
  pvm_pkINT(nk, 1, 1);
  for (i = 0; i < abs(*nk); i++) {
    pvm_pkINT(&ik[i], 1, 1);
    pvm_pkINT(&fk[i], 1, 1);
  }
  if (*kns != 0) pvm_pkINT(ns, *kns*3, 1);
  pvm_pkINT(mblk, 1, 1);
  pvm_pkFLOAT(rev, 1, 1);
  pvm_pkFLOAT(xmx, 6, 1);
  for (i = 0; i < abs(*nk); i++)  pvm_pkFLOAT(fl[i], 2, 1);
  if (*mirror < 0) pvm_pkFLOAT(repmat, 16, 1);
  pvm_pkbyte(tit, 80, 1);
  pvm_pkbyte(dtit, 20, 1);
  pvm_pkbyte(ptit, 20, 1);
  for (i = 0; i < abs(*nk); i++) pvm_pkbyte(&tk[i*32], 32, 1);
  if (*kns != 0) pvm_pkbyte(nt, *kns*20, 1);
  if (*npc != 0) pvm_pkbyte(tc, *npc*32, 1);
  i = -1;
  pvm_pkint(&i, 1, 1);
  stat = pvm_send(pv3_stid, INPRIO);
  if (stat != 0) printf(" pV3 Warning: Init Send Status-> %d to %X\n",
                        pv3_stid, stat);
}


/* pack ack type message */

void
pV_SENDMES (INT *id, INT *ints, FLOAT *reals)
{
  int l;

  /* used for mid = 35 & 37 */

  pv_MesBuffer(1);
  pvm_pkint(id, 1, 1);
  pvm_pkint(&pv3_did, 1, 1);
  pvm_pkint(&pv3_id, 1, 1);
  pvm_pkINT(ints, 3, 1);

  l = 0;
  pvm_pkint(&l, 1, 1);
  l = 5;
  pvm_pkint(&l, 1, 1);
  l = 0;
  pvm_pkint(&l, 1, 1);

  pvm_pkFLOAT(reals, 5, 1);
  pv3_wrdcnt += 14;
}


/* pack int extract */

void
pV_SENDXI (INT * id, INT *num, INT *type, INT *nd, INT *len, INT *ints)
{
  int size, i, np, l;

  size = *nd;
  size = *len*size;
  if (size <= 0) return;
  if (MAXLEN-pv3_wrdcnt < 16) pv_MesBuffer(0);

  i = 0;
  while (size > 0) {
    pv_MesBuffer(1);
    np = MAXLEN - pv3_wrdcnt;
    if (np > size) np = size;
    pvm_pkINT(id, 1, 1);
    pvm_pkint(&pv3_did, 1, 1);
    pvm_pkint(&pv3_id, 1, 1);
    pvm_pkINT(type, 1, 1);
    pvm_pkINT(len, 1, 1);
    pvm_pkINT(num, 1, 1);

    l = 2 + np;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkint(&i, 1, 1);
    pvm_pkint(&np, 1, 1);
    pvm_pkINT(&ints[i], np, 1);
    pv3_wrdcnt += np + 11;
    size -= np;
    i += np;
  }
}


/* pack float extract */

void
pV_SENDXR (INT *id, INT *num, INT *type, INT *nd, INT *len, FLOAT *reals)
{
  int size, i, np, l;

  size = *nd;
  size = *len*size;
  if (size <= 0) return;
  if (MAXLEN-pv3_wrdcnt < 16) pv_MesBuffer(0);

  i = 0;
  while (size > 0) {
    pv_MesBuffer(1);
    np = MAXLEN - pv3_wrdcnt;
    if (np > size) np = size;
    pvm_pkINT(id, 1, 1);
    pvm_pkint(&pv3_did, 1, 1);
    pvm_pkint(&pv3_id, 1, 1);
    pvm_pkINT(type, 1, 1);
    pvm_pkINT(len, 1, 1);
    pvm_pkINT(num, 1, 1);

    l = 2;
    pvm_pkint(&l, 1, 1);
    l = np;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkint(&i, 1, 1);
    pvm_pkint(&np, 1, 1);
    pvm_pkFLOAT(&reals[i], np, 1);
    pv3_wrdcnt += np + 11;
    size -= np;
    i += np;
  }
}


/* pack vector cloud extracts */

void
pV_SENDXV (INT *type, INT *nd, FLOAT *reals, FLOAT *out, FLOAT *t, INT *n)
{
  int i, np, mid, num, j, it, remain, l;

  mid = 20;
  num = *n;
  remain = *nd*num;
  if (remain <= 0) return;
  if (MAXLEN-pv3_wrdcnt-*nd < 16) pv_MesBuffer(0);

  it = 0;
  i  = 0;
  while (remain > 0) {
    pv_MesBuffer(1);
    np = MAXLEN - pv3_wrdcnt;
    j = *nd;
    np = np/j;
    np *= j;
    if (np > remain) np = remain;
    j = 0;
    pvm_pkint(&mid, 1, 1);
    pvm_pkint(&pv3_did, 1, 1);
    pvm_pkint(&pv3_id, 1, 1);
    pvm_pkINT(type, 1, 1);
    pvm_pkint(&num, 1, 1);
    pvm_pkint(&j, 1, 1);

    l = 2;
    pvm_pkint(&l, 1, 1);
    l = np;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkint(&i, 1, 1);
    pvm_pkint(&np, 1, 1);
    while (j < np) {
      pV_FILLVCLOUD(type, nd, t, reals, &it, out);
      pvm_pkFLOAT(out, *nd, 1);
      j  += *nd;
    }
    pv3_wrdcnt += np + 11;
    remain -= np;
    i += np;
  }
}


/* pack streamline int extract */

void
pV_SENDSLXI (INT *id, INT *num, INT *type, INT *nd, INT *len, INT *nseg,
             INT *ints)
{
  int size, i, np, l;

  size = *nd;
  size = *len*size;
  if (MAXLEN-pv3_wrdcnt < 16) pv_MesBuffer(0);

  i = 0;
  while (size > 0) {
    pv_MesBuffer(1);
    np = MAXLEN - pv3_wrdcnt;
    if (np > size) np = size;
    pvm_pkINT(id, 1, 1);
    pvm_pkint(&pv3_did, 1, 1);
    pvm_pkint(&pv3_id, 1, 1);
    pvm_pkINT(type, 1, 1);
    pvm_pkINT(len, 1, 1);
    pvm_pkINT(num, 1, 1);

    l = 3 + np;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkINT(nseg, 1, 1);
    pvm_pkint(&i, 1, 1);
    pvm_pkint(&np, 1, 1);
    pvm_pkINT(&ints[i], np, 1);
    pv3_wrdcnt += np + 12;
    size -= np;
    i += np;
  }
}


/* pack streamline float extract */

void
pV_SENDSLXR (INT *id, INT *num, INT *type, INT *nd, INT *len, INT *nseg,
             FLOAT *reals)
{
  int size, i, np, l;

  size = *nd;
  size = *len*size;
  if (MAXLEN-pv3_wrdcnt < 16) pv_MesBuffer(0);

  i = 0;
  while (size > 0) {
    pv_MesBuffer(1);
    np = MAXLEN - pv3_wrdcnt;
    if (np > size) np = size;
    pvm_pkINT(id, 1, 1);
    pvm_pkint(&pv3_did, 1, 1);
    pvm_pkint(&pv3_id, 1, 1);
    pvm_pkINT(type, 1, 1);
    pvm_pkINT(len, 1, 1);
    pvm_pkINT(num, 1, 1);

    l = 3;
    pvm_pkint(&l, 1, 1);
    l = np;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkINT(nseg, 1, 1);
    pvm_pkint(&i, 1, 1);
    pvm_pkint(&np, 1, 1);
    pvm_pkFLOAT(&reals[i], np, 1);
    pv3_wrdcnt += np + 12;
    size -= np;
    i += np;
  }
}


/* pack state-vector extract */

void
pV_SENDSV (INT *id, INT *num, INT *nd, INT *len, INT *index, FLOAT *weight,
           FLOAT *reals, INT *kcellt, INT *jsurf, INT *istream)
{
  int size, i, k, np, type, off, rank, length, i19;
  INT kcr, j, l, m, kn[8], kc;

  length = *len;
  if (*id == 19) {
    length = 0;
    for (k = 0; k < *len; k++) if (index[10*k+7] == pv3_stid) length++;
  }

  rank = *nd;
  size = length*rank;
  if (size <= 0) return;
  type = 12;

  if (MAXLEN-pv3_wrdcnt-rank < 16) pv_MesBuffer(0);

  i19 = 0;
  i   = 0;
  off = 0;

  while (size > 0) {
    pv_MesBuffer(1);
    np = MAXLEN - pv3_wrdcnt;
    np = np/rank;
    np *= rank;
    if (np > size) np = size;
    pvm_pkINT(id, 1, 1);
    pvm_pkint(&pv3_did, 1, 1);
    pvm_pkint(&pv3_id, 1, 1);
    pvm_pkint(&type, 1, 1);
    pvm_pkINT(&length, 1, 1);
    pvm_pkINT(num, 1, 1);

    l = 2;
    if (*id == 18) l++;
    pvm_pkint(&l, 1, 1);
    l = np;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    if (*id == 18) pvm_pkINT(&num[6], 1, 1);
    pvm_pkint(&i, 1, 1);
    pvm_pkint(&np, 1, 1);
    if (*id == 18) {
      /* StreamLines */
      for (k = 0; k < np/rank; k++) {
        kcr = index[k+off];
        if ((*jsurf != 0) && (istream[(k+off)*2+1] == 0)) kcr = -kcr;
        pV_CELL2NODES (&kcr, &istream[(k+off)*2+1], &j, kn);
        for (m = 0; m < j; m++) 
          if (kn[m] > 0) {
            pVSTATE (nd, &kn[m], &reals[*nd*(m+1)]);
          } else {
            l  = -kn[m];
            kc = kcr - *kcellt;
            pVPSTATE (nd, &kc, &l, &reals[*nd*(m+1)]);
          }
        for (l = 0; l < *nd; l++) {
          reals[l] = 0.0;
          for (m = 0; m < j; m++)
            reals[l] += weight[(k+off)*8+m]*reals[*nd*(m+1)+l];
        }
        pvm_pkFLOAT(reals, *nd, 1);
      }
    } else if (*id == 19) {
      /* Bubbles */
      for (k = 0; k < np/rank; k++) {
        while (index[10*i19+7] != pv3_stid) i19++;
        kcr = index[10*i19];
        if ((index[10*i19+2] <= 0) && (index[10*i19+9] == 0)) kcr = -kcr;
        pV_CELL2NODES (&kcr, &index[10*i19+9], &j, kn);
        for (m = 0; m < j; m++)
          if (kn[m] > 0) {
            pVSTATE (nd, &kn[m], &reals[*nd*(m+1)]);
          } else {
            l  = -kn[m];
            kc = kcr - *kcellt;
            pVPSTATE (nd, &kc, &l, &reals[*nd*(m+1)]);
          }
        for (l = 0; l < *nd; l++) {
          reals[l] = 0.0;
          for (m = 0; m < j; m++)
            reals[l] += weight[(k+off)*8+m]*reals[*nd*(m+1)+l];
        }
        pvm_pkFLOAT(reals, *nd, 1);
        i19++;
      }
    } else if (*id == 21) {
      /* Points */
      for (k = 0; k < np/rank; k++) {
        kcr = index[4*i19];
        pV_CELL2NODES (&kcr, &index[4*i19+2], &j, kn);
        for (m = 0; m < j; m++)
          if (kn[m] > 0) {
            pVSTATE (nd, &kn[m], &reals[*nd*(m+1)]);
          } else {
            l  = -kn[m];
            kc = kcr - *kcellt;
            pVPSTATE (nd, &kc, &l, &reals[*nd*(m+1)]);
          }
        for (l = 0; l < *nd; l++) {
          reals[l] = 0.0;
          for (m = 0; m < j; m++)
            reals[l] += weight[11*i19+m]*reals[*nd*(m+1)+l];
        }
        pvm_pkFLOAT(reals, *nd, 1);
        i19++;
      }
    } else {
      /* surfaces */
      j = 2;
      if (*jsurf != 0) j = 1;
      for (k = 0; k < np/rank; k++) {
        if (index[3*(k+off)+2] == 0) {
          pVSTATE (nd, &index[3*(k+off)], reals);
          if (j != 1) {
            pVSTATE (nd, &index[3*(k+off)+1], &reals[*nd]);
            for (l = 0; l < *nd; l++) 
              reals[l] += weight[k+off]*(reals[*nd+l]-reals[l]);
          }
        } else {
          m = index[3*(k+off)];
          if (m > 0) {
	    pVSTATE (nd, &m, reals);
          } else {
            m = -m;
            pVPSTATE (nd, &index[3*(k+off)+2], &m, reals);
          }
          if (j == 2) {
            m = index[3*(k+off)+1];
            if (m > 0) {
	      pVSTATE (nd, &m, &reals[*nd]);
            } else {
              m = -m;
              pVPSTATE (nd, &index[3*(k+off)+2], &m, &reals[*nd]);
            }
            for (l = 0; l < *nd; l++) 
              reals[l] += weight[k+off]*(reals[*nd+l]-reals[l]);
          }
        }
        pvm_pkFLOAT(reals, *nd, 1);
      }
    }
    pv3_wrdcnt += np + 11;
    if (*id == 18) pv3_wrdcnt++;
    size -= np;
    i    += np;
    off  += np/rank;
    if (size > 0) pv3_wrdcnt = MAXLEN;
  }
}


/* pack transfer sl/part */

void
pV_SENDXFER (INT *id, INT *ints, FLOAT *reals)
{
  int l;

  pv_MesBuffer(2);
  pvm_pkINT(id, 1, 1);
  pvm_pkint(&pv3_did, 1, 1);
  pvm_pkint(&pv3_id, 1, 1);
  pvm_pkINT(ints, 3, 1);

  switch (*id) {
  case 16:
    l = 9;
    pvm_pkint(&l, 1, 1);
    l = 30;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkINT(&ints[3], 9, 1);
    pvm_pkFLOAT(reals, 30, 1);
    break;
  case 17:
    l = 4;
    pvm_pkint(&l, 1, 1);
    l = 24;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkINT(&ints[3], 4, 1);
    pvm_pkFLOAT(reals, 24, 1);
    break;
  case 45:
    l = 3;
    pvm_pkint(&l, 1, 1);
    l = 3;
    pvm_pkint(&l, 1, 1);
    l = 0;
    pvm_pkint(&l, 1, 1);

    pvm_pkINT(&ints[3], 3, 1);
    pvm_pkFLOAT(reals, 3, 1);
    break;
  }
}


/* pack time type message */

void
pV_SENDTIME (INT *istat, FLOAT *time, FLOAT *fmm, INT *nk, 
             INT *sizes, INT *blocks, char *str, int strLEN)
{
  int  i, j, l, n;

  n = 3*sizes[7];
  if (MAXLEN-pv3_wrdcnt-2*(*nk+1) < 40+n) pv_MesBuffer(0);
  pv_MesBuffer(1);
  j = 33;
  pvm_pkint(&j, 1, 1);
  pvm_pkint(&pv3_did, 1, 1);
  pvm_pkint(&pv3_id, 1, 1);
  pvm_pkINT(istat, 1, 1);
  j = 0;
  pvm_pkint(&j, 1, 1);
  pvm_pkint(&j, 1, 1);
  j = *nk;

  l = 10 + n;
  pvm_pkint(&l, 1, 1);
  l = 1 + 2*(j+1);
  pvm_pkint(&l, 1, 1);
  l = 80;
  pvm_pkint(&l, 1, 1);

  pvm_pkINT(nk, 1, 1);
  pvm_pkINT(sizes, 9, 1);
  for (i = 0; i < sizes[7]; i++) pvm_pkINT(&blocks[6*i], 3, 1);
  pvm_pkFLOAT(time, 1, 1);
  pvm_pkFLOAT(fmm, 2*(j+1), 1);
  pvm_pkbyte(str, 80, 1);
  pv3_wrdcnt += 40 + 2*(j+1) + n;
}


/* pack string message */

void
pV_SENDSTRING (char *str, int strLEN)
{
  int  i, j, l, indx;

  pv_MesBuffer(1);
  j = 31;
  pvm_pkint(&j, 1, 1);
  pvm_pkint(&pv3_did, 1, 1);
  pvm_pkint(&pv3_id, 1, 1);
  j = 0;
  pvm_pkint(&j, 1, 1);
  pvm_pkint(&j, 1, 1);
  pvm_pkint(&j, 1, 1);

  l = 0;
  pvm_pkint(&l, 1, 1);
  l = 0;
  pvm_pkint(&l, 1, 1);
  l = 80;
  pvm_pkint(&l, 1, 1);

  pvm_pkbyte(str, 80, 1);
  pv3_wrdcnt += 29;

  if (pv3_nser == 1) return;

  indx = pv3_sindx;
  for(i = 0; i < pv3_nser; i++)
    if (indx != i)
      if ((pv3_ser[i].status > 1) && (pv3_ser[i].status < 4)) {
        pv3_sindx = i;
        pv3_stid  = pv3_ser[i].tid;
        pv_MesBuffer(1);
        j = 31;
        pvm_pkint(&j, 1, 1);
        pvm_pkint(&pv3_did, 1, 1);
        pvm_pkint(&pv3_id, 1, 1);
        j = 0;
        pvm_pkint(&j, 1, 1);
        pvm_pkint(&j, 1, 1);
        pvm_pkint(&j, 1, 1);
        l = 0;
        pvm_pkint(&l, 1, 1);
        l = 0;
        pvm_pkint(&l, 1, 1);
        l = 80;
        pvm_pkint(&l, 1, 1);
        pvm_pkbyte(str, 80, 1);
        pv3_wrdcnt += 29;
      }

  pv3_sindx = indx;
  pv3_stid  = pv3_ser[indx].tid;
}


/* pvm send an acknowledgement that a transfered particle/sl has
   been dealt with by this client */

void
pV_SENDXFERACK (INT *mid, INT *ID, INT *IDO)
{
  int  j, l;

  j = 2;
  if (*mid == 44) j = 1;
  pv_MesBuffer(j);

  pvm_pkINT(mid,  1, 1);
  pvm_pkint(&pv3_did, 1, 1);
  pvm_pkint(&pv3_id, 1, 1);
  pvm_pkINT(ID,  1, 1);
  pvm_pkINT(IDO, 1, 1);
  j = 0;
  pvm_pkint(&j, 1, 1);

  l = 0;
  pvm_pkint(&l, 1, 1);
  l = 0;
  pvm_pkint(&l, 1, 1);
  l = 0;
  pvm_pkint(&l, 1, 1);

  if (*mid == 44) pv3_wrdcnt += 9;
}


/* return server data to client */

void
pV_GETSERDATA (INT *handle, INT *mid, INT *nint, INT **ints, INT *nfloat,
               FLOAT **floats, INT *nchar, char **chars)
{
  ServerData *sd, *lsd;

  sd  = pv3_sd;
  lsd = NULL;

  while (sd != NULL) {
    if (sd->handle == *handle) {
      *mid    = sd->mid;
      *nint   = sd->nint;
      *ints   = sd->ints;
      *nfloat = sd->nfloat;
      *floats = sd->floats;
      *nchar  = sd->nchar;
      *chars  = sd->chars;
      if (lsd == NULL) {
        pv3_sd = sd->next;
      } else {
        lsd->next = sd->next;
      }
      free(sd);
      return;
    }
    lsd = sd;
    sd  = sd->next;
  }
  printf(" pV3 Warning: Handle not Found! %d  (pV_GetServerData)\n", *handle);
}


/* get server to client data stream -- mid = 50 only */

static int
pv_readData(int mid)
{
  int        i, nint, nfloat, nchar;
  INT        idum;
  FLOAT      fdum;
  char       cdum;
  ServerData *sd, *lsd;

  pvm_upkint(&nint, 1, 1);
  pvm_upkint(&nfloat, 1, 1);
  pvm_upkint(&nchar, 1, 1);

  lsd = NULL;
  sd  = pv3_sd;
  while (sd != NULL) {
    lsd = sd;
    sd  = sd->next;
  }
  sd = (ServerData *) malloc(sizeof(ServerData));
  if (sd == NULL) {
    for (i = 0; i < nint;   i++) pvm_upkINT(&idum, 1, 1);
    for (i = 0; i < nfloat; i++) pvm_upkFLOAT(&fdum, 1, 1);
    for (i = 0; i < nchar;  i++) pvm_upkbyte(&cdum, 1, 1);
    return -1;
  }
  sd->handle = pv3_sdh;
  sd->mid    = mid;
  sd->nint   = nint;
  sd->ints   = NULL;
  sd->nfloat = nfloat;
  sd->floats = NULL;
  sd->nchar  = nchar;
  sd->chars  = NULL;
  sd->next   = NULL;
  if (lsd == NULL) {
    pv3_sd = sd;
  } else {
    lsd->next = sd;
  }

  if (nint > 0) {
    sd->ints = (INT *) malloc(nint*sizeof(INT));
    if (sd->ints == NULL) {
      sd->nint = 0;
      for (i = 0; i < nint; i++) pvm_upkINT(&idum, 1, 1);
    } else {
      pvm_upkINT(sd->ints, nint, 1);
    }
  }
  if (nfloat > 0) {
    sd->floats = (FLOAT *) malloc(nfloat*sizeof(FLOAT));
    if (sd->floats == NULL) {
      sd->nfloat = 0;
      for (i = 0; i < nfloat; i++) pvm_upkFLOAT(&fdum, 1, 1);
    } else {
      pvm_upkFLOAT(sd->floats, nfloat, 1);
    }
  }
  if (nchar > 0) {
    sd->chars = (char *) malloc(nchar*sizeof(char));
    if (sd->chars == NULL) {
      sd->nchar = 0;
      for (i = 0; i < nchar; i++) pvm_upkbyte(&cdum, 1, 1);
    } else {
      pvm_upkbyte(sd->chars, nchar, 1);
    }
  }
  pv3_sdh++;
  return sd->handle;
}


/* pvm get request */

void
pV_GETREQUEST (INT *mid, INT *is, INT *iv, INT *it, INT *mask, INT *ints,
               FLOAT *reals, char *cstr, int cstrLEN)
{
  int bufid, did, cl, len, i, inum, j, k;
  int nint, nfloat, nchar;

  /* has server exitted? */

  for (i = 0; i < pv3_nser; i++)
    if (pv3_ser[i].status < 4) 
      if (pvm_pstat(pv3_ser[i].tid) < 0) {
        printf(" pV3 Warning: Server %X has exitted!\n", pv3_ser[i].tid);
        *mid = 36;
        *is  = -1;
        *iv  =  i+1;
        *it  =  pv3_ser[i].tid;
        if ((pv3_srbuf == 2) && (pv3_stid == pv3_ser[i].tid)) 
          if (pv3_lrbuf == 0) {
            pv3_srbuf = 0;
          } else {
            pvm_freebuf(pvm_setrbuf(pv3_lrbuf));
            pv3_srbuf = 1;
            pv3_stid  = pv3_lrtid;
            pv3_sindx = pv3_lrindx;
          }
        if ((pv3_srbuf == 1) && (pv3_stid == pv3_ser[i].tid)) pv3_srbuf = 0;
        return;
      }

  /* in high prio read buffer */

  if (pv3_srbuf == 2) {
    *mid = -1;
    pvm_upkint(mid, 1, 1);
    if (*mid == -1) {
      if (pv3_lrbuf == 0) {
        pv3_srbuf = 0;
      } else {
        pvm_freebuf(pvm_setrbuf(pv3_lrbuf));
        pv3_srbuf = 1;
        pv3_stid  = pv3_lrtid;
        pv3_sindx = pv3_lrindx;
      }
    }
  }

  /* in low prio read buffer */

  if (pv3_srbuf == 1) {
    if (pvm_probe(-1, HIPRIO) > 0) {
      i = pvm_setrbuf(0);
      if (i != pv3_lrbuf) {
        printf(" pV3 Buffer ERROR: %d, %d\n", i, pv3_lrbuf);
        pv3_lrbuf = 0;
      }
      *mid = -1;
      bufid = pvm_recv(-1, HIPRIO);
      pvm_bufinfo(bufid, &len, &i, &inum);
      k = 0;
      for (j = 0; j < pv3_nser; j++)
        if (inum == pv3_ser[j].tid) {
          pv3_stid  = inum;
          pv3_sindx = j;
          k++;
        }
      if (k == 0) {
        printf(" pV3 Warning: Server not found (%X)!\n", inum);
      } else {
        pv3_srbuf = 2;
        pvm_upkint(mid, 1, 1);
      }
    }
    if (pv3_srbuf != 2) {
      *mid = -1;
      pvm_upkint(mid, 1, 1);
      if (*mid == -1) pv3_srbuf = 0;
    }
  }

  /* no current read buffer */

  if (pv3_srbuf == 0) {
    *mid = -1;
    bufid = pvm_nrecv(-1, -1);
    if (bufid <= 0) {
      pv_MesBuffer(0);
      bufid = pvm_nrecv(-1, -1);
    }
    if (bufid <= 0) return;
    pvm_bufinfo(bufid, &len, &i, &inum);

    len = 0;
    for (j = 0; j < pv3_nser; j++)
      if (inum == pv3_ser[j].tid) {
        pv3_stid  = inum;
        pv3_sindx = j;
        len++;
      }
    if (len == 0) printf(" pV3 Warning: Server not found (%X)!\n", inum);
    if (i == LOPRIO) {
      pv3_srbuf  = 1;
      pv3_lrbuf  = bufid;
      pv3_lrtid  = pv3_stid;
      pv3_lrindx = pv3_sindx;
    } else {
      pv3_srbuf  = 2;
      pv3_lrbuf  = 0;
    }
    pvm_upkint(mid, 1, 1);
  }

  /* get next concatinated message */

  nint   = 0;
  nfloat = 0;
  nchar  = 0;
  pvm_upkint(&did, 1, 1);
  pvm_upkint(&cl, 1, 1);
  pvm_upkINT(is, 1, 1);
  pvm_upkINT(iv, 1, 1);
  pvm_upkINT(it, 1, 1);
  pvm_upkINT(mask, 1, 1);
  if (*mid != 50) {
    pvm_upkint(&nint, 1, 1);
    pvm_upkint(&nfloat, 1, 1);
    pvm_upkint(&nchar, 1, 1);
    if (nint   != 0) pvm_upkINT(ints, nint, 1);
    if (nfloat != 0) pvm_upkFLOAT(reals, nfloat, 1);
    if (nchar  != 0) pvm_upkbyte(cstr, nchar, 1);
  } else {
    *is = pv_readData(*mask);
  }

  /* note: global iopt in *is (mid = 35) */
  if ((*mid == 35) && (pv3_did == -1)) pv3_did = *iv;

  if (pv3_did != did) printf(" pV3 Warning: Discipline MisMatch! %d %d %d\n",
                             pv3_did, did, *mid);
  if (pv3_id != cl) printf(" pV3 Warning: Client ID MisMatch! %d %d %d\n",
                           pv3_id, cl, *mid);
}


/* pvm blocked get request (with timeout) */

void
pV_GETTREQUEST (INT *mid, INT *is, INT *iv, INT *it, INT *mask, INT *to, 
                INT *ints, FLOAT *reals, char *cstr, int cstrLEN)
{
  int bufid, len, inum, i, did, cl, j, k;
  int nint, nfloat, nchar;
  struct timeval tmout;

  /* has server exitted? */

  for (i = 0; i < pv3_nser; i++)
    if (pv3_ser[i].status < 4)
      if (pvm_pstat(pv3_ser[i].tid) < 0) {
        printf(" pV3 Warning: Server %X has exitted!\n", pv3_ser[i].tid);
        *mid = 36;
        *is  = -1;
        *iv  =  i+1;
        *it  =  pv3_ser[i].tid;
        if ((pv3_srbuf == 2) && (pv3_stid == pv3_ser[i].tid))
          if (pv3_lrbuf == 0) {
            pv3_srbuf = 0;
          } else {
            pvm_freebuf(pvm_setrbuf(pv3_lrbuf));
            pv3_srbuf = 1;
            pv3_stid  = pv3_lrtid;
            pv3_sindx = pv3_lrindx;
          }
        if ((pv3_srbuf == 1) && (pv3_stid == pv3_ser[i].tid)) pv3_srbuf = 0;
        return;
      }

  /* in high prio read buffer */

  if (pv3_srbuf == 2) {
    *mid = -1;
    pvm_upkint(mid, 1, 1);
    if (*mid == -1) {
      if (pv3_lrbuf == 0) {
        pv3_srbuf = 0;
      } else {
        pvm_freebuf(pvm_setrbuf(pv3_lrbuf));
        pv3_srbuf = 1;
        pv3_stid  = pv3_lrtid;
        pv3_sindx = pv3_lrindx;
      }
    }
  }

  /* in low prio read buffer */

  if (pv3_srbuf == 1) {
    if (pvm_probe(-1, HIPRIO) > 0) {
      i = pvm_setrbuf(0);
      if (i != pv3_lrbuf) {
        printf(" pV3 Buffer ERROR: %d, %d\n", i, pv3_lrbuf);
        pv3_lrbuf = 0;
      }
      *mid = -1;
      bufid = pvm_recv(-1, HIPRIO);
      pvm_bufinfo(bufid, &len, &i, &inum);
      k = 0;
      for (j = 0; j < pv3_nser; j++)
        if (inum == pv3_ser[j].tid) {
          pv3_stid  = inum;
          pv3_sindx = j;
          k++;
        }
      if (k == 0) {
        printf(" pV3 Warning: Server not found (%X)!\n", inum);
      } else {
        pv3_srbuf = 2;
        pvm_upkint(mid, 1, 1);
      }
    }
    if (pv3_srbuf != 2) {
      *mid = -1;
      pvm_upkint(mid, 1, 1);
      if (*mid == -1) pv3_srbuf = 0;
    }
  }

  /* no current read buffer */

  if (pv3_srbuf == 0) {
    if (pvm_probe(-1, -1) <= 0) pv_MesBuffer(0);
    tmout.tv_sec  = *to;
    tmout.tv_usec = 0;
    bufid = pvm_trecv(-1, -1, &tmout);
    if (bufid < 0) {
      printf(" pV3 Warning: A server has Timed-Out!\n");
      *mid = 36;
      *is  = -1;
      *iv  =  0;
      *it  =  0;
      return;
    }

    /* some bizarre error - why am I getting bufids == 0? */
    *mid = -1;
    if (bufid == 0) return;
    pvm_bufinfo(bufid, &len, &i, &inum);

    len = 0;
    for (j = 0; j < pv3_nser; j++)
      if (inum == pv3_ser[j].tid) {
        pv3_stid  = inum;
        pv3_sindx = j;
        len++;
      }
    if (len == 0) printf(" pV3 Warning: Server not found (%X)!\n", inum);
    if (i == LOPRIO) {
      pv3_srbuf  = 1;
      pv3_lrbuf  = bufid;
      pv3_lrtid  = pv3_stid;
      pv3_lrindx = pv3_sindx;
    } else {
      pv3_srbuf  = 2;
      pv3_lrbuf  = 0;
    }
    pvm_upkint(mid, 1, 1);
  }

  /* get next concatinated message */

  nint   = 0;
  nfloat = 0;
  nchar  = 0;
  pvm_upkint(&did, 1, 1);
  pvm_upkint(&cl, 1, 1);
  pvm_upkINT(is, 1, 1);
  pvm_upkINT(iv, 1, 1);
  pvm_upkINT(it, 1, 1);
  pvm_upkINT(mask, 1, 1);
  if (*mid != 50) {
    pvm_upkint(&nint, 1, 1);
    pvm_upkint(&nfloat, 1, 1);
    pvm_upkint(&nchar, 1, 1);
    if (nint   != 0) pvm_upkINT(ints, nint, 1);
    if (nfloat != 0) pvm_upkFLOAT(reals, nfloat, 1);
    if (nchar  != 0) pvm_upkbyte(cstr, nchar, 1);
  } else {
    *is = pv_readData(*mask);
  }

  /* note: global iopt in *is (mid = 35) */
  if ((*mid == 35) && (pv3_did == -1)) pv3_did = *iv;

  if (pv3_did != did) printf(" pV3 Warning: Discipline MisMatch! %d %d %d\n",
                             pv3_did, did, *mid);
  if (pv3_id != cl) printf(" pV3 Warning: Client ID MisMatch! %d %d %d\n",
                           pv3_id, cl, *mid);
}
