c
c	img2X - Visual3 image viewer
c
c	usage:	img2X visual_file[/n] [file2[/n]] ...
c
c		where: n is a optional image compressor.  n=2 means
c		       select every other pixel, n=3 picks every
c		       third pixel.
c
c	        terminate with a ButtonPress in any image window
c		key strokes: 'x' in a window - terminate that window
c			     '~' in any image window - full screen dump
c
c		maximum of 10 images displayed at one time.
c
c       Copyright 1990 - 1996, Massachusetts Institute of Technology.
c
c	Function declarations.
c
	integer*8 XFtnInits, XFtnGCs, XFtnEvent, XFtnColorWindows,
     &            XFtnImgFill
	integer   XFtnNumEvents
c
c	Event names.
c
	integer KeyPress, KeyRelease, ButtonPress, ButtonRelease,
     &	        Expose, NoExpose
c
	parameter ( KeyPress		=  2 )
	parameter ( KeyRelease		=  3 )
	parameter ( ButtonPress		=  4 )
	parameter ( ButtonRelease	=  5 )
	parameter ( Expose		= 12 )
	parameter ( NoExpose	 	= 14 )
c
	integer Off, On
c
	parameter ( Off = 0 )
	parameter ( On  = 1 )
c
	integer*8    display, window(10), GC, rwindow, img(10)
	integer*8    iwin, iadr
	integer      npx(10), npy(10), rev, nrpx, nrpy, msize
	character*80 filnam, text(4), lname
	logical      flag, xpose(10), first
	data first/.true./, rev/2/
c
c	begin setup
c
	GC  = 0
	nw  = 0
	nsx = 0
	nsy = 0
c
	write(*,*) ' '
	write(*,*) ' img2X  Rev 2.30'
	write(*,*) ' '
c
	nargs = iargc()
	if(nargs .eq. 0) then
	  write(*,*) ' '
	  write(*,*) ' Usage: img2X file1[/n] [file2[/n]] ...'
	  write(*,*) ' '
	  stop
	endif
	if(nargs .gt. 10) stop '**ERROR** Too Many Arguments'
c
	do 1 na = 1, nargs
c
c	  get and parse file-name and pixel skip
c
	  call getarg(na, filnam)
	  nl = 0
	  ns = 0
	  do i = 80, 1, -1
	    if(nl .eq. 0 .and. filnam(i:i) .ne. ' ') nl = i
	    if(ns .eq. 0 .and. filnam(i:i) .eq. '/') ns = i
	  enddo
	  if(nl .eq. 0) nl = 80
	  nskip = 1
	  if(ns .ne. 0) then
	    lname = filnam(ns+1:nl)
	    read(lname,*,err=19,end=19) nskip
	    if(nskip .le. 0) go to 19
	    nl = ns-1
	  endif
	  if(nl .ne. 80) filnam(nl+1:80) = ' '
c
	  write(*,1002) na,filnam(1:nl)
 1002	  format(' File #',i2,': ',a)
	  inquire(file=filnam, exist=flag)
	  if(.not.flag) then
	    write(*,*) ' **ERROR** File does NOT exist!'
	    go to 1
	  endif
	  if(imgread(rev, filnam, text, nskip, npixx, npixy, iadr) 
     &       .ne. 0) go to 1
c
	  if(first) then
	    display = XFtnInits(nrpx, nrpy, msize)
	    nrpx = nrpx - 2*msize
	    nrpy = nrpy - 2*msize
	    rwindow = XFtnColorWindows(display, 'img2X', 'Visual3',
     &                                 nrpx, nrpy, 0, 0)
	    call XFtnLower(display, rwindow)
	    first = .false.
	  endif
c
	  if(npixx .gt. nrpx) then
	    write(*,*) ' **ERROR** Requested window TOO large!'
	    call freeV3(iadr)
	    go to 1
	  endif
	  npx(nw+1) =     npixx
	  npy(nw+1) = min(npixy, nrpy)
	  if(npx(nw+1).le.3 .or. npy(nw+1).le.3) then
	    write(*,*) ' **ERROR** Requested window TOO small!'
	    call freeV3(iadr)
	    go to 1
	  endif
c
	  write(*,*) text(1)
	  write(*,*) text(2)
	  write(*,*) text(3)
	  write(*,*) text(4)
c
c	  create window and wait for expose event
	  call XFtnSynchronize(display, On)
	  nw = nw + 1
	  nswx = nsx
	  nswy = nsy
	  if (npx(nw)+nswx .gt. nrpx) nswx = max(0, nrpx-npx(nw))
	  if (npy(nw)+nswy .gt. nrpy) nswy = max(0, nrpy-npy(nw))
	  if(npx(nw) .ge. nrpx .or. npy(nw) .ge. nrpy) then
	    window(nw) = XFtnColorWindows(display, filnam, 'Visual3',
     &                                    npx(nw), npy(nw), nswx, nswy)
	  else
	    window(nw) = XFtnColorWindows(display, filnam, 'img2X',
     &                                    npx(nw), npy(nw), nswx, nswy)
	  endif
	  if(GC .eq. 0) GC = XFtnGCs(display, window(nw))
 11	  if(XFtnNumEvents(display) .ne. 0) then
	    iwin = XFtnEvent(display, itype, ie, je, istate)
	    if(iwin.eq.window(nw) .and. itype.eq.Expose) go to 12
	  endif
	  go to 11
c
c	  fill in image structure and map to window
 12 	  call XFtnSynchronize(display, Off)
	  img(nw) = XFtnImgFill(display, window(nw), npx(nw),
     &                          npy(nw), iadr, rev)
	  call freeV3(iadr)
	  call XFtnImgPut(display, window(nw), GC, img(nw),
     &                    npx(nw), npy(nw))
c
c	  set next window start
c	  if(nsx+npx(nw) .gt. 1000) then
c	    nsx = 0
c	    nsy = min(1000, nsy+npy(nw)+4)
c	  else
c	    nsx = nsx+npx(nw)+4
c	  endif
	  nsx = nsx + 20
	  nsy = nsy + 20
c
	  go to 1
c
 19	  write(*,*) '**ERROR** in File Name Parsing: ',filnam(1:nl)
c
 1	write(*,*) ' '
	if(nw .eq. 0) stop '**ERROR** No valid image files!'
        call XFtnFlush(display)
c
c	end graphics setup - wait for events
c
 2	do i = 1, 10
	  xpose(i) = .false.
	enddo
	nev = XFtnNumEvents(display)
	do ne = 1, nev
	  iwin = XFtnEvent(display, itype, ie, je, istate)
	  do iw = 1, nw
	    if(iwin .eq. window(iw)) go to 3
	  enddo
	  itype = 0
c
c	  expose events
c
 3	  if(itype .eq. Expose) xpose(iw) = .true.
c
c	  key press events
c
	  if(itype .eq. KeyPress) then
c	    x - close window
	    if(istate .eq. ichar('x')) then
	      call XFtnImgFree(display, img(iw))
	      call XFtnDestroyWindow(display, window(iw))
	      window(iw) = 0
	      j = 0
	      do i = 1, nw
	        if(window(i) .ne. 0) j = j + 1
	      enddo
	      if(j .eq. 0) go to 9
	    endif
c           ~ - image output of screen
            if(istate .eq. ichar('~')) then
 4	      write(*,1000)
 1000         format(' Full Screen Dump:'/
     &               ' Enter file name (QUIT to quit):',$)
              read(*,'(a)') filnam
	      if(filnam .eq. ' ') go to 4
              if(filnam .ne. 'QUIT' .and. filnam .ne. 'quit') then
	        text(1) = '  Image produced by img2X'
	        text(2) = ' '
	        text(3) = ' '
	        text(4) = ' '
	        call XFtnDump(rwindow, filnam, text)
              endif
              write(*,*) ' '
            endif
	  endif
c
c	  button press events
c
	  if(itype .eq. ButtonPress) go to 9
	enddo
c
c	redraw exposed windows
	do iw = 1, nw
	  if(xpose(iw) .and. window(iw) .ne. 0) then
	    call XFtnImgPut(display, window(iw), GC, img(iw),
     &                      npx(iw), npy(iw))
            call XFtnFlush(display)
	  endif
	enddo
	go to 2
c
c	clean up and terminate
c
 9	nev = XFtnNumEvents(display)
	do ne = 1, nev
	  iwin = XFtnEvent(display, itype, ie, je, istate)
	enddo
	do i = 1, nw
	  if(window(i) .ne. 0) then
	    call XFtnImgFree(display, img(i))
	    call XFtnDestroyWindow(display, window(i))
	  endif
	enddo
	call XFtnDestroyWindow(display, rwindow)
	call XFtnCloseDisplay(display)
	stop
c 
	end
