c
c	img2ps - visual image file output processor - PostScript
c
c	usage:	img2ps visual_file [-b][-g][-r][-i][-4]
c				   [-cxxxxxxxx][-i][-4]
c				   [-cps]
c
c		-cps -> generate color postscript output
c		-b -> blue separation
c		-g -> green separation
c		-r -> red separation
c		-c -> color mapping [x is r, g, or b]
c		-i -> inverse intensity
c		if none are specified color mapping is used -crrrgggbb
c		   (3bits red, 3bits green, 2bits blue)
c
c	PostScript generated on standard output
c
c       Copyright 1990 - 1996, Massachusetts Institute of Technology.
c
c	David Whitaker of NASA Langley contributed to the cps section.
c	               now at CRAY
c
	integer      linergb(2*3*1280), psline, line(1280)
c
	character*80 filnam, text(4), lname
	integer      icl(2,8), rev, ie
	logical      red, blue, green, color, bit4, inv, cps
	integer*4    iaddr, mallocV3
c
	data inv/.true./, bit4/.false./, rev/2/
	data xoffst/1.25/, yoffst/1.15/, sclfac/1.0/
c
c	get image file
c
	call getarg(1,filnam)
	if(imgread(rev,filnam,text,1,npixx,npixy,iaddr) .ne. 0) stop
	call fixtxt(text(1))
	call fixtxt(text(2))
	call fixtxt(text(3))
	call fixtxt(text(4))
	if(npixx .gt. 1280) stop 'scan line too long!'
c
	cps = .false.
	n = 2
	call getarg(n,lname)
c
	red = .false.
	green = .false.
	blue = .false.
	color = .true.
	icl(1,1) = 1
	icl(2,1) = 128
	icl(1,2) = 1
	icl(2,2) = 64
	icl(1,3) = 1
	icl(2,3) = 32
	icl(1,4) = 2
	icl(2,4) = 128
	icl(1,5) = 2
	icl(2,5) = 64
	icl(1,6) = 2
	icl(2,6) = 32
	icl(1,7) = 3
	icl(2,7) = 128
	icl(1,8) = 3
	icl(2,8) = 64
	irb = 128
	igb = 128
	ibb = 128
	ibit = 0
 2	if(lname .eq. ' ') go to 3
	if(lname(1:1) .eq. '-') then
	  if(lname(2:2).eq.'B' .or. lname(2:2).eq.'b') blue=.true.
	  if(lname(2:2).eq.'G' .or. lname(2:2).eq.'g') green=.true.
	  if(lname(2:2).eq.'R' .or. lname(2:2).eq.'r') red=.true.
	  if(lname(2:2).eq.'4') bit4 = .true.
	  if(lname(2:2).eq.'C' .or. lname(2:2).eq.'c') then
	    if(lname(3:3).eq.'P' .or. lname(3:3).eq.'p') then
	      if(lname(4:4).eq.'S'.or.lname(4:4).eq.'s') cps=.true.
	    else
	      do i = 3, 10
	        ic = 1
	        if(lname(i:i).eq.'G'.or.lname(i:i).eq.'g') ic = 2
	        if(lname(i:i).eq.'B'.or.lname(i:i).eq.'b') ic = 3
	        icl(1,i-2) = ic
	        if(ic .eq. 1) then
	          icl(2,ic-2) = irb
	          irb = irb/2
	        elseif(ic .eq. 2) then
	          icl(2,ic-2) = igb
	          igb = igb/2
	        else
	          icl(2,ic-2) = ibb
	          ibb = ibb/2
	        endif
	      enddo
	    endif
	  endif
	  if(lname(2:2).eq.'I' .or. lname(2:2).eq.'i') inv = .not.inv 
	endif
	n = n + 1
	call getarg(n,lname)
	go to 2
c
 3	if(blue .or. green .or. red .or. cps) color = .false.
	if(blue .or. green .or. red .or. color) cps = .false.
c
c
c       set sizes and scales
c
	xsize = 8.0
	ysize = xsize*float(npixy)/float(npixx)
	if(ysize .gt. 6.0) then
	  ysize = 6.0
	  xsize = ysize*float(npixx)/float(npixy)
	endif
	xoff = 72.0*xoffst
	yoff = 72.0*yoffst
	v2s = 72.0*sclfac
	xx = xsize*v2s
	yy = ysize*v2s
c
	write(*,2000)
 2000   format('%!',/,'%Output generated by img2ps'/
     &         '/textl {currentpoint stroke gsave moveto'          /
     &         '        currentpoint translate -90 rotate show'    /
     &         '        grestore newpath'                          /
     &         '       } def'                                      /
     &         '/textc {gsave gsave stroke grestore currentpoint'  /
     &         '        translate -90 rotate dup stringwidth exch' /
     &         '        -2 div exch rmoveto show grestore newpath' /
     &         '       } def'                                      /
     &         '/Helvetica findfont 12 scalefont setfont'          )
c
	yh = yy + yoff + 9
	write(*,2004) yoff-20.,xoff+xx/2.,text(3)
 2004   format(2f8.2,' moveto'/' (',a,') textc')
        write(*,2002) yh+30.,xoff+xx,text(1)
 2002   format(2f8.2,' moveto'/' (',a,') textl')
	write(*,2002) yh+15.,xoff+xx,text(2)
	write(*,2002) yh,xoff+xx,text(4)
	write(*,2003) yoff+yy, xoff+xx, yoff, xoff+xx,
     &                yoff, xoff, yoff+yy, xoff,
     &                yoff+yy, xoff+xx
 2003   format(' .50 setlinewidth ',
     &         2f8.2,' moveto',2f8.2,' lineto',2f8.2,' lineto'/
     &         2f8.2,' lineto',2f8.2,' lineto'/
     &         ' stroke')
	write(*,*) yoff,xoff,' translate'
	write(*,*) ' 90 rotate'
	nb = 1
	if(cps) go to 1
	maxb = 32000./float(npixx)
	do nb = maxb, 2, -1
	  if(mod(npixy,nb) .eq. 0) go to 1
	enddo
	nb = 1
 1	ysy = yy*float(nb)/float(npixy)
	write(*,*) xx,ysy,' scale'
c
	nbit = 8
	if(bit4 .and. .not.cps) nbit = 4
c
c	color
c
        if(cps) then
	  write(*,2010) npixx,nb,nbit,npixx,-nb,nb
 2010	  format('/T {0 -1 translate}def'                            /
     &           '/P {{currentfile 4 string readhexstring pop dup'   /
     &           ' 1 3 getinterval/V exch def 0 get dup 1 add 3 mul' /
     &           ' /S exch string def 1 add 3 mul 1 sub'             /
     &           ' 0 exch 3 exch{S exch V '                          /
     &           ' putinterval}for S}}def'                           /
     &           '/M {save  R restore}def'                           /
     &           '/R {',3i6,' [',i6,' 0 0',i6,' 0',i6,' ]',          /
     &           ' P  false 3 colorimage}def'                         )
c
	  do j = 0, npixy-1
            psline = iaddr + (npixy-1 - j)*npixx*4
	    do i = 1, npixx
	      line(i) = ireturn(%val(psline+(npixx-i)*4))
            enddo
            is = 1
            irun = 0
	    icr = line(1)/65536
	    icg = mod(line(1)/256,256)
	    icb = mod(line(1),256)
	    do i = 1, npixx
	      itr = line(i)/65536
	      itg = mod(line(i)/256,256)
	      itb = mod(line(i),256)
	      if(itr.eq.icr .and. itg.eq.icg .and. itb.eq.icb) then
                irun = irun + 1
              else 
                do ii = 1, (irun-1)/256 + 1
                  linergb(is) = mod(irun-1,256) 
                  if(ii .lt. (irun-1)/256 + 1) linergb(is) = 255
                  linergb(is+1) = icr
                  linergb(is+2) = icg
                  linergb(is+3) = icb
                  is = is + 4
                enddo
                icr = itr
                icg = itg
                icb = itb
                irun = 1
              endif
              if(i .eq. npixx) then
                do ii = 1, (irun-1)/256 + 1
                  linergb(is) = mod(irun-1,256) 
                  if(ii .lt. (irun-1)/256 + 1) linergb(is) = 255
                  linergb(is+1) = icr
                  linergb(is+2) = icg
                  linergb(is+3) = icb
                  is = is + 4
                enddo
              endif
	    enddo
            ie = is - 1
	    write(*,*) ' T M'
            write(*,1000) (linergb(i),i=1,ie)
 1000	    format(2x,38Z2.2)
	  enddo
          write(*,*) ' showpage'
c
c	greys
c
	else
	  do j = 0, npixy-1
            psline = iaddr + (npixy-1 - j)*npixx*4
	    do i = 1, npixx
	      line(i) = ireturn(%val(psline+(npixx-i)*4))
            enddo
	    if(mod(j,nb) .eq. 0) then
	      if(j .ne. 0) write(*,*) ' >} image'
	      write(*,*) ' 0 -1 translate'
	      write(*,*) npixx,nb,nbit,
     &                   ' [',npixx,' 0 0',-nb,' 0 ',nb,' ]'
	      write(*,*) ' {<'
	    endif
	    do i = 1, npixx
	      ir = line(i)/65536
	      ig = mod(line(i)/256,256)
	      ib = mod(line(i),256)
	      ival = 0
	      if(red)   ival = max(ival, ir)
	      if(green) ival = max(ival, ig)
	      if(blue)  ival = max(ival, ib)
	      if(color) then
	        ival = 0
	        do k = 1, 8
	          ibit = ir
	          if(icl(1,k) .eq. 2) ibit = ig
	          if(icl(1,k) .eq. 3) ibit = ib
	          ibit = mod(ibit/icl(2,k),2)
	          ival = ival + ibit*2**(8-k)
	        enddo
	      endif
	      if(inv) ival = 255 - ival
	      line(i) = ival
	    enddo
	    if(bit4) then
	      write(*,1001) (line(i)/16,i=1,npixx)
 1001	      format(2x,76Z1)
	    else
	      write(*,1000) (line(i),i=1,npixx)
	    endif
	  enddo
	  write(*,*) ' >} image'
	  write(*,*) ' showpage'
	endif
c 
	end


	integer function ireturn(i)
c
	ireturn = i
	return
	end
