c
c	img2tiff - visual image file output processor - TIFF
c
c	usage:	img2tiff visual_file tiff_file
c
c	Copyright 1990 - 1996, Massachusetts Institute of Technology.
c
	parameter (mtags = 14)
c
	pointer      (pline, line), (psline, sline)
	integer      line(1), sline(1)
c
	character*80 filnam, text(4), lname
	character*8  name
	character*19 dattim
	integer      i4, rev
	integer*2    i2
	integer*1    i1(4)
	logical      flag, byterev
	equivalence (i1,i4)
	common /border/ byterev
	integer*BSIZE    iaddr, ifp, mallocV3
c
	data name/'img2tif '/, rev/2/
c
	i4 = 0
	i1(4) = rev
	byterev = i4 .ne. rev
c
	if(iargc() .ne. 2) 
     &    stop 'Error - Usage: img2tiff img_file tiff_file!'
	call getarg(1,filnam)
	inquire(file=filnam,exist=flag)
	if(.not.flag) stop 'input file does not exist!'
	if(imgread(rev,filnam,text,1,npixx,npixy,iaddr) .ne. 0) stop
	pline = mallocV3(max(npixx,npixy)*4)
	if(pline .eq. 0) stop 'Error - MALLOC!'
c
	call getarg(2,lname)
	call ioopen(lname, 1, ifp)
c
	isdata = 16 + mtags*12
c
c	byte order - "mm" = z'4d4d'
	i2 = 19789
	call iowrit(i2,2,ifp)
c
c	magic number = 42
	i2 = 42
	call swap2(i2)
	call iowrit(i2,2,ifp)
c
c	IFD pointer
	i4 = 8
	call swap4(i4)
	call iowrit(i4,4,ifp)
c
c	IFD
	i2 = mtags
	call swap2(i2)
	call iowrit(i2,2,ifp)
c	subfile type (new)
	i2 = 254
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 4
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = 0
	call iowrit(i4,4,ifp)
c	image width
	i2 = 256
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 4
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = npixx
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	image length
	i2 = 257
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 4
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = npixy
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	bits/sample
	i2 = 258
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 3
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 3
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	photometric interp
	i2 = 262
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 3
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = 2*256*256
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	strip offsets
	i2 = 273
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 4
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = npixy
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata+6
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	samples/pixel
	i2 = 277
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 3
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = 3*256*256
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	rows/strip
	i2 = 278
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 4
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	strip byte count
	i2 = 279
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 4
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = npixy
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata+6+npixy*4
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	xres
	i2 = 282
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 5
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata+6+npixy*8
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	yres
	i2 = 283
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 5
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata+6+npixy*8
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	Planar Config
	i2 = 284
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 3
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = 1*256*256
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	Software
	i2 = 305
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 2
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 8
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata+14+npixy*8
	call swap4(i4)
	call iowrit(i4,4,ifp)
c	DateTime
	i2 = 306
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i2 = 2
	call swap2(i2)
	call iowrit(i2,2,ifp)
	i4 = 20
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = isdata+22+npixy*8
	call swap4(i4)
	call iowrit(i4,4,ifp)
c
	i4 = 0
	call iowrit(i4,4,ifp)
	call iowrit(i4,2,ifp)
c
	iddata = isdata+42+npixy*8
c
c	bits per sample
	i2 = 8
	call swap2(i2)
	call iowrit(i2,2,ifp)
	call iowrit(i2,2,ifp)
	call iowrit(i2,2,ifp)
c
c	strip offsets
	do i = 1, npixy
	  i4 = iddata + 3*npixx*(i-1)
	  call swap4(i4)
	  line(i) = i4
	enddo
	call iowrit(line,4*npixy,ifp)
c
c	strip byte count
	do i = 1, npixy
	  i4 = 3*npixx
	  call swap4(i4)
	  line(i) = i4
	enddo
	call iowrit(line,4*npixy,ifp)
c
c	xres & yres
	i4 = max(npixx, npixy)
	call swap4(i4)
	call iowrit(i4,4,ifp)
	i4 = 1
	call swap4(i4)
	call iowrit(i4,4,ifp)
c
c	software
	name(8:8) = char(0)
	call iowrit(name,8,ifp)
c
c	date/time
	call ppdate(dattim)
	call iowrit(dattim,9,ifp)
	call iowrit('  ',2,ifp)
	dattim(19:19) = char(0)
	call iowrit(dattim(11:11),9,ifp)
c
c       write image
c
	do j = 0, npixy-1
	  psline = iaddr + j*npixx*4
	  do i = 1, npixx
	    i4 = sline(i)
	    if(byterev) then
	      i1(4) = i1(1)
	      i1(1) = i1(3)
	      i1(3) = i1(4)
	      call iowrit(i1(1),3,ifp)
	    else
	      call iowrit(i1(2),3,ifp)
	    endif
	  enddo
	enddo
c
	call ioclos(ifp)
	end


	subroutine swap2(i2a)
c
c	integer*2 byte swap
c
	integer*2 i2, i2a
	integer*1 i1(2), isv
	logical   byterev
	common /border/ byterev
	equivalence(i1, i2)
c
	if(.not.byterev) return
	i2    = i2a
	isv   = i1(1)
	i1(1) = i1(2)
	i1(2) = isv
	i2a   = i2
c
	return
	end


	subroutine swap4(i4a)
c
c	integer*4 byte swap
c
	integer*4 i4, i4a
	integer*1 i1(4), isv
	logical   byterev
	common /border/ byterev
	equivalence(i1, i4)
c
	if(.not.byterev) return
	i4    = i4a
	isv   = i1(1)
	i1(1) = i1(4)
	i1(4) = isv
	isv   = i1(2)
	i1(2) = i1(3)
	i1(3) = isv
	i4a   = i4
c
	return
	end
