c
c	lin2eps - visual line file output processor - Encapsulated PostScript
c
c	usage:	lin2eps visual_file
c
c	PostScript generated on standard output
c
c       Copyright 1990 - 1996, Massachusetts Institute of Technology.
c
c----------------------------------------------------------------------c
c Altered by Jonathan Taylor, Whittle Lab, Cambridge to create eps files
c----------------------------------------------------------------------c
c
	parameter (mwork = 3840)
c
	character*80 filnam, text(4)
	character*2  type
	real         xwork(mwork), ywork(mwork),  zwork(mwork)
	real         xform(4,4),   alfseg(2,100), xyzlin(6)
	logical      down, flag
	integer*8    memp, mallocV3
c
	data xoffst/0.875/, yoffst/3.55/, sclfac/1.0/
c
	if(iargc() .ne. 1) stop 'error - 1 argument required!'
	call getarg(1,filnam)
	inquire(file=filnam,exist=flag)
	if(.not.flag) stop 'input file does not exist!'
	open(unit=1,file=filnam,form='unformatted',status='old')
        read(1) type, rev
	if(type .ne. '2D' .and. type .ne. '3D')
     &      stop 'Error - Not a Visual3 LineFile!'
	read(1) text(1)
	call fixtxt(text(1))
	read(1) text(2)
	call fixtxt(text(2))
	read(1) text(3)
	call fixtxt(text(3))
	read(1) text(4)
	call fixtxt(text(4))
c
c       set sizes and scales
c
	xsize = 6.5
	ysize = 6.5
	xoff  = 72.0*xoffst
	yoff  = 72.0*yoffst
	v2s   = 72.0*sclfac
	xx    = xsize*v2s
	yy    = ysize*v2s
	xm    = xsize*v2s
	ym    = ysize*v2s
c
c       write header information
c
	write(*,2000) filnam, xoff, yoff, xoff+xx, yoff+yy
 2000   format('%!PS-Adobe-3.0 epsf-3.0' /
     &         '%%Creator: lin2ps'       /
     &         '%%Title:   ', a80,       /
     &         '%%Pages:   1'            /
     &         '%%BoundingBox:', 4f8.2,  /
     &         '%%EndComments'           )
cc        write(*,2001) yoff+yy, xoff+xx, yoff, xoff+xx,
cc     &                yoff, xoff, yoff+yy, xoff
        write(*,2001) xoff+xx, yoff+yy, xoff+xx, yoff,
     &                xoff, yoff, xoff, yoff+yy
 2001   format('%%BeginProlog'                                     /
     &         '%%BeginResource: lin2ps'                           /
     &         '/textl {currentpoint stroke gsave moveto'          /
     &         '        currentpoint translate 0 rotate show'    /
     &         '        grestore newpath'                          /
     &         '       } def'                                      /
     &         '/textc {gsave gsave stroke grestore currentpoint'  /
     &         '        translate 0 rotate dup stringwidth exch' /
     &         '        -2 div exch rmoveto show grestore newpath' /
     &         '       } def'                                      /
     &         '/Helvetica findfont 12 scalefont setfont'          /
     &         '/boxpath {newpath', 2f8.2,' moveto',2f8.2,' lineto'/,
     &                              2f8.2,' lineto',2f8.2,' lineto'/
     &                   'closepath } def'                         /
     &         '%%EndResource'                                       /
     &         '%%EndProlog'                                         )

	yh = yy + yoff + 9

        write(*,2006) '   one', 1
 2006   format('%%Page: ', a6, i3 )

	write(*,2004) xoff+xx/2.,yoff-20.,text(3)
 2004   format(2f8.2,' moveto'/' (',a,') textc')
        write(*,2002) xoff,yh+30.,text(1)
 2002   format(2f8.2,' moveto'/' (',a,') textl')
	write(*,2002) xoff,yh+15.,text(2)
	write(*,2002) xoff,yh,text(4)
c
c       set clipping path
	write(*,2005)
 2005	format(' 0.50 setlinewidth boxpath stroke' /
     &         ' boxpath clip'                     )

c
c	2D Window
	if(type .eq. '2D') then
 1	  read(1,end=9) nl,iflag
	  np = 0
	  if(iflag .eq. 1) then
	    read(1,end=9) (xwork(i),ywork(i),i=1,nl)
            xx =      0.5*(xwork(1)+1.0)*xm
	    yy =      0.5*(ywork(1)+1.0)*ym
	    if(xx .ge. 0.0 .and. xx .le. xm .and.
     &         yy .ge. 0.0 .and. yy .le. ym) then
              write(*,1000) xx+xoff, yy+yoff
 1000	      format(2f8.2,' moveto')
	      down = .true.
	      np = np + 1
	    else
	      down = .false.
	    endif
	    do i = 2, nl
	      xl = xx
	      yl = yy
              xx =      0.5*(xwork(i)+1.0)*xm
              yy =      0.5*(ywork(i)+1.0)*ym
	      if(down) then
	        if(np .gt. 1000) then
	          write(*,*) ' stroke'
                  write(*,1000) xl+xoff, yl+yoff
	          np = 1
	        endif
                write(*,1001) xx+xoff, yy+yoff
 1001	        format(2f8.2,' lineto')
	        np = np + 1
	        down = xx .ge. 0.0 .and. xx .le. xm .and.
     &                 yy .ge. 0.0 .and. yy .le. ym
	      else
	        if(xx .ge. 0.0 .and. xx .le. xm .and.
     &             yy .ge. 0.0 .and. yy .le. ym) then
                  write(*,1000) xl+xoff, yl+yoff
                  write(*,1001) xx+xoff, yy+yoff
	          down = .true.
	          np = np + 2
	        endif
	      endif
	    enddo
	  else
	    np = nl*2
	    read(1,end=9) (xwork(i),ywork(i),i=1,np)
	    do 2 i = 1, np, 2
              x1 =      0.5*(xwork(i  )+1.0)*xm
              y1 =      0.5*(ywork(i  )+1.0)*ym
              x2 =      0.5*(xwork(i+1)+1.0)*xm
              y2 =      0.5*(ywork(i+1)+1.0)*ym
	      if(x1 .lt. 0.0 .and. x2 .lt. 0.0) go to 2
	      if(y1 .lt. 0.0 .and. y2 .lt. 0.0) go to 2
	      if(x1 .gt. xm  .and. x2 .gt. xm ) go to 2
	      if(y1 .gt. ym  .and. y2 .gt. ym ) go to 2
              write(*,1002) x1+xoff, y1+yoff, x2+xoff, y2+yoff
 1002	      format(2f8.2,' moveto ',2f8.2,' lineto')
	      if(mod(i-1,500).eq.0 .and. i+1.ne.np) write(*,*) ' stroke'
 2	    continue
	  endif
	  write(*,*) ' stroke'
	  go to 1
 9	  continue
c
c	3D Window
c
	else
	  read(1) xform
	  ntri = 0
c
c	  get number of triangles
 3	  read(1,end=4) np, iflag
	  if(iflag .eq. 3) then
	    ntri = ntri + np
	    np = np*3
	  elseif(iflag .eq. 2) then
	    np = np*2
	  endif
	  read(1) (xwork(i),ywork(i),zwork(i),i=1,np)
	  go to 3
c
c	  store the triangles
 4	  rewind 1
          read(1) type, rev
	  read(1) text(1)
	  call fixtxt(text(1))
	  read(1) text(2)
	  call fixtxt(text(2))
	  read(1) text(3)
	  call fixtxt(text(3))
	  read(1) text(4)
	  call fixtxt(text(4))
	  read(1) xform
	  if(ntri .ne. 0) then
	    mem = 4*ntri*13
	    memp = mallocV3(mem)
	    if(memp .eq. 0) stop 'Error in Memory Allocation'
	  endif
	  n = 0
 5	  read(1,end=6) np, iflag
	  if(iflag .eq. 3) then
	    nt = np
	    np = np*3
	  elseif(iflag .eq. 2) then
	    np = np*2
	  endif
	  read(1) (xwork(i),ywork(i),zwork(i),i=1,np)
	  if(iflag .eq. 3) then
	    call readtri(xwork, ywork, zwork, nt, n, xform, %val(memp))
	  endif
	  go to 5
c
c	draw lines
 6	  rewind 1
          read(1) type, rev
	  read(1) text(1)
	  call fixtxt(text(1))
	  read(1) text(2)
	  call fixtxt(text(2))
	  read(1) text(3)
	  call fixtxt(text(3))
	  read(1) text(4)
	  call fixtxt(text(4))
	  read(1) xform
	  npts = 0
c
 7	  read(1,end=8) np, iflag
	  if(iflag .eq. 3) then
	    np = np*3
	  elseif(iflag .eq. 2) then
	    np = np*2
	  endif
	  read(1) (xwork(i),ywork(i),zwork(i),i=1,np)
	  if(iflag .ne. 3) then
	    do i = 1, np-1, iflag
	      x = xwork(i)
	      y = ywork(i)
	      z = zwork(i)
	      x1 = x*xform(1,1)+y*xform(1,2)+z*xform(1,3)+xform(1,4)
	      y1 = x*xform(2,1)+y*xform(2,2)+z*xform(2,3)+xform(2,4)
	      z1 = x*xform(3,1)+y*xform(3,2)+z*xform(3,3)+xform(3,4)
	      z1 = -z1
	      x = xwork(i+1)
	      y = ywork(i+1)
	      z = zwork(i+1)
	      x2 = x*xform(1,1)+y*xform(1,2)+z*xform(1,3)+xform(1,4)
	      y2 = x*xform(2,1)+y*xform(2,2)+z*xform(2,3)+xform(2,4)
	      z2 = x*xform(3,1)+y*xform(3,2)+z*xform(3,3)+xform(3,4)
	      z2 = -z2
	      if(z1 .lt. -1.0 .and. z2 .lt. -1.0) go to 12
	      if(z1 .gt.  1.0 .and. z2 .gt.  1.0) go to 12
	      if(z1 .lt. -1.0) then
	        d  = (-1.0-z1)/(z2-z1)
	        x1 = x1 + d*(x2-x1)
	        y1 = y1 + d*(y2-y1)
	        z1 = z1 + d*(z2-z1)
	      endif
	      if(z1 .gt.  1.0) then
	        d  = (z1-1.0)/(z1-z2)
	        x1 = x1 + d*(x2-x1)
	        y1 = y1 + d*(y2-y1)
	        z1 = z1 + d*(z2-z1)
	      endif
	      if(z2 .lt. -1.0) then
	        d  = (-1.0-z2)/(z1-z2)
	        x2 = x2 + d*(x1-x2)
	        y2 = y2 + d*(y1-y2)
	        z2 = z2 + d*(z1-z2)
	      endif
	      if(z2 .gt.  1.0) then
	        d  = (z2-1.0)/(z2-z1)
	        x2 = x2 + d*(x1-x2)
	        y2 = y2 + d*(y1-y2)
	        z2 = z2 + d*(z1-z2)
	      endif
	      if(ntri .ne. 0) then
	        xyzlin(1) = x1
	        xyzlin(2) = y1
	        xyzlin(3) = z1
	        xyzlin(4) = x2
	        xyzlin(5) = y2
	        xyzlin(6) = z2
	        nseg = 100
	        call hidden(xyzlin, ntri, %val(memp), nseg, alfseg)
	        if(nseg .eq. 0) go to 12
	        do n = 1, nseg
                  xp1 =      0.5*(x1+alfseg(1,n)*(x2-x1) + 1.0)*xm
	          yp1 =      0.5*(y1+alfseg(1,n)*(y2-y1) + 1.0)*ym
                  xp2 =      0.5*(x1+alfseg(2,n)*(x2-x1) + 1.0)*xm
	          yp2 =      0.5*(y1+alfseg(2,n)*(y2-y1) + 1.0)*ym
	          if(xp1 .lt. 0.0 .and. xp2 .lt. 0.0) go to 121
	          if(yp1 .lt. 0.0 .and. yp2 .lt. 0.0) go to 121
	          if(xp1 .gt. xm  .and. xp2 .gt. xm ) go to 121
	          if(yp1 .gt. ym  .and. yp2 .gt. ym ) go to 121
	          npts = npts + 1
                  write(*,1002) xp1+xoff, yp1+yoff, xp2+xoff, yp2+yoff
	          if(npts .gt. 500) then
	            write(*,*) ' stroke'
	            npts = 0
	          endif
  121             continue
                enddo
	      else
                xp1 =      0.5*(x1 + 1.0)*xm
	        yp1 =      0.5*(y1 + 1.0)*ym
                xp2 =      0.5*(x2 + 1.0)*xm
	        yp2 =      0.5*(y2 + 1.0)*ym
	        if(xp1 .lt. 0.0 .and. xp2 .lt. 0.0) go to 12
	        if(yp1 .lt. 0.0 .and. yp2 .lt. 0.0) go to 12
	        if(xp1 .gt. xm  .and. xp2 .gt. xm ) go to 12
	        if(yp1 .gt. ym  .and. yp2 .gt. ym ) go to 12
	        npts = npts + 1
                write(*,1002) xp1+xoff, yp1+yoff, xp2+xoff, yp2+yoff
	        if(npts .gt. 500) then
	          write(*,*) ' stroke'
	          npts = 0
	        endif
	      endif
   12         continue
            enddo
	  endif
	  go to 7
c
 8	  if(npts .ne. 0) write(*,*) ' stroke'
	endif
	write(*,*) ' showpage'
c
	end


	subroutine readtri(xtri, ytri, ztri, nt, n, xform, xyztri)
c
c	read and transform xyztri
c
	real xtri(3,1), ytri(3,1), ztri(3,1), xform(4,4), xyztri(13,1)
c
	do i = 1, nt
	  n = n + 1
c
	  x = xtri(1,i)
	  y = ytri(1,i)
	  z = ztri(1,i)
	  xt = x*xform(1,1) + y*xform(1,2) + z*xform(1,3) + xform(1,4)
	  yt = x*xform(2,1) + y*xform(2,2) + z*xform(2,3) + xform(2,4)
	  zt = x*xform(3,1) + y*xform(3,2) + z*xform(3,3) + xform(3,4)
	  xyztri(1,n) =  xt
	  xyztri(2,n) =  yt
	  xyztri(3,n) = -zt
c
	  x = xtri(2,i)
	  y = ytri(2,i)
	  z = ztri(2,i)
	  xt = x*xform(1,1) + y*xform(1,2) + z*xform(1,3) + xform(1,4)
	  yt = x*xform(2,1) + y*xform(2,2) + z*xform(2,3) + xform(2,4)
	  zt = x*xform(3,1) + y*xform(3,2) + z*xform(3,3) + xform(3,4)
	  xyztri(4,n) =  xt
	  xyztri(5,n) =  yt
	  xyztri(6,n) = -zt
c
	  x = xtri(3,i)
	  y = ytri(3,i)
	  z = ztri(3,i)
	  xt = x*xform(1,1) + y*xform(1,2) + z*xform(1,3) + xform(1,4)
	  yt = x*xform(2,1) + y*xform(2,2) + z*xform(2,3) + xform(2,4)
	  zt = x*xform(3,1) + y*xform(3,2) + z*xform(3,3) + xform(3,4)
	  xyztri(7,n) =  xt
	  xyztri(8,n) =  yt
	  xyztri(9,n) = -zt
c
	  xyztri(10,n) = min(xyztri(1,n), xyztri(4,n), xyztri(7,n))
	  xyztri(11,n) = max(xyztri(1,n), xyztri(4,n), xyztri(7,n))
	  xyztri(12,n) = min(xyztri(2,n), xyztri(5,n), xyztri(8,n))
	  xyztri(13,n) = max(xyztri(2,n), xyztri(5,n), xyztri(8,n))
c
	enddo
c
	return
	end


       SUBROUTINE HIDDEN(XYZLIN,NTRI,XYZTRI,NSEG,ALFSEG)
C
C      This is a hidden line routine.  Given a set of triangles, and a
C      single line as input, it computes the the line segments (if any)
C      which are visible.
C
C      XYZLIN = array of data about input line (unchanged by routine)
C          1  = x1
C          2  = y1
C          3  = z1
C          4  = x2
C          5  = y2
C          6  = z2
C
C      NTRI   = number of triangles
C
C      XYZTRI = array of data about input triangles (unchanged by routine)
C          1  = x1
C          2  = y1
C          3  = z1
C          4  = x2
C          5  = y2
C          6  = z2
C          7  = x3
C          8  = y3
C          9  = z3
C         10  = min(x)
C         11  = max(x)
C         12  = min(y)
C         13  = max(y)
C
C      NSEG   = (input)  dimension of ALFSEG = max. no. of segments
C               (output) number of visible line segments
C
C      ALFSEG = output values describing the visible line segments as
C               fractions of the original line
C          1  = beginning of segment
C          2  =       end of segment
C
       REAL XYZLIN(6), XYZTRI(13,NTRI), ALFSEG(2,NSEG)
C
       DATA EPS/1.0E-5/
C
C----- Initialize a few things
       X1 = XYZLIN(1)
       Y1 = XYZLIN(2)
       Z1 = XYZLIN(3) + EPS
       X2 = XYZLIN(4)
       Y2 = XYZLIN(5)
       Z2 = XYZLIN(6) + EPS
C
       XMIN = MIN(X1,X2)
       YMIN = MIN(Y1,Y2)
       XMAX = MAX(X1,X2)
       YMAX = MAX(Y1,Y2)
C
       NMXSEG = NSEG
       NSEG = 1
       ALFSEG(1,1) = 0.0
       ALFSEG(2,1) = 1.0
C
C----- Main processing loop
       DO 1 KT = 1, NTRI
C
C....... first, crude but effective purge of most cells
         IF(XYZTRI(10,KT).GE.XMAX .OR. XYZTRI(11,KT).LE.XMIN) GOTO 1
         IF(XYZTRI(12,KT).GE.YMAX .OR. XYZTRI(13,KT).LE.YMIN) GOTO 1
C
C....... find where cell nodes are relative to line
         N1 = 0
         IF( (XYZTRI(1,KT)-X1)*(Y2-Y1) .GT. 
     &       (XYZTRI(2,KT)-Y1)*(X2-X1) )    N1 = N1+1
         IF( (XYZTRI(4,KT)-X1)*(Y2-Y1) .GT. 
     &       (XYZTRI(5,KT)-Y1)*(X2-X1) )    N1 = N1+2
         IF( (XYZTRI(7,KT)-X1)*(Y2-Y1) .GT. 
     &       (XYZTRI(8,KT)-Y1)*(X2-X1) )    N1 = 3-N1
C
C....... skip if cell all on one side of line
         IF(N1.EQ.0) GOTO 1
C
C....... set up temporary variables in canonical orientation
         N2 = MOD(N1,3) + 1           
         N3 = MOD(N2,3) + 1           
C
         N13 = 3*N1 - 2
         XT1 = XYZTRI(N13  ,KT)
         YT1 = XYZTRI(N13+1,KT)
         ZT1 = XYZTRI(N13+2,KT)
         N23 = 3*N2 - 2
         XT2 = XYZTRI(N23  ,KT)
         YT2 = XYZTRI(N23+1,KT)
         ZT2 = XYZTRI(N23+2,KT)
         N33 = 3*N3 - 2
         XT3 = XYZTRI(N33  ,KT)
         YT3 = XYZTRI(N33+1,KT)
         ZT3 = XYZTRI(N33+2,KT)
C
C....... compute xi, eta, zeta values for line in triangle coords
         DETINV = 1.0 / ( (XT2-XT1)*(YT3-YT1) - (XT3-XT1)*(YT2-YT1) )
         XI1 = DETINV * ( (X1 -XT1)*(YT3-YT1) - (XT3-XT1)*(Y1 -YT1) )
         IF(ABS(XI1-1.0).LT.EPS) XI1 = 1.0
         ET1 = DETINV * ( (XT2-XT1)*(Y1 -YT1) - (X1 -XT1)*(YT2-YT1) )
         IF(ABS(ET1-1.0).LT.EPS) ET1 = 1.0
         ZE1 = (Z1-ZT1) - XI1*(ZT2-ZT1) - ET1*(ZT3-ZT1)
         XI2 = DETINV * ( (X2 -XT1)*(YT3-YT1) - (XT3-XT1)*(Y2 -YT1) )
         IF(ABS(XI2-1.0).LT.EPS) XI2 = 1.0
         ET2 = DETINV * ( (XT2-XT1)*(Y2 -YT1) - (X2 -XT1)*(YT2-YT1) )
         IF(ABS(ET2-1.0).LT.EPS) ET2 = 1.0
         ZE2 = (Z2-ZT1) - XI2*(ZT2-ZT1) - ET2*(ZT3-ZT1)
C
C....... branch to end of loop if line is outside triangle
         IF(MAX(XI1,XI2).LE.0. .OR.
     &      MAX(ET1,ET2).LE.0. .OR.
     &      MIN(XI1+ET1,XI2+ET2) .GT. 1.0) GOTO 1
C
C....... compute hidden part of line
         IF(MIN(ZE1,ZE2).GE.0.) THEN
          ALF1 = 1.0
          ALF2 = 0.0
         ELSE IF(MAX(ZE1,ZE2).LT.0.) THEN
          ALF1 = 0.0
          ALF2 = 1.0
         ELSE IF(ZE1.GE.0.) THEN
          ALF1 = ZE1 / (ZE1-ZE2)
          ALF2 = 1.0
         ELSE
          ALF1 = 0.0
          ALF2 = ZE1 / (ZE1-ZE2)
         ENDIF
C
         BET = ( (0.5*(XT1+XT2)-X1)*(YT2-YT1) -
     &           (0.5*(YT1+YT2)-Y1)*(XT2-XT1) ) /
     &         ( (X2-X1)*(YT2-YT1) - (Y2-Y1)*(XT2-XT1) )
         GAM = ( (0.5*(XT1+XT3)-X1)*(YT3-YT1) -
     &           (0.5*(YT1+YT3)-Y1)*(XT3-XT1) ) /
     &         ( (X2-X1)*(YT3-YT1) - (Y2-Y1)*(XT3-XT1) )
C
         ALF1 = MAX(ALF1,MIN(BET,GAM))
         ALF2 = MIN(ALF2,MAX(BET,GAM))
C
C....... branch to end of loop if no hidden part 
         IF(ALF1.GE.ALF2) GOTO 1
         IF(ALF1 .LT.     EPS) ALF1 = 0.0
         IF(ALF2 .GT. 1.0-EPS) ALF2 = 1.0
C
C....... combine new hidden part with previous visible bits
         NSEG2 = NSEG
C
         DO 2 NS = NSEG2, 1, -1
           IF(ALF1.GE.ALFSEG(2,NS) .OR. ALF2.LE.ALFSEG(1,NS)) THEN
           ELSE IF(ALF1.GT.ALFSEG(1,NS) .AND. ALF2.LT.ALFSEG(2,NS)) THEN
            IF(NSEG.EQ.NMXSEG) STOP 'Error: too many segments'
            NSEG = NSEG+1
            ALFSEG(1,NSEG) = ALF2
            ALFSEG(2,NSEG) = ALFSEG(2,NS)
            ALFSEG(2,NS) = ALF1
           ELSE IF(ALF1.LE.ALFSEG(1,NS) .AND. ALF2.GE.ALFSEG(2,NS)) THEN
            ALFSEG(1,NS) = ALFSEG(1,NSEG)
            ALFSEG(2,NS) = ALFSEG(2,NSEG)
            NSEG = NSEG-1
           ELSE IF(ALF1.LE.ALFSEG(1,NS) .AND. ALF2.LT.ALFSEG(2,NS)) THEN
            ALFSEG(1,NS) = ALF2
           ELSE IF(ALF1.GT.ALFSEG(1,NS) .AND. ALF2.GE.ALFSEG(2,NS)) THEN
            ALFSEG(2,NS) = ALF1
           ENDIF
 2       CONTINUE
C
         IF(NSEG.EQ.0) RETURN
 1     CONTINUE
C
       RETURN
       END
