c
c	tab2ps - visual table file output processor - PostScript
c
c	usage:	tab2ps visual_file
c
c	PostScript generated on standard output
c
c       Copyright 1990 - 1992, Massachusetts Institute of Technology.
c
	character*80 filnam, text(5), lname
	character*32 xaxis, yaxis
	logical      flag, endax
	data xoffst/1.25/, yoffst/1.25/, sclfac/1.0/
c
	if(iargc() .ne. 1) stop 'error - 1 argument required!'
	call getarg(1,filnam)
	inquire(file=filnam,exist=flag)
	if(.not.flag) stop 'input file does not exist!'
	open(unit=1,file=filnam,status='old')
	read(1,1000) text(1)
 1000	format(a80)
	read(1,1000) text(2)
	read(1,1000) text(3)
	read(1,1000) text(4)
	read(1,1000) text(5)
	read(1,1001) xaxis, yaxis
 1001	format(2a32)
	endax = .false.
	if(xaxis .eq. ' ' .and. yaxis .eq. ' ') then
 5	  read(1,*) np
	  if(np .le. 0) go to 6
	  do i = 1, np
	    read(1,*) xp, yp
	  enddo
	  go to 5
 6 	  read(1,1001) xaxis, yaxis
	  rewind 1
	  read(1,1000) text(1)
	  read(1,1000) text(2)
	  read(1,1000) text(3)
	  read(1,1000) text(4)
	  read(1,1000) text(5)
	  read(1,1000)
	  endax = .true.
	endif
c 
	xoff = 72.0*xoffst
	yoff = 72.0*yoffst
	v2s  = 72.0*sclfac
	xsize = 8.
	ysize = 6.
	xx = xsize*v2s
	yy = ysize*v2s
c
	lname = text(4)
	read(lname(14:80),*) xmn, xinc
	lname = text(5)
	read(lname(14:80),*) ymn, yinc
c
	flag = .true.
	if(xaxis .eq. 'Time') flag = .false.
	call PS_Axes(text, xaxis, yaxis, flag, xmn, xinc, ymn, yinc)
c
c       set clipping path
	write(*,2005) yoff+yy, xoff+xx, yoff, xoff+xx,
     &                yoff, xoff, yoff+yy, xoff
 2005	format(' gsave'/' /boxpath {newpath ',
     &         2f8.2,' moveto',2f8.2,' lineto',2f8.2,' lineto'/
     &         2f8.2,' lineto closepath } def'/
     &         ' boxpath clip')
c
c	draw line
	xm = xsize*v2s
c
 1	npts = 0
	read(1,*,end=2,err=2) np
	if(np .le. 0) go to 2
c
	read(1,*,end=2,err=2) xp, yp
	x = xm-v2s*(xp-xmn)/xinc
	y =    v2s*(yp-ymn)/yinc
	write(*,2000) y+yoff, x+xoff
 2000	format(2f8.2,' moveto')
	do i = 2, np
	  read(1,*,end=3,err=3) xp, yp
	  x = xm-v2s*(xp-xmn)/xinc
	  y =    v2s*(yp-ymn)/yinc
	  write(*,2001) y+yoff, x+xoff
 2001	  format(2f8.2,' lineto')
	  npts = npts + 1
	  if(npts .gt. 500 .and. i .ne. np) then
	    write(*,*) 'stroke'
	    write(*,2000) y+yoff, x+xoff
	    npts = 0
	  endif
	enddo
	write(*,*) ' stroke'
	go to 1
 3	write(*,*) ' stroke'
c
 2	write(*,*) ' grestore'
	if(.not. endax) then
	  read(1,1000,end=4,err=4) lname
	  write(*,1100) yy+yoff+9, xoff+xx-9, lname
 1100	  format(2f8.2,' moveto'/' (',a,') textl')
	endif
c
 4 	write(*,*) ' showpage'
	end



	subroutine PS_Axes(text,xaxis,yaxis,xanno,xmn,xinc,ymn,yinc)
c
c       plot axes and titles into PostScript file
c
	logical xanno
        character*6  titln
	character*80 text(*), ttl
	character*32 xaxis, yaxis
	character*10 fmtx, fmty, expx, expy
	data xoffst/1.25/, yoffst/1.25/, sclfac/1.0/
c
c
	write(*,2000)
 2000	format('%!',/,'%Output generated by tab2ps'/
     &            '/textl {currentpoint stroke gsave moveto'          /
     &            '        currentpoint translate -90 rotate show'    /
     &            '        grestore newpath'                          /
     &            '       } def'                                      /
     &            '/textc {gsave gsave stroke grestore currentpoint'  /
     &            '        translate -90 rotate dup stringwidth exch' /
     &            '        -2 div exch rmoveto show grestore newpath' /
     &            '       } def'                                      /
     &            '/textr {gsave gsave stroke grestore currentpoint'  /
     &            '        translate dup stringwidth exch'            /
     &            '        -2 div exch rmoveto show grestore newpath' /
     &            '       } def'                                      /
     &            '/Helvetica findfont 12 scalefont setfont'          )
c
c	draw titles
	xoff = 72.0*xoffst
	yoff = 72.0*yoffst
	v2s = 72.0*sclfac
	xx = 8*v2s
	yy = 6*v2s
	yh = yy + yoff + 9
	write(*,1000) yh+30.,xoff+xx-9.,' moveto (',text(1),') textl'
 1000	format(2f8.2,3a)
        write(*,1100) yh+15.,xoff+xx-9.,text(3)
 1100   format(2f8.2,' moveto'/' (',a,') textl')
	ttl = text(2)
	do ix1 = 1, 80
	  if(ttl(ix1:ix1) .ne. ' ') go to 1
	enddo
	ix1 = 79
 1	do ix2 = 80, ix1+1, -1
	  if(ttl(ix2:ix2) .ne. ' ') go to 2
	enddo
 2	write(*,1000) yoff-60.,xoff+xx/2.,' moveto (',
     &                ttl(ix1:ix2),') textc'
	write(*,1002) yoff+yy, xoff+xx, yoff, xoff+xx,
     &                yoff, xoff
 1002	format(' .25 setlinewidth ',
     &         2f8.2,' moveto',2f8.2,' lineto',2f8.2,' lineto'/
     &         ' stroke')
c
c	get axis scalings
	iexpx = 6
	iexpy = 6
	expx = ' '
	if(xanno)
     &  call PS_Scale_Axes(xmn, xmn+8.*xinc, xinc, iexpx, expx, fmtx)
	call PS_Scale_Axes(ymn, ymn+6.*yinc, yinc, iexpy, expy, fmty)
c
c	find title limits in character strings
	do ix1 = 1, 32
	  if(xaxis(ix1:ix1) .ne. ' ') go to 3
	enddo
	ix1 = 31
 3	do ix2 = 32, ix1+1, -1
	  if(xaxis(ix2:ix2) .ne. ' ') go to 4
	enddo
 4	do iy1 = 1, 32
	  if(yaxis(iy1:iy1) .ne. ' ') go to 5
	enddo
	iy1 = 31
 5	do iy2 = 32, iy1+1, -1
	  if(yaxis(iy2:iy2) .ne. ' ') go to 6
	enddo
c
c	write axes titles
 6	if(expx .eq. ' ') then
	  write(*,1003) yoff-34.,xx/2.+xoff,xaxis(ix1:ix2)
 1003	  format(2f8.2,' moveto (',a,') textc')
	else
	  write(*,1003) yoff-34.,xx/2.+xoff,xaxis(ix1:ix2) //
     &	                      expx
	endif
	if(expy .eq. ' ') then
	  write(*,1004) yy/2.+yoff,xoff+8*v2s+24.,yaxis(iy1:iy2)
 1004	  format(2f8.2,' moveto (',a,') textr')
	else
	  write(*,1004) yy/2.+yoff,xoff+8*v2s+24.,
     &                        yaxis(iy1:iy2) // expy
	endif
c
c	place tics and annotate x axis
	do i = 0, 8
	  if(xanno) write(titln,fmtx) (xmn + (8-i)*xinc)/10.**iexpx
	  xx = xoff + i*v2s
	  write(*,1005) yoff, xx
 1005	  format(2f8.2,' moveto -5 0 rlineto -15 0 rmoveto')
c	  if(xanno) write(*,1006) yoff-.25*v2s,xx-.1*v2s,titln
	  if(xanno) write(*,1006) yoff-.25*v2s,xx,titln
 1006	  format(2f8.2,' moveto (',a,') textc')
	enddo
c
c	place tics and annotate y axis
        xx = xoff + 8*v2s
        do i = 0, 6
          write(titln,fmty) (ymn + i*yinc)/10.**iexpy
          yy = yoff + i*v2s
	  write(*,1008) yy, xx
 1008	  format(2f8.2,' moveto 0 5 rlineto -3 5 rmoveto')
	  write(*,1009) yy,xx+.1*v2s,titln
 1009	  format(2f8.2,' moveto (',a,') textr')
	enddo
        write(*,*) ' .5 setlinewidth'
c
	return
	end
 

	subroutine PS_Scale_Axes(amn, amx, ainc, iexpm, exponent, fmt)
c
c	set up for good axis scaling
c
	character*10 fmt, exponent
c
c	Calculate the appropriate exponent
c
	ifig = iexpm
	a = max(abs(amn),abs(amx))
	expm = log10(a)
	iexpm = expm
	exponent = ' '
 	if(expm .lt. 0.0 .and. expm .ne. iexpm) iexpm = iexpm - 1
c
c	Figure out number of significant figures
c
	a = a / 10.**iexpm
	ia = a*1000 + .5
	ia1 = 1000*( ainc/10.**iexpm) + .5
c
c	IA now has the 4 most significant figures of A in it. See if
c	there are some that can be discarded. Also, IA1 has the 4
c	most significant figures of the increment in it.
c
	nfig1 = 4
	nfig = 4
	if(ia1 .lt. 1000) then
	  ia1 = ia1 * 10
	  nfig1 = 5
	endif
	if(mod(ia1,10)   .eq. 0) nfig1 = nfig1 - 1
	if(mod(ia1,100)  .eq. 0) nfig1 = nfig1 - 1
	if(mod(ia1,1000) .eq. 0) nfig1 = nfig1 - 1
	if(mod(ia,10)    .eq. 0) nfig  = 3
	if(mod(ia,100)   .eq. 0) nfig  = 2
	if(mod(ia,1000)  .eq. 0) nfig  = 1
	nfig = max(nfig, nfig1)
c
c	Now see what format we should use for things
c
	if(iexpm .ge. -1 .and. iexpm .le. 2) then
	  nfiguse = min(nfig-iexpm-1, 3)
	  nfiguse = max(nfiguse, 0)
	  iexpm = 0
	else
	  nfiguse = min(nfig, 3)
	  if(iexpm .gt. 9) then
	    write(exponent,'(a7,i2)') ' x 10**',iexpm
	  else if(iexpm .lt. -9) then
	    write(exponent,'(a7,i3)') ' x 10**',iexpm
	  else if(iexpm .lt. 0 .and. iexpm .gt. -10) then
	    write(exponent,'(a7,i2)') ' x 10**',iexpm
	  else
	    write(exponent,'(a7,i1)') ' x 10**',iexpm
	  endif
	endif
	if(amn .lt. 0.0 .or. amx .lt. 0.0) nfiguse = max(1,nfiguse-1)
	if(ifig .eq. 5) then
	  if(nfiguse .gt. 2) nfiguse = nfiguse - 1
	  fmt = '(f5.' // char (48 + nfiguse) // ')'
	else
	  fmt = '(f6.' // char (48 + nfiguse) // ')'
	endif
	return
	end
