#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "../pV3ser.h"


/* this is required so that some systems can init the FORTARN IO subsystem */

#ifdef WIN32

#define MAINPROG main
#define PREFIX   __stdcall

#else

#define PREFIX
#ifdef UNDERSCORE
#ifdef LINUX
#define MAINPROG        MAIN__
#else
#define MAINPROG        MAIN__
#endif
#define PV_SERVERINIT   pv_serverinit_
#define PV_SERVERHSHAKE pv_serverhshake_
#define PV_SERVERDOWN   pv_serverdown_
#else
#define MAINPROG        main
#define PV_SERVERINIT   pv_serverinit
#define PV_SERVERHSHAKE pv_serverhshake
#define PV_SERVERDOWN   pv_serverdown
#endif
#endif

#ifdef SUN
#define MAINPROG        main
#endif


  extern void PREFIX PV_SERVERINIT   ( int *stat );
  extern void PREFIX PV_SERVERHSHAKE ( int *stat );
  extern void PREFIX PV_SERVERDOWN   ( int *stat );


void
MAINPROG()
{
  void  *ex, *nextex;
  int   istat, i, ivec[11], type, exnum, cnt, first;
  float rvec[12];
  char  exname[20];

  PV_SERVERINIT(&istat);
  if (istat != 0) {
    printf(" PV_SERVERINIT return = %d\n", istat);
    exit(1);
  }
  first = -1;

again:

  first++;
  if (first == 0) {
    ex = NULL;
#ifdef WIN32
    PV_GETEXTRACT(&ex, &type, &exnum, ivec, rvec, exname, 20, &nextex);
#else
    PV_GETEXTRACT(&ex, &type, &exnum, ivec, rvec, exname, &nextex, 20);
#endif
    while (ex != NULL) {
#ifdef WIN32
      PV_GETEXTRACT(&ex, &type, &exnum, ivec, rvec, exname, 20, &nextex);
#else
      PV_GETEXTRACT(&ex, &type, &exnum, ivec, rvec, exname, &nextex, 20);
#endif
      for (i = 0; i < 20; i++) printf("%c", exname[i]);
      printf("  type = %d,   num = %d\n", type, exnum);
      ex = nextex;
    }
    printf("\n");
  }

  cnt = 0;
  do {
    /* do something */

/*  sleep(1);  */
/*  sginap(1); */

    PV_SERVERHSHAKE(&istat);
    cnt++;
  } while (istat == 0);

  if (istat > 0) {
    i = -2;
    PV_GETSTATE(&i, ivec, rvec, exname, 20);
    printf(" Time = %f  %d\n", rvec[0], cnt);
    if (rvec[0] > 10.0) PV_SERVERDOWN(&istat);
    goto again;
  }

  printf(" ..sleeping...");
#ifdef WIN32
  Sleep(10000);
#else
  sleep(10);
#endif
  printf(" waking\n");

  PV_SERVERINIT(&istat);
  if (istat != 0) {
    printf(" PV_SERVERINIT return = %d\n", istat);
    exit(1);
  }
  first = -1;
  goto again;
}
