/*
 *	pV3 Servers Include
 *
 *	Allows WS/machine dependent stuff to work with FORTRAN
 *
 *	Copyright 1995 - 2001, Massachusetts Institute of Technology.
 */

/*
 *      pV3ser.h
 *
 *
$Log$
 */

#ifndef _PV3S_H_

#define _PV3S_H_


/* routine definitions */

#ifdef WIN32

#define PREFIX __stdcall

#else

#ifdef ABSOFT
#define PREFIX __cdecl
#else
#define PREFIX
#endif

#ifdef UNDERSCORE

#define PV_CURSOR      pv_cursor_
#define PV_GETPOINTER  pv_getpointer_
#define PV_GETSTATE    pv_getstate_
#define PV_SETSTATE    pv_setstate_
#define PV_REGISTER    pv_register_
#define PV_GETEXTRACTG pv_getextractg_
#define PV_GETEXTRACT  pv_getextract_
#define PV_GETSUBG     pv_getsubg_
#define PV_GETSUB      pv_getsub_
#define PV_SETSUB      pv_setsub_
#define PV_CLEARSUB    pv_clearsub_
#define PV_SETEXMASK   pv_setexmask_
#define PV_SETINSMASK  pv_setinsmask_
#define PV_SETEXCOLOR  pv_setexcolor_
#define PV_SENDDATA    pv_senddata_
#define PV_OBJECT3D    pv_object3d_
#define PV_OBJECT2D    pv_object2d_
#define PV_LINE        pv_line_
#define PV_LINECOLOR   pv_linecolor_
#define PV_ANNOTATE3D  pv_annotate3d_
#define PV_ANNOTATE2D  pv_annotate2d_
#define PV_DISCIPSTAT  pv_discipstat_
#define PV_CLIENTSTAT  pv_clientstat_
#define PV_FIELDSTAT   pv_fieldstat_
#define PV_CUTSTAT     pv_cutstat_
#define PV_SETDISCIP   pv_setdiscip_
#define PV_SETEXSTATE  pv_setexstate_
#define PV_CREXTRACT   pv_crextract_
#define PV_DEEXTRACT   pv_deextract_
#define PV_PICK        pv_pick_
#define PV_SETPICMASK  pv_setpicmask_
#define PV_GETPICMASK  pv_getpicmask_
#define PV_SELECT      pv_select_
#define PV_PAUSE       pv_pause_
#define pV_DYNTOOL     pv_dyntool_
#define PVEVENTS       pvevents_
#define PVSAFE         pvsafe_
#define PVSETEXTRACT   pvsetextract_
#define PVSEND         pvsend_
#define PVDRAW3D       pvdraw3d_
#define PVDRAW2D       pvdraw2d_
#define PVDRAW1D       pvdraw1d_
#define PVDRAWKEY      pvdrawkey_
#define PVPROBE        pvprobe_
#define PVINIT         pvinit_
#define PVRUBBER       pvrubber_
#define PVCONVERT      pvconvert_
#define PVRENDER       pvrender_
#define PVPICKED       pvpicked_
#define PVFILLPOINTS   pvfillpoints_

#else

#define PV_CURSOR      pv_cursor
#define PV_GETPOINTER  pv_getpointer
#define PV_GETSTATE    pv_getstate
#define PV_SETSTATE    pv_setstate
#define PV_REGISTER    pv_register
#define PV_GETEXTRACTG pv_getextractg
#define PV_GETEXTRACT  pv_getextract
#define PV_GETSUBG     pv_getsubg
#define PV_GETSUB      pv_getsub
#define PV_SETSUB      pv_setsub
#define PV_CLEARSUB    pv_clearsub
#define PV_SETEXMASK   pv_setexmask
#define PV_SETINSMASK  pv_setinsmask
#define PV_SETEXCOLOR  pv_setexcolor
#define PV_SENDDATA    pv_senddata
#define PV_OBJECT3D    pv_object3d
#define PV_OBJECT2D    pv_object2d
#define PV_LINE        pv_line
#define PV_LINECOLOR   pv_linecolor
#define PV_ANNOTATE3D  pv_annotate3d
#define PV_ANNOTATE2D  pv_annotate2d
#define PV_DISCIPSTAT  pv_discipstat
#define PV_CLIENTSTAT  pv_clientstat
#define PV_FIELDSTAT   pv_fieldstat
#define PV_CUTSTAT     pv_cutstat
#define PV_SETDISCIP   pv_setdiscip
#define PV_SETEXSTATE  pv_setexstate
#define PV_CREXTRACT   pv_crextract
#define PV_DEEXTRACT   pv_deextract
#define PV_PICK        pv_pick
#define PV_PAUSE       pv_pause
#define pV_DYNTOOL     pv_dyntool
#define PV_SETPICMASK  pv_setpicmask
#define PV_GETPICMASK  pv_getpicmask
#define PV_SELECT      pv_select
#define PVEVENTS       pvevents
#define PVSAFE         pvsafe
#define PVSETEXTRACT   pvsetextract
#define PVSEND         pvsend
#define PVDRAW3D       pvdraw3d
#define PVDRAW2D       pvdraw2d
#define PVDRAW1D       pvdraw1d
#define PVDRAWKEY      pvdrawkey
#define PVPROBE        pvprobe
#define PVINIT         pvinit
#define PVRUBBER       pvrubber
#define PVCONVERT      pvconvert
#define PVRENDER       pvrender
#define PVPICKED       pvpicked
#define PVFILLPOINTS   pvfillpoints

#endif
#endif


#ifdef __ProtoGlarp__
#undef __ProtoGlarp__
#endif
#if defined(__STDC__) || defined(__cplusplus) || defined(WIN32)
#define __ProtoGlarp__(x) x
#else
#define __ProtoGlarp__(x) ()
#endif

#ifdef __cplusplus
extern "C" {
#endif

void	PREFIX
        PV_CURSOR __ProtoGlarp__(( int *flag ));
void	PREFIX
        PV_GETPOINTER __ProtoGlarp__(( int *opt, void **ptr ));
void	PREFIX
        PV_GETSTATE __ProtoGlarp__(( int *opt, int *ivec, float *rvec,
	                             char *string, int stringLEN ));
void	PREFIX
        PV_SETSTATE __ProtoGlarp__(( int *opt, int *ivec, float *rvec,
	                             char *string, int stringLEN ));
int	PREFIX
        PV_GETSUBG __ProtoGlarp__(( void **ex, int *subex, int *numcs,
	                            void **ptr, int *len, int *cid ));
int	PREFIX
        PV_GETSUB __ProtoGlarp__(( void **ex, int *subex, int *numcs,
	                           void **ptr, int *len, int *cid ));
int	PREFIX
        PV_SETSUB __ProtoGlarp__(( void **ex, int *subex, int *numcs,
	                           int *len ));
void	PREFIX
        PV_CLEARSUB __ProtoGlarp__(( void **ex, int *subex, int *numcs ));
void	PREFIX
        PV_SETEXMASK __ProtoGlarp__(( void **ex, int *mask ));
void	PREFIX
        PV_SETINSMASK __ProtoGlarp__(( void **ex, int *mask ));
void	PREFIX
        PV_SETEXCOLOR __ProtoGlarp__(( void **ex, float *color ));
void	PREFIX
	PV_SENDDATA __ProtoGlarp__(( int *did, int *cid, int *mid,
				     int *nint, int *ints, int *nfloat,
				     float *floats, int *nchar, char *chars ));
void	PREFIX
        PV_OBJECT3D __ProtoGlarp__(( int *type, int *color, float *xyzp,
	                             float *radii, float *col, int *np ));
void	PREFIX
        PV_OBJECT2D __ProtoGlarp__(( int *type, int *color, float *xyw,
	                             float *col, int *np ));
void	PREFIX
        PV_LINE __ProtoGlarp__(( float *x, float *y, int *np ));
void	PREFIX
        PV_LINECOLOR __ProtoGlarp__(( float *color ));
void	PREFIX
        PV_ANNOTATE3D __ProtoGlarp__(( int *FID, float *color, float *size,
                                       float *width, float *xyz, float *norx,
                                       float *nory, char *str, int strLEN ));
void	PREFIX
        PV_ANNOTATE2D __ProtoGlarp__(( int *FID, float *color, float *size,
                                       float *width, float *xyw, float *angle,
                                       char *str, int strLEN ));
void	PREFIX
        PV_DISCIPSTAT __ProtoGlarp__(( int *did, int *nid, int *ncl,
                                       char *dname, int dnameLEN ));
void	PREFIX
        PV_CLIENTSTAT __ProtoGlarp__(( int *did, int *cid, int *opt, int *ncl,
                                       int *on, char *cname, int cnameLEN ));
void	PREFIX
        PV_FIELDSTAT __ProtoGlarp__(( int *did, int *fid, int *nfl, int *fty,
                                      float *flims, char *fname ));
void	PREFIX
        PV_CUTSTAT __ProtoGlarp__(( int *did, int *cin, int *nct,
                                    char *ctitle, int ctitleLEN ));
void	PREFIX
        PV_SETDISCIP __ProtoGlarp__(( int *did ));
void	PREFIX
        PV_SETEXSTATE __ProtoGlarp__(( void **ex, int *pltmask, int *scalar,
                                       int *vector, int *thres ));
void	PREFIX
        PV_DEEXTRACT __ProtoGlarp__(( void **ex ));
void	PREFIX
        PV_PICK __ProtoGlarp__(( int *all ));
void	PREFIX
        PV_SETPICMASK __ProtoGlarp__(( void **ex, int *mask ));
void	PREFIX
        PV_GETPICMASK __ProtoGlarp__(( void **ex, int *mask, int *all ));
void	PREFIX
        PV_SELECT __ProtoGlarp__(( int *bit ));
void	PREFIX
	PV_PAUSE __ProtoGlarp__(( int *istat ));
void	PREFIX
	PV_DYNTOOL __ProtoGlarp__(( int *did, int *ifn, int *ipmsk, int *ivec,
                                    float *rvec, int *istat ));

void	PREFIX
        PVEVENTS __ProtoGlarp__(( void **win, int *type, int *xe, int *ye,
	                          int *state ));
void	PREFIX
        PVSAFE __ProtoGlarp__(( ));
void	PREFIX
        PVSETEXTRACT __ProtoGlarp__(( int *index, int *exnum, int *plotmask,
	                              int *reqmask, int *ival, float *rvec ));
void	PREFIX
        PVSEND __ProtoGlarp__(( int *did));
void	PREFIX
        PVDRAW3D __ProtoGlarp__(( int *stat ));
void	PREFIX
        PVDRAW2D __ProtoGlarp__(( int *stat ));
void	PREFIX
        PVDRAW1D __ProtoGlarp__(( int *stat ));
void	PREFIX
        PVDRAWKEY __ProtoGlarp__(( int *stat ));
#ifdef WIN32
void	PREFIX
        PVPROBE __ProtoGlarp__(( int *flag, char *xaxis, int xaxisLEN,
                                 char *yaxis, int yaxisLEN ));
#else
void	PREFIX
        PVPROBE __ProtoGlarp__(( int *flag, char *xaxis, char *yaxis,
	                         int xaxisLEN, int yaxisLEN ));
#endif
void	PREFIX
        PVINIT __ProtoGlarp__(( int *npix1, int *nsx1, int *nsy1,
	                        int *npix2, int *nsx2, int *nsy2,
	                        int *npix3, int *nsx3, int *nsy3 ));
void	PREFIX
        PVRUBBER __ProtoGlarp__(( int *WinID, int *type ));
void	PREFIX
        PVCONVERT __ProtoGlarp__(( char *dis, int *rank, int *len, float *xyz,
                                   float *sv, int *iscl, float *s, int *ivct,
                                   float *v, int *ithr, float *t, int disLEN ));
void	PREFIX
        PVRENDER __ProtoGlarp__(( float *time ));
void	PREFIX
        PVPICKED __ProtoGlarp__(( void **ex, float *xyz, int *rep, int *bit,
                                  int *isub, int *index, int *state ));
void	PREFIX
        PVFILLPOINTS __ProtoGlarp__(( void **ex, int *num, int *type, int *len,
                                      int *cc, float *xyz, char *en, int enLEN ));

#ifdef WIN32
void *	__stdcall
        PV_CREXTRACT __ProtoGlarp__(( int *type, char *name, int nameLEN,
                                      int *ivec, float *rvec, int *exnum ));
void *	__stdcall
        PV_REGISTER __ProtoGlarp__(( int *index, char *name, int nameLEN, 
                                     int *subtype, int *subsize, int *subopt,
	                             int *subloc, void (*routine)(int *stat,
	                         int *exn, int *mask, int *cid, int *cnt,
	                         int *len0, void *sub0, int *len1, void *sub1,
	                         int *len2, void *sub2, int *len3, void *sub3,
	                         int *len4, void *sub4, int *len5, void *sub5,
	                         int *len6, void *sub6, int *len7, void *sub7,
	                         int *len8, void *sub8, int *len9, void *sub9,
	                         int *lenA, void *subA, int *lenB, void *subB),
	                             int *exnum ));
void	__stdcall
        PV_GETEXTRACTG __ProtoGlarp__(( void **ex, int *type, int *num,
	                                int *ivec, float *rvec, char *name,
	                                int nameLEN, void **nextex ));
void	__stdcall
        PV_GETEXTRACT __ProtoGlarp__(( void **ex, int *type, int *num,
	                               int *ivec, float *rvec, char *name,
	                               int nameLEN, void **nextex ));
#else
void *	PREFIX
        PV_CREXTRACT __ProtoGlarp__(( int *type, char *name, int *ivec, 
                                      float *rvec, int *exnum, int nameLEN ));
void *	PREFIX
        PV_REGISTER __ProtoGlarp__(( int *index, char *name, int *subtype,
	                             int *subsize, int *subopt,
	                             int *subloc, void (*routine)(int *stat,
	                         int *exn, int *mask, int *cid, int *cnt,
	                         int *len0, void *sub0, int *len1, void *sub1,
	                         int *len2, void *sub2, int *len3, void *sub3,
	                         int *len4, void *sub4, int *len5, void *sub5,
	                         int *len6, void *sub6, int *len7, void *sub7,
	                         int *len8, void *sub8, int *len9, void *sub9,
	                         int *lenA, void *subA, int *lenB, void *subB),
	                             int *exnum, int nameLEN ));
void	PREFIX
        PV_GETEXTRACTG __ProtoGlarp__(( void **ex, int *type, int *num,
	                                int *ivec, float *rvec, char *name,
	                                void **nextex, int nameLEN ));
void	PREFIX
        PV_GETEXTRACT __ProtoGlarp__(( void **ex, int *type, int *num,
	                               int *ivec, float *rvec, char *name,
	                               void **nextex, int nameLEN ));
#endif

#ifdef __cplusplus
}
#endif

#endif  /*_PV3S_H_*/
