        subroutine pvevents(iwin, itype, ie, je, istate)
c
c       Programmed Events Loop - Check and use appropriate events
c
c         called right after the event is pulled of the queue,
c         therefore if this routine changes the event info, pV3
c         uses the changed data.  events can be ignored by resetting
c         the window id to -1/0.  use pv_getpointer(...) to get
c         window data.
c
c       where:  iwin    - X window id of event
c                         -1 - no event and break out of event collection
c                          0 - no event but continue in tight loop
c               itype   - type of X event
c                          2 - KeyPress
c                          3 - KeyRelease
c                          4 - ButtonPress
c                          5 - ButtonRelease
c               ie      - x pixel number
c               je      - y pixel number
c               istate  - state info (key stroke or button #)
c
        save         keybin, winid, first, lineout
        integer*8    winid(4), iwin
	integer      keybin(32)
	character*80 cstr
        logical      first
        data first/.true./, lineout/0/
c
c       the first time in - get window ids and special key bindings
        if(first) then
          call pv_getpointer(2, winid(2))
          call pv_getpointer(3, winid(3))
          call pv_getpointer(4, winid(4))
          call pv_getstate(-1, keybin, rvec, cstr)
          first = .false.
        endif
c
c	2D window event
	if(iwin .eq. winid(2)) then
          if(itype .eq. 4 .and. istate .eq. 2) then
	    call XFtnSDialFun(iwin, ie, je, 2, lineout)
	    iwin = 0
          endif
          if(itype .eq. 5 .and. istate .eq. 2) then
	    call XFtnSDialFun(iwin, ie, je, 0, lineout)
	    iwin = 0
          endif
c	  replace middle mouse with "s"
	  if(itype .eq. 2 .and. istate .eq. ichar('s')) then
	    itype  = 4
	    istate = 2
	  endif
        endif
c
c	3D window event
	if(iwin .eq. winid(3)) then
          if(itype .eq. 4 .and. istate .eq. 2) then
	    call XFtnSDialFun(iwin, ie, je, 3, lineout)
	    iwin = 0
          endif
          if(itype .eq. 5 .and. istate .eq. 2) then
	    call XFtnSDialFun(iwin, ie, je, 0, lineout)
	    iwin = 0
          endif
        endif
c
c	Dials window event
	if(iwin .eq. winid(4)) then
	  if(itype .eq. 2 .and. istate .eq. ichar('O')) then
	    lineout = lineout + 1
	    if(lineout .gt. 1) lineout = 0
	    if(lineout .eq. 0) then
	      write(*,*) ' Outline mode: Off!'
	    else
	      write(*,*) ' Outline mode: On!'
	    endif
	    write(*,*) ' '
	  endif
	endif
c
	return
	end
