/*
 * dials.c
 *
 * Xlib/dial-box interface for the SGI and Visual3
 *
 * Copyright 1990 - 1996, Massachusetts Institute of Technology.
 *
 */

#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XInput.h>

#ifdef UNDERSCORE

#define XFTNINITDIAL xftninitdial_
#define XFTNGETDIALS xftngetdials_

#else

#define XFTNINITDIAL xftninitdial
#define XFTNGETDIALS xftngetdials

#endif

  extern Display *XFtnDpy;
  XDevice *XFtnDDev = NULL;
  int XFtnDVals[8] = {0,0,0,0,0,0,0,0};

int
XFTNINITDIAL()
{
  int              i, stat, ndevices;
  XDeviceInfoPtr   list, slist;

  if (XFtnDDev != NULL) return 1;
  list = (XDeviceInfoPtr) XListInputDevices (XFtnDpy, &ndevices);
  stat  = 0;
  slist = list;
  for (i=0; i<ndevices; i++, list++) {
    if (strcmp("dial+buttons", list->name) == 0) {
      stat = 1;
      XFtnDDev = XOpenDevice(XFtnDpy, list->id);
      XSetDeviceValuators(XFtnDpy, XFtnDDev, XFtnDVals, 0, 8);
    }
  }

  XFreeDeviceList(slist);
  return stat*200;
}


int
XFTNGETDIALS(drev)
  int drev[];

{
  int            j, k, ret, rev[8];
  XDeviceState   *sstate;
  XInputClass    *anystate;
  XKeyState      *kdata;
  XButtonState   *bdata;
  XValuatorState *vdata;

  ret = 0;
  if (XFtnDDev == NULL) return ret;

  sstate = XQueryDeviceState(XFtnDpy, XFtnDDev);
  anystate = sstate->data;
  for (j=0; j<sstate->num_classes; j++) {
    switch (anystate->class) {
    case KeyClass:
      kdata    = (XKeyState *) anystate;
      anystate = (XInputClass *) ++kdata;
      break;
    case ButtonClass:
      bdata    = (XButtonState *) anystate;
      anystate = (XInputClass *) ++bdata;
      break;
    case ValuatorClass:
      vdata = (XValuatorState *) anystate;
      for (k=0; k<vdata->num_valuators; k++) {
        rev[k]       = *(vdata->valuators+k) - XFtnDVals[k];
        XFtnDVals[k] = *(vdata->valuators+k);
        if (rev[k] >  800) rev[k] = 0;
        if (rev[k] < -800) rev[k] = 0;
        if (rev[k] != 0) ret = 1;
      }
      drev[0] = rev[6];
      drev[1] = rev[4];
      drev[2] = rev[2];
      drev[3] = rev[0];
      drev[4] = rev[7];
      drev[5] = rev[5];
      drev[6] = rev[3];
      drev[7] = rev[1];
      anystate = (XInputClass *) ++vdata;
      break;
    }
  }

  XFreeDeviceState(sstate);
  return ret;
}


void
xftnDialEvent()
{

}


void
xftnSetDialEvent(window)
  Window window;
{

}
