/*
 * dials.c
 *
 * dummy Xlib/dial-box interface for Visual3/pV3
 *
 * Copyright 1995 - 1996, Massachusetts Institute of Technology.
 *
 */

#include <stdio.h>
#include <X11/Xlib.h>


#ifdef UNDERSCORE

#define XFTNINITDIAL xftninitdial_
#define XFTNGETDIALS xftngetdials_

#else

#define XFTNINITDIAL xftninitdial
#define XFTNGETDIALS xftngetdials

#endif


/* extrenals */

  extern Display *XFtnDpy;                 /* X Display */
  extern XEvent   XFtnXEvent;              /* X Event used */


/* dialbox numbering:   0    4
 *                      1    5
 *                      2    6
 *                      3    7
 */

  int XFtnDVals[8] = {0, 0, 0, 0, 0, 0, 0, 0};


/* 
 * code used to:
 *   1) check for the existance of the device(s)
 *   2) initialize the device(s)
 *   3) return status - 0 no device
 *                      non-zero -- the number of counts per revolution
 */

int
XFTNINITDIAL()
{
  return 0;
}


/* 
 * return the current device counts per dial (in the order above) -- drev
 * the routine returns 0 if all counts are zero, non-zero otherwise
 */

int
XFTNGETDIALS(drev)
  int drev[];
{
  int k, ret;

  ret = 0;
  for (k = 0; k < 8; k++) {
    drev[k] = XFtnDVals[k];
    if (drev[k] != 0) ret = 1;
    XFtnDVals[k] = 0;
  }
  return ret;
}


/*
 * internal routine that gets called when an X event occurs that
 * Visual3/pV3 does not recognize
 *
 * query XFtnXEvent for the event attributes  -- is it from the device?
 * XFtnDVals should be adjusted to account for the event
 */

void
xftnDialEvent()
{
}


/*
 * internal routine that allows other events to occur in a
 * Visual3/pV3 window
 * 
 * this routine is called after the creation of each window
 */

void
xftnSetDialEvent(window)
  Window window;
{
}
