#include <stdio.h>
#include <stdlib.h>
#include "wsdepend.h"

/*
 *  An example that modifies pV3Server or pV3Batch to allow
 *  Vector Clouds to be turned on at startup
 *
 *  Similar code can be used to set the attributes of any extract.
 *
 *  This routine must be compiled with:
 *     -DUNDERSCORE	for SGI and ALPHA machines
 *
 *  then linked with the appropriate objects and libraries as seen in
 *  the sub-driectories here or in "modules"
 *
 */

#define VCLOUD 20

void
PVSAFE()
{
  int   type, num, ivec[11];
  float rvec[12];
  char  name[20];
  void  *ex, *nextex;

  static int first = 0;

  /* ignore things the first time through */

  first++;
  if (first == 1) return;

  /* loop through all extracts looking for Vector Clouds */
  ex = NULL;
next:
#ifdef WIN32
  PV_GETEXTRACT(&ex, &type, &num, ivec, rvec, name, 20, &nextex);
#else
  PV_GETEXTRACT(&ex, &type, &num, ivec, rvec, name, &nextex, 20);
#endif

  /* OK - got it, now set the mask */
  if (type == VCLOUD) {
    num = 1;
    PV_SETEXMASK(&ex, &num);
    return;
  }

  /* look at the next extract */
  ex = nextex;
  if (ex != NULL) goto next;
}
