#include "parameters.h"
#define FLOW pfw(itime)%
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
MODULE calc_dens
  IMPLICIT NONE

CONTAINS

!#######################################################################
  SUBROUTINE ScalDensity(v,mvmax)
!#######################################################################
    USE common_area, ONLY: pfw, itime, rhoref
  
    REAL,INTENT(OUT) :: v(*)
    INTEGER,INTENT(IN) :: mvmax
    INTEGER k

    DEBUG3('     \ ScalDensity')
    CALL Calc_Density
    DO k = 1, mvmax
      v(k) = rhoref * FLOW r(k)
    ENDDO
    DEBUG3('     / ScalDensity')
  
  END SUBROUTINE

!#######################################################################
  SUBROUTINE Calc_Density()
!#######################################################################
    USE common_area, ONLY: pfw, itime, cur

    IF(.NOT. ASSOCIATED(FLOW r))THEN
    ENDIF

    cur(itime)%v => FLOW r

  END SUBROUTINE Calc_Density

END MODULE calc_dens
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
