#include "parameters.h"
#define FLOW pfw(itime)%
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
MODULE calc_ener
  IMPLICIT NONE
CONTAINS
!#######################################################################
  SUBROUTINE ScalEnergy(v, key, mvmax)
!#######################################################################
    USE common_area, ONLY: pfw, itime, rhoref, vref
    USE mod_events, ONLY: event_get_secondary

    INTEGER,INTENT(IN) :: key,mvmax
    REAL,INTENT(INOUT) :: v(*)
    INTEGER :: k
    REAL,POINTER,DIMENSION(:) :: ptr

    SELECT CASE(event_get_secondary(key))
      CASE(2)
        DO k = 1, mvmax
          v(k) = FLOW e(k) * FLOW r(k) * rhoref * vref**2
        ENDDO
        RETURN
      CASE(1) 
        CALL Calc_Energy
        ptr => FLOW e
      CASE DEFAULT
        RETURN
    END SELECT
    DO k = 1, mvmax
      v(k) = ptr(k) * vref**2
    ENDDO
    NULLIFY(ptr)

  END SUBROUTINE ScalEnergy

!#######################################################################
  SUBROUTINE Calc_Energy()
!#######################################################################
    USE common_area, ONLY: pfw, itime, cur, pgr, igrid
    USE calc_gas,  ONLY: Calc_Gamma

    INTEGER m, mvmax

    IF(.NOT. ASSOCIATED(FLOW e))THEN
      IF(.NOT. ASSOCIATED(FLOW g))CALL Calc_Gamma

      mvmax=pgr(igrid)%tpts
      ALLOCATE(FLOW e(mvmax))
      DO m=1,mvmax
        FLOW e(m) = 1./(FLOW g(m)-1.)*FLOW p(m)/FLOW r(m)
      ENDDO
    ENDIF

    cur(itime)%v => FLOW e
  
  END SUBROUTINE Calc_Energy
END MODULE calc_ener
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
