#define FLOW pfw(itime)%
MODULE calc_gas
  IMPLICIT NONE

CONTAINS
!#######################################################################
  SUBROUTINE Calc_Gamma()
!#######################################################################
!!! This routine is currently forcing the Rgas to be a constant!!!
    USE common_area

    INTEGER k,mvmax
    REAL tm,g1,g2,t1,t2

    IF(.NOT. ASSOCIATED(FLOW g))THEN
      mvmax=pgr(igrid)%tpts
      ALLOCATE(FLOW g(mvmax))

      g1=gamtable(1)
      g2=gamtable(2)
      t1=tref*tempgam(1)
      t2=tref*tempgam(2)

      IF(.NOT. ASSOCIATED(FLOW p))THEN
        DO k=1,mvmax
          FLOW g(k) = gammabase
        ENDDO
      ELSE
        DO k=1,mvmax
          tm=FLOW p(k) / (FLOW r(k) * rgasref) * pref/rhoref
          FLOW g(k) = g1 + (g2-g1) / (t2-t1) * (tm-t1)
        ENDDO
      ENDIF
    ENDIF

    cur(itime)%v => FLOW g

  END SUBROUTINE Calc_Gamma
END MODULE calc_gas
