#include "parameters.h"
!###########################################################
SUBROUTINE WriteColFile(iopt)
!###########################################################
!
! ARGUMENTS
! ----------------------------------------------------------
! NAME      TYPE    DESCRIPTION
! --------- ------- ----------------------------------------
! iopt      INT*4   On input, flag to pick which color file
!                   to write.  On output, flag returns the
!                   outcome of the file write.
!
  IMPLICIT NONE

  INTEGER,INTENT(INOUT) :: iopt

  SELECT CASE(iopt)
    CASE DEFAULT
      CALL WriteColFile_Spec(iopt)
  END SELECT

END SUBROUTINE WriteColFile

!###########################################################
SUBROUTINE WriteColFile_Spec(iopt)
!###########################################################
  IMPLICIT NONE

  INTEGER,INTENT(INOUT) :: iopt
  INTEGER :: i
  REAL :: red,green,blue
  LOGICAL :: ios

  iopt=0
  INQUIRE(FILE='spec.col',EXIST=ios)
  IF(ios)THEN
    WRITE(*,*) 'Color file exists'
    iopt=-1
  ELSE
    OPEN(UNIT=COLUNIT,FILE='spec.col',FORM='formatted')
    WRITE(COLUNIT,6000) 256,4
    red = 0.
    blue = 1.
    DO i = 1, 64
      green = FLOAT(i-1)/FLOAT(64)
      WRITE(COLUNIT,6001) red, green, blue
    ENDDO
    green = 1.
    DO i = 1, 64
      blue = 1.-FLOAT(i)/FLOAT(64)
      WRITE(COLUNIT,6001) red, green, blue
    ENDDO
    blue = 0.
    green = 1.
    DO i = 1, 64
      red = FLOAT(i-1)/FLOAT(64)
      WRITE(COLUNIT,6001) red, green, blue
    ENDDO
    red = 1.
    DO i = 1, 64
      green = 1.-FLOAT(i-1)/FLOAT(64)
      WRITE(COLUNIT,6001) red, green, blue
    ENDDO

    WRITE(COLUNIT,6001) 0.,0.,0.
    DO i = 1, 3
      WRITE(COLUNIT,6001) 1.,1.,1.
    ENDDO
    CLOSE(COLUNIT)
  ENDIF

  RETURN

6000 FORMAT(2I4)
6001 FORMAT(3F8.5)

END SUBROUTINE WriteColFile_Spec
