#include "parameters.h"
!#######################################################################
SUBROUTINE ControlPanel(isstat)
!#######################################################################
  USE keydata
# ifdef PV3SERIAL
    USE readflow, ONLY: ReloadFlow
# else
!    USE journal_common, ONLY: FinalizeJournal, CopyJournal
# endif
  USE server_common, ONLY: cftoggle, cltoggle, clnlevels, cllocation, povteccombined, clsize
  IMPLICIT NONE

  INTEGER,INTENT(OUT) :: isstat
  INTEGER :: iopt2=0, istat=0
  CHARACTER(LEN=1) :: iopt=' '
  CHARACTER(LEN=MAXSTRLEN) :: cmdstr=' '

  isstat=0

  WRITE(*,*) '  Enter control panel option:'
  WRITE(*,*) ' r  Reload grid or flow'
  WRITE(*,*) ' s  Run a script, demo, or journal'
  WRITE(*,*) ' w  Write a journal file'
  WRITE(*,*) ' v  Set server variables'

  READ(*,*) iopt
  WRITE(*,*) ' '

  SELECT CASE(iopt)
    CASE('r')
! Reload grid or flow
      WRITE(*,*) '  Enter option for data reloading:'
      WRITE(*,*) ' 1. Reload GRID'
      WRITE(*,*) ' 2. Reload FLOW'
      READ(*,*) reloadstatus
      IF(reloadstatus.EQ.1 .OR. reloadstatus.EQ.2)THEN
        WRITE(*,*) '  Enter new file name:'
        READ(*,*) keyfilename
#       ifdef PV3SERIAL
          CALL ReloadFlow(keyfilename)
          isstat=1
#       endif
      ENDIF
      
    CASE('s')
      WRITE(*,*) '  Enter script type:'
      WRITE(*,*) ' 1. Image processing script'
      WRITE(*,*) ' 2. Journal execution'
      WRITE(*,*) ' 3. Demo execution'
      READ(*,*) iopt2
      WRITE(*,*) '  Enter name of script file: [default script.dat/journal.jnl/demo.out]'
      READ(*,"(A80)") scriptfilename
      SELECT CASE(iopt2)
        CASE(1)
          IF(TRIM(ADJUSTL(scriptfilename)).EQ.'')scriptfilename='script.dat'
          OPEN(UNIT=IMAGEUNIT, FILE=scriptfilename)
          isprocess = .TRUE.

        CASE(2)
          IF(TRIM(ADJUSTL(scriptfilename)).EQ.'')scriptfilename='journal.jnl'
          OPEN(UNIT=JOURNALIUNIT, FILE=scriptfilename)
          joprocess = .TRUE.
         
        CASE(3)
          IF(TRIM(ADJUSTL(scriptfilename)).EQ.'')scriptfilename='demo.out'
 
        CASE DEFAULT
          WRITE(*,*) ' Invalid option.'

      END SELECT
       
    CASE('w')
#ifndef PV3SERIAL
!      WRITE(*,*) '  Enter journal name: [default journal.jnl]'
!      READ(*,"(A80)") scriptfilename
!      IF(TRIM(ADJUSTL(scriptfilename)).EQ.'')scriptfilename='journal.jnl'
!      CALL CopyJournal( scriptfilename )
!      CALL FinalizeJournal( 1, scriptfilename )
      scriptfilename=''
#endif

    CASE('v')
      WRITE(*,*) '  Enter server variable to modify:'
      WRITE(*,*) ' 1. POV files (combined T/uncombined F) ',povteccombined
      WRITE(*,*) ' 2. Reference coordinate frame ',cftoggle
      WRITE(*,*) ' 3. Contour legend ',cltoggle
      WRITE(*,*) ' 4. Contour legend number of divisions ',clnlevels
      WRITE(*,*) ' 5. Contour legend orientation ',cllocation
      WRITE(*,*) ' 6. Contour legend size ',clsize
      READ(*,*) iopt2
      SELECT CASE(iopt2)
        CASE(1)
          povteccombined = .NOT. povteccombined
        CASE(2)
          cftoggle = .NOT. cftoggle
        CASE(3)
          cltoggle = .NOT. cltoggle
        CASE(4)
          WRITE(*,*) '   Enter new number of divisions:'
          READ(*,*) clnlevels
        CASE(5)
          WRITE(*,*) '   (negative is horizontal, positive is vertical)'
          WRITE(*,*) '   1 - top right'
          WRITE(*,*) '   2 - bottom right'
          WRITE(*,*) '   3 - bottom left'
          WRITE(*,*) '   4 - top left'
          READ(*,*) cllocation
        CASE(6)
          WRITE(*,*) '   Enter new size of contour legend:'
          READ(*,*) clsize
        CASE DEFAULT
          RETURN
      END SELECT

    CASE DEFAULT
      WRITE(*,*) ' Unknown option ',iopt

  END SELECT 

END SUBROUTINE ControlPanel
