PROGRAM gridprog
  USE common_area
  USE readgrid
  USE general, ONLY: iblck

  IMPLICIT NONE

  INTEGER :: i, j, k, r, nblks
  INTEGER :: iface, jface, kface, surfpts
  INTEGER :: tol, beqcntr

  CHARACTER(LEN=80) :: filnm

  gridarr(1) = 'noz1-run3.plt3d-grd'
  filnm="noz1-run3.conn"

  ngrid = 1
  ALLOCATE(pgr(ngrid))
  CALL Init_Pgr()
  CALL Rd_P3DT_Grd(gridarr(1),1)

  PRINT*,' The total number of points is:',pgr(1)%tpts
  PRINT*,' The total number of blocks is:',pgr(1)%nblks,  iblck

! I indices are stored in pgr(1)%li(1:nblks)
! J indices are stored in pgr(1)%lj(1:nblks)
! K indices are stored in pgr(1)%lk(1:nblks)

  surfpts=0
  DO i=1,pgr(1)%nblks
    iface=2*pgr(1)%lj(i)*pgr(1)%lk(i)
    jface=2*pgr(1)%li(i)*pgr(1)%lk(i)
    kface=2*pgr(1)%li(i)*pgr(1)%lj(i)
    surfpts=surfpts+iface+jface+kface
  ENDDO 

  PRINT*, ' The total number of surface points is:', surfpts

  
  CALL parsesub2(filnm)

  CALL equivsub

  tol=0.00001
  CALL fillequiv(tol,beqcntr)

END PROGRAM gridprog
