!#######################################################################
SUBROUTINE ImageScriptProcessBatch(iwin, itype, ie, je, istate, winid)
!#######################################################################
  USE general, ONLY: MakeUpper
  USE server_common, ONLY: numcs, rstate
  USE keydata, ONLY: keyfilename, reloadstatus, isprocess
  IMPLICIT NONE

  INTEGER*BSIZE, INTENT(INOUT) :: iwin
  INTEGER, INTENT(INOUT) :: itype, ie, je, istate
  INTEGER*BSIZE, DIMENSION(9), INTENT(IN) :: winid

  INTEGER*BSIZE :: ivec(12)=0
  INTEGER :: tmpint=0, i=0
  REAL :: rvec(12)=0.
  CHARACTER(LEN=20) :: str=''
  LOGICAL, SAVE :: UPDATING = .FALSE.

  INCLUDE 'parameters.f'

  CHARACTER(LEN=MAXSTRLEN),SAVE :: commandline=' '
  CHARACTER(LEN=NSTRLEN) :: command=' '

!=======================================================================
!
  IF(UPDATING) THEN
    IF(.NOT.ALL(rstate.EQ.0)) UPDATING = .FALSE.
    RETURN
  ENDIF

!=======================================================================
! Determine if clients are ready
  IF(.NOT. ALL(rstate.EQ.0))RETURN
  
!=======================================================================
! Begin parsing request file
  CALL ISPBExtractToSpace(commandline,command)

  CALL MakeUpper(command,NSTRLEN)

  SELECT CASE(TRIM(ADJUSTL(command)))
    CASE('RELOADFLOW')
      UPDATING = .TRUE.
      CALL ISPBExtractToSpace(commandline,keyfilename)
      reloadstatus = 2
      WRITE(*,*) ' Reloading flow file ',TRIM(keyfilename)

    CASE('REDRAW')
      WRITE(*,*) ' Redrawing...'

    CASE('DUMPIMAGE')
      WRITE(*,*) ' Dumping image...'
      CALL ISPBExtractToSpace(commandline,command)
      READ(command,*,ERR=7000) tmpint
      IF(tmpint.GE.1 .AND. tmpint.LE.3)THEN
      ! Set a response, in this case the default image name
        ivec(1) = 0
        str = ''
        CALL pV_SetState(8, ivec, rvec, str)
        iwin = winid(tmpint)
        itype = 2
        ie = 1
        je = 1
        istate = ICHAR('~')
      ELSE
        WRITE(*,*) ' ERROR: Script file, iwin is not 1, 2, or 3.'
      ENDIF

    CASE('DUMPPVB')
      WRITE(*,*) ' Dumping PVB file...'
      CALL GetExtractData()

    CASE('')
    CASE DEFAULT
      WRITE(*,*) ' Unknown script command: ',TRIM(ADJUSTL(command))

  END SELECT

  RETURN

7000 CONTINUE
     WRITE(*,*) ' ERROR reading window number from file: not an int.'
     CLOSE(IMAGEUNIT)
     isprocess = .FALSE.
     RETURN

END SUBROUTINE ImageScriptProcessBatch

!#######################################################################
SUBROUTINE ISPBExtractToSpace(strin, strout)
!#######################################################################
  USE keydata, ONLY: isprocess
  IMPLICIT NONE
  INCLUDE 'parameters.f'

  CHARACTER(LEN=MAXSTRLEN), INTENT(INOUT) :: strin
  CHARACTER(LEN=NSTRLEN), INTENT(OUT) :: strout

  INTEGER :: i
  INTEGER, SAVE :: linenm = 0

  IF(TRIM(ADJUSTL(strin)).EQ.'')THEN
    READ(IMAGEUNIT,"(A120)",ERR=7000,END=9000) strin
    linenm = linenm + 1
  ENDIF

  strin = ADJUSTL(strin)
  strout = ' '

  IF(strin(1:1).EQ.'!')THEN
    strin=''
    strout=''
  ENDIF

  i = 1
  DO WHILE(strin(i:i).NE.' ')
    strout(i:i) = strin(i:i)
    strin(i:i) = ' '
    i = i + 1
  ENDDO
  
  strin = ADJUSTL(strin)

  RETURN

7000 CONTINUE
     WRITE(*,*) '  ERROR reading from script file at line ',linenm
9000 CONTINUE
     WRITE(*,*) '  Closing image scripting file.'
     CLOSE(IMAGEUNIT)
     linenm = 0
     isprocess = .FALSE.
     strin=''
     strout=''
     RETURN
  
END SUBROUTINE ISPBExtractToSpace
