#include "parameters.h"

!#######################################################################
SUBROUTINE Print3DHelp()
!#######################################################################
  IMPLICIT NONE

  WRITE(*,*) '  Feature Extraction:'
  WRITE(*,*) ' X      Feature Extraction'
  WRITE(*,*) ' '
  WRITE(*,*) '  Other Controls:'
  WRITE(*,*) ' Alt-f  Modify frame rate (fps)'
  WRITE(*,*) ' F      Time step toggle'
  WRITE(*,*) ' I      Unsteady image dumping'
  WRITE(*,*) ' N      Modify replication states'
  WRITE(*,*) ' P      Dump surfaces to Tecplot/POV'
  WRITE(*,*) ' Alt-p  Unsteady dump surfaces to Tecplot/POV'
  WRITE(*,*) ' S      Automatic scanning of cut planes and iso-surfaces'
  WRITE(*,*) ' '

END SUBROUTINE Print3DHelp

!#######################################################################
SUBROUTINE ToggleExtract( num, nam )
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: num
  CHARACTER(LEN=20), INTENT(IN) :: nam

  extracton(num) = .NOT. extracton(num)
  IF(extracton(num))THEN
    WRITE(*,*) TRIM(ADJUSTL(nam)) // ' turned on'
  ELSE
    WRITE(*,*) TRIM(ADJUSTL(nam)) // ' disabled'
  ENDIF

END SUBROUTINE

!#######################################################################
SUBROUTINE ToggleExtractAllOff()
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER :: i

  DO i = 1, 5
    extracton(i) = .FALSE.
  ENDDO
  WRITE(*,*) '  All FX features disabled!'

END SUBROUTINE ToggleExtractAllOff

!#######################################################################
SUBROUTINE GetUserMapping(key,str)
!#######################################################################
  IMPLICIT NONE
  INTEGER,INTENT(INOUT) :: key
  CHARACTER(LEN=7),INTENT(IN) :: str
  CHARACTER :: inchar

  WRITE(*,*) '  Enter desired mapping for ',str
  WRITE(*,*) ' r  Radial'
  WRITE(*,*) ' t  Tangential'
  WRITE(*,*) ' z  Axial/Grid coordinate'
  WRITE(*,*) ' x  Grid coordinate'
  WRITE(*,*) ' y  Grid coordinate'
  WRITE(*,*) ' i  Block index'
  WRITE(*,*) ' j  Block index'
  WRITE(*,*) ' k  Block index'
  READ(*,*) inchar
  IF(inchar.EQ.'r' .OR. inchar.EQ.'t' .OR. inchar.EQ.'z' .OR. &
     inchar.EQ.'x' .OR. inchar.EQ.'y'                    .OR. &
     inchar.EQ.'i' .OR. inchar.EQ.'j' .OR. inchar.EQ.'k')key = ICHAR(inchar)
  
END SUBROUTINE GetUserMapping

!#######################################################################
SUBROUTINE PlotMaskModifyV3(pmask)
!#######################################################################
! This routine is intended to switch the V3 plotmask to match the values
! of the pV3 plotmask for standard surface rendering.
  IMPLICIT NONE

  INTEGER,INTENT(INOUT) :: pmask

  IF(BTEST(pmask,5).AND.pmask.LT.0)THEN
    pmask = ABS(pmask)
  ELSEIF(pmask.LT.0)THEN
    pmask = ABS(pmask) + 32
  ELSEIF(BTEST(pmask,5))THEN
    pmask = pmask - 32
  ENDIF

END SUBROUTINE PlotMaskModifyV3
