!#######################################################################
SUBROUTINE Init_FX(iopt)
!#######################################################################
  USE common_area, ONLY: FXnbc, FXshowSurf, FXattind, FXsepind
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: iopt

  INTEGER :: cel1, cel2, cel3, cel4, nptet, ptet, blck(1),iblnk
  INTEGER :: kcel1, kcel2, kcel3, kcel4, knptet, kptet, knblck
  INTEGER :: scel, bc
  INTEGER :: nnode, kiblnk, knsurf
  INTEGER :: i, istat
  INTEGER, ALLOCATABLE, DIMENSION(:,:) :: blocks
  REAL :: xyz
  REAL :: gam

  POINTER (pcel1,cel1), (pcel2,cel2), (pcel3,cel3), (pcel4,cel4)
  POINTER (pnptet,nptet), (pptet,ptet), (pblck,blck), (piblnk,iblnk)
  POINTER (pxyz,xyz), (pscel,scel), (pbc,bc)

  CALL pV_GetStruc(315, pnptet, knptet)
  IF(knptet.NE.0)THEN
    WRITE(*,*) ' This case contains ',knptet,' PolyTet Strips'
    RETURN
  ENDIF
  CALL pV_GetStruc(318, pnptet, knptet)
  IF(knptet.NE.0)THEN
    WRITE(*,*) ' This case contains ',knptet,' Complex polyhedra'
    RETURN
  ENDIF

  istat = 47
  CALL pV_GetStruc(301, pxyz, nnode)

  CALL pV_GetStruc(311, pcel1, kcel1)
  CALL pV_GetStruc(312, pcel2, kcel2)
  CALL pV_GetStruc(313, pcel3, kcel3)
  CALL pV_GetStruc(314, pcel4, kcel4)
  CALL pV_GetStruc(315, pnptet, knptet)
  CALL pV_GetStruc(316, pptet, kptet)
  CALL pV_GetStruc(317, pblck, knblck)
  IF(knblck.NE.0)THEN
    ALLOCATE(blocks(3,knblck))
    DO i = 1, knblck
      blocks(1,i) = blck((i-1)*6+1)
      blocks(2,i) = blck((i-1)*6+2)
      blocks(3,i) = blck((i-1)*6+3)
      nnode = nnode - blocks(1,i)*blocks(2,i)*blocks(3,i)
    ENDDO
    CALL pV_GetStruc(306, piblnk, kiblnk)
    IF(kiblnk.NE.0) istat = istat + 16
  ENDIF

  CALL pV_GetStruc(321, pbc, FXnbc)
  CALL pV_GetStruc(323, pscel, knsurf)
  IF(FXnbc.GT.0)THEN
    ALLOCATE(FXshowSurf(FXnbc))
    ALLOCATE(FXattind(FXnbc))
    ALLOCATE(FXsepind(FXnbc))
  ENDIF

  gam = 1.4
#ifdef FXPV3CLIENT
  CALL FX_Init(gam, iopt, nnode, 0, kcel1, kcel2, kcel3, kcel4, knblck, blocks, 0, knsurf, FXnbc, istat)
!  CALL FX_RTParams( 1, 1., 1., 0. )
#endif
  WRITE(*,*) ' FX_init return = ',istat
  IF(knblck.NE.0) DEALLOCATE(blocks)

END SUBROUTINE Init_FX
