!#######################################################################
SUBROUTINE getkeytm(keyt)
!#######################################################################
  IMPLICIT NONE

  INTEGER, INTENT(OUT) :: keyt

  CHARACTER inchar

  keyt = 0
  WRITE(*,*) '  Enter averaging option:'
  WRITE(*,*) ' A  Time-average'
  WRITE(*,*) ' D  Time-difference'
  WRITE(*,*) ' M  Time-minimum'
  WRITE(*,*) ' X  Time-maximum'
  WRITE(*,*) ' R  RMS'
  WRITE(*,*) ' T  FFT'
  READ*,inchar
  keyt=ICHAR(inchar)
  IF(keyt.EQ.ICHAR('A') .OR. keyt.EQ.ICHAR('D') .OR. &
     keyt.EQ.ICHAR('M') .OR. keyt.EQ.ICHAR('X') .OR. &
     keyt.EQ.ICHAR('R') .OR. keyt.EQ.ICHAR('T'))RETURN
  keyt = -1
  
END SUBROUTINE getkeytm

!#######################################################################
SUBROUTINE getkeyv(keyv)
!#######################################################################
  IMPLICIT NONE

  INTEGER, INTENT(OUT) :: keyv

  CHARACTER inchar

  keyv = 0
  WRITE(*,*) '  Enter vector option:'
  WRITE(*,*) ' V  Absolute Velocity'
  WRITE(*,*) ' W  Relative Velocity'
  WRITE(*,*) ' Z  Absolute Vorticity'
  WRITE(*,*) ' O  Relative Vorticity'
  READ*,inchar
  keyv=ICHAR(inchar)
  IF(keyv.EQ.ICHAR('V') .OR. keyv.EQ.ICHAR('W') .OR. &
     keyv.EQ.ICHAR('O') .OR. keyv.EQ.ICHAR('Z'))RETURN
  keyv = -1
  

END SUBROUTINE getkeyv

!#######################################################################
SUBROUTINE getkeyt(keyt)
!#######################################################################
! Get the thresholding key option
  IMPLICIT NONE

  INTEGER, INTENT(OUT) :: keyt

  CHARACTER inchar

  keyt = 0
  WRITE(*,*) '  Enter thresholding option:'
  WRITE(*,*) ' i  I-Coordinate'
  WRITE(*,*) ' j  J-Coordinate'
  WRITE(*,*) ' k  K-Coordinate'
  WRITE(*,*) ' x  X-Coordinate'
  WRITE(*,*) ' y  Y-Coordinate'
  WRITE(*,*) ' z  Z-Coordinate'
  READ*,inchar
  keyt=ICHAR(inchar)
  IF(keyt.EQ.ICHAR('i') .OR. keyt.EQ.ICHAR('x') .OR. &
     keyt.EQ.ICHAR('j') .OR. keyt.EQ.ICHAR('y') .OR. &
     keyt.EQ.ICHAR('k') .OR. keyt.EQ.ICHAR('z'))RETURN
  keyt = -1
  

END SUBROUTINE getkeyt

!#######################################################################
SUBROUTINE getkey1(key1)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(OUT) :: key1

  CHARACTER inchar

  key1=0
  WRITE(*,*) '  Enter scalar option:'
  WRITE(*,*) ' a  Angles'
  WRITE(*,*) ' c  Coordinates'
  WRITE(*,*) ' d  Density'
  WRITE(*,*) ' e  Energy'
  WRITE(*,*) ' h  Enthalpy'
  WRITE(*,*) ' i  Rothalpy'
  WRITE(*,*) ' m  Mach number'
  WRITE(*,*) ' o  Other scalars'
  WRITE(*,*) ' p  Pressure'
  WRITE(*,*) ' q  Turbulence'
  WRITE(*,*) ' r  Rho-V'
  WRITE(*,*) ' s  Entropy'
  WRITE(*,*) ' t  Temperature'
  WRITE(*,*) ' v  Velocity'
  WRITE(*,*) ' w  Vorticity'
  READ*,inchar
  key1=ICHAR(inchar)
  IF(key1.EQ.ICHAR('a') .OR. key1.EQ.ICHAR('c') .OR. &
     key1.EQ.ICHAR('d') .OR. key1.EQ.ICHAR('e') .OR. &
     key1.EQ.ICHAR('h') .OR. key1.EQ.ICHAR('i') .OR. &
     key1.EQ.ICHAR('m') .OR. key1.EQ.ICHAR('o') .OR. &
     key1.EQ.ICHAR('p') .OR. key1.EQ.ICHAR('q') .OR. &
     key1.EQ.ICHAR('r') .OR. key1.EQ.ICHAR('s') .OR. &
     key1.EQ.ICHAR('t') .OR. key1.EQ.ICHAR('v') .OR. &
     key1.EQ.ICHAR('w'))RETURN
    key1=-1

  RETURN

END SUBROUTINE

!#######################################################################
SUBROUTINE getkey2(key1, key2, varstr)
!#######################################################################
! ARGUMENTS
!-----------------------------------------------------------------------
! The subroutine requires 2 arguments, first the user pressed key for
! input, and second the user pressed key as output.
! Name   Type    I/O    Description
! ----   ----    ---    -----------
! key1   INT     IN     Input key which may need a response
! key2   INT     OUT    Return value or second key value
! varstr CHAR    OUT    String for the key window
!
! OUTPUT
!-----------------------------------------------------------------------
! The subroutine returns key2 which contains values as described:
!  = -1    There was an error with stdin and pVEvents will return
!  =  0    No second key is necessary, do not broadcast
!  >  0    key2 is valid and will be broadcast and pVEvents will return
!
  IMPLICIT NONE

  INTEGER,INTENT(IN)  :: key1
  INTEGER,INTENT(OUT) :: key2

  CHARACTER*32,INTENT(OUT) :: varstr
  CHARACTER :: inchar

  key2=0
  varstr = ' '
  SELECT CASE(key1)
!=======================================================================
! "a" hit for angles
    CASE(ICHAR('a'))
      WRITE(*,*) '  Enter desired angle option:'
      WRITE(*,*) ' a  Alpha-Z'
      WRITE(*,*) ' A  Alpha-M'
      WRITE(*,*) ' b  Beta-Z'
      WRITE(*,*) ' B  Beta-M'
      WRITE(*,*) ' p  Phi'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('a')
          varstr = 'Angles: Alpha-Z'
        CASE('A')
          varstr = 'Angles: Alpha-M'
        CASE('b')
          varstr = 'Angles: Beta-Z'
        CASE('B')
          varstr = 'Angles: Beta-M'
        CASE('p')
          varstr = 'Angles: Phi'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "c" hit for coordinates
    CASE(ICHAR('c'))
      WRITE(*,*) '  Enter desired coordinate option:'
      WRITE(*,*) ' i  I or Ibb value'
      WRITE(*,*) ' j  J or Isp value'
      WRITE(*,*) ' k  K or Ifl value'
      WRITE(*,*) ' r  R value'
      WRITE(*,*) ' t  Theta value'
      WRITE(*,*) ' x  X value'
      WRITE(*,*) ' y  Y value'
      WRITE(*,*) ' z  Z value'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('i')
          varstr = 'Coordinates: I'
        CASE('j')
          varstr = 'Coordinates: J'
        CASE('k')
          varstr = 'Coordinates: K'
        CASE('r')
          varstr = 'Coordinates: Radius'
        CASE('t')
          varstr = 'Coordinates: Theta'
        CASE('x')
          varstr = 'Coordinates: X'
        CASE('y')
          varstr = 'Coordinates: Y'
        CASE('z')
          varstr = 'Coordinates: Z'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "d" hit for density -- there are no options
    CASE(ICHAR('d'))
      key2=1
      varstr = 'Density'

!=======================================================================
! "h" hit for enthalpy
    CASE(ICHAR('h'))
      WRITE(*,*) '  Enter desired enthalpy option:'
      WRITE(*,*) ' s  Static Enthalpy'
      WRITE(*,*) ' a  Absolute Total Enthalpy'
      WRITE(*,*) ' r  Relative Total Enthalpy'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('s')
          varstr = 'Enthalpy: Static'
        CASE('a')
          varstr = 'Enthalpy: Absolute Total'
        CASE('r')
          varstr = 'Enthalpy: Relative Total'
        CASE DEFAULT
          key2 = -1
      END SELECT

!=======================================================================
! "i" hit for rothalpy
    CASE(ICHAR('i'))
      WRITE(*,*) '  Enter the desired rothalpy option:'
      WRITE(*,*) ' i  rothalpy'
      WRITE(*,*) ' t  rothalpy/cp (temp units)'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('i')
          varstr = 'Rothalpy'
        CASE('t')
          varstr = 'Rothalpy: Rothalpy/CP'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "m" hit for mach number
    CASE(ICHAR('m'))
      WRITE(*,*) '  Enter the desired rho-v option:'
      WRITE(*,*) ' h  Absolute theta-component'
      WRITE(*,*) ' H  Relative theta-component'
      WRITE(*,*) ' r  r-component'
      WRITE(*,*) ' t  Absolute total'
      WRITE(*,*) ' T  Relative total'
      WRITE(*,*) ' x  Absolute x-component'
      WRITE(*,*) ' X  Relative x-component'
      WRITE(*,*) ' y  Absolute y-component'
      WRITE(*,*) ' Y  Relative Y-component'
      WRITE(*,*) ' z  Z-component'
      WRITE(*,*) ' i  Ideal mach number from ps and ptideal'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('h')
          varstr = 'Mach: Abs. Theta'
        CASE('H')
          varstr = 'Mach: Rel. Theta'
        CASE('r')
          varstr = 'Mach: Radial'
        CASE('t')
          varstr = 'Mach: Abs. Total'
        CASE('T')
          varstr = 'Mach: Rel. Total'
        CASE('x')
          varstr = 'Mach: Abs. X'
        CASE('X')
          varstr = 'Mach: Rel. X'
        CASE('y')
          varstr = 'Mach: Abs. Y'
        CASE('Y')
          varstr = 'Mach: Rel. Y'
        CASE('z')
          varstr = 'Mach: Z'
        CASE('i')
          varstr = 'Mach: Ideal'
        CASE DEFAULT
          key2 = -1
      END SELECT

!=======================================================================
! "p" hit for pressure
    CASE(ICHAR('p'))
      WRITE(*,*) '  Enter desired pressure option:'
      WRITE(*,*) ' s  Static Pressure'
      WRITE(*,*) ' a  Absolute Total Pressure'
      WRITE(*,*) ' r  Relative Total Pressure'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('s')
          varstr = 'Pressure: Static'
        CASE('a')
          varstr = 'Pressure: Absolute Total'
        CASE('r')
          varstr = 'Pressure: Relative Total Pressure'
        CASE DEFAULT
          key2 = -1
      END SELECT

!=======================================================================
! "r" hit for rho-v
    CASE(114)
      WRITE(*,*) '  Enter the desired rho-v option:'
      WRITE(*,*) ' h  Absolute theta-component'
      WRITE(*,*) ' H  Relative theta-component'
      WRITE(*,*) ' r  r-component'
      WRITE(*,*) ' t  Absolute total'
      WRITE(*,*) ' T  Relative total'
      WRITE(*,*) ' x  Absolute x-component'
      WRITE(*,*) ' X  Relative x-component'
      WRITE(*,*) ' y  Absolute y-component'
      WRITE(*,*) ' Y  Relative Y-component'
      WRITE(*,*) ' z  Z-component'
      READ*,inchar
      key2=ICHAR(inchar)
      IF(key2.EQ.ICHAR('h') .OR. key2.EQ.ICHAR('H') .OR. &
         key2.EQ.ICHAR('r') .OR. key2.EQ.ICHAR('z') .OR. &
         key2.EQ.ICHAR('t') .OR. key2.EQ.ICHAR('T') .OR. &
         key2.EQ.ICHAR('x') .OR. key2.EQ.ICHAR('y') .OR. &
         key2.EQ.ICHAR('X') .OR. key2.EQ.ICHAR('Y'))RETURN
      SELECT CASE(inchar)
        CASE('h')
          varstr = 'Rho-V: Abs. Theta'
        CASE('H')
          varstr = 'Rho-V: Rel. Theta'
        CASE('r')
          varstr = 'Rho-V: Radial'
        CASE('t')
          varstr = 'Rho-V: Abs. Total'
        CASE('T')
          varstr = 'Rho-V: Rel. Total'
        CASE('x')
          varstr = 'Rho-V: Abs. X'
        CASE('X')
          varstr = 'Rho-V: Rel. X'
        CASE('y')
          varstr = 'Rho-V: Abs. Y'
        CASE('Y')
          varstr = 'Rho-V: Rel. Y'
        CASE('z')
          varstr = 'Rho-V: Z'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "s" hit for entropy
    CASE(115)
      WRITE(*,*) '  Enter desired entropy option:'
      WRITE(*,*) ' a  Absolute level'
      WRITE(*,*) ' e  Exp(s/R)'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('a')
          varstr = 'Entropy: Absolute Level'
        CASE('e')
          varstr = 'Entropy: Exp(s/R)'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "t" hit for temperature
    CASE(116)
      WRITE(*,*) '  Enter the desired temperature option:'
      WRITE(*,*) ' s  Static temperature'
      WRITE(*,*) ' a  Absolute total temperature'
      WRITE(*,*) ' r  Relative total temperature'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('s')
          varstr = 'Temperature: Static'
        CASE('a')
          varstr = 'Temperature: Absolute Total'
        CASE('r')
          varstr = 'Temperature: Relative Total Pressure'
        CASE DEFAULT
          key2 = -1
      END SELECT

!=======================================================================
! "v" hit for velocity
    CASE(118)
      WRITE(*,*) '  Enter the desired velocity option:'
      WRITE(*,*) ' h  Absolute theta-component'
      WRITE(*,*) ' H  Relative theta-component'
      WRITE(*,*) ' r  r-component'
      WRITE(*,*) ' t  Absolute total'
      WRITE(*,*) ' T  Relative total'
      WRITE(*,*) ' x  Absolute x-component'
      WRITE(*,*) ' X  Relative x-component'
      WRITE(*,*) ' y  Absolute y-component'
      WRITE(*,*) ' Y  Relative Y-component'
      WRITE(*,*) ' z  Z-component'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('h')
          varstr = 'Vel: Abs. Theta'
        CASE('H')
          varstr = 'Vel: Rel. Theta'
        CASE('r')
          varstr = 'Vel: Radial'
        CASE('t')
          varstr = 'Vel: Abs. Total'
        CASE('T')
          varstr = 'Vel: Rel. Total'
        CASE('x')
          varstr = 'Vel: Abs. X'
        CASE('X')
          varstr = 'Vel: Rel. X'
        CASE('y')
          varstr = 'Vel: Abs. Y'
        CASE('Y')
          varstr = 'Vel: Rel. Y'
        CASE('z')
          varstr = 'Vel: Z'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "w" hit for vorticity
    CASE(119)
      WRITE(*,*) '  Enter desired vorticity option:'
      WRITE(*,*) ' h  Theta-component'
      WRITE(*,*) ' r  r-component'
      WRITE(*,*) ' s  Streamwise component (absolute)'
      WRITE(*,*) ' S  Streamwise component (relative)'
      WRITE(*,*) ' t  Absolute total'
      WRITE(*,*) ' T  Relative total'
      WRITE(*,*) ' x  X-component'
      WRITE(*,*) ' y  Y-component'
      WRITE(*,*) ' z  Absolute Z-component'
      WRITE(*,*) ' Z  Relative Z-component'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('h')
          varstr = 'Vort: Theta'
        CASE('r')
          varstr = 'Vort: Radial'
        CASE('s')
          varstr = 'Vort: Abs. Streamwise'
        CASE('S')
          varstr = 'Vort: Rel. Streamwise'
        CASE('t')
          varstr = 'Vort: Abs. Total'
        CASE('T')
          varstr = 'Vort: Rel. Total'
        CASE('x')
          varstr = 'Vort: X'
        CASE('y')
          varstr = 'Vort: Y'
        CASE('z')
          varstr = 'Vort: Abs. Z'
        CASE('Z')
          varstr = 'Vort: Rel. Z'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "q" hit for turbulence
    CASE(ICHAR('q'))
      WRITE(*,*) '  Enter desired turbulence option:'
      WRITE(*,*) ' m  Turbulence mu_t'
      WRITE(*,*) ' k  Turbulence K'
      WRITE(*,*) ' e  Turbulence Epsilon'
      WRITE(*,*) ' i  Turbulence Intensity'
      WRITE(*,*) ' q  Q Criterion'
      WRITE(*,*) ' r  Ratio Turbulent/Molecular Viscosity'
      WRITE(*,*) ' t  Total Viscosity (Turbulent+Molecular)'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('m')
          varstr = 'Turb: Mu_t'
        CASE('k')
          varstr = 'Turb: K'
        CASE('e')
          varstr = 'Turb: Eps'
        CASE('i')
          varstr = 'Turb: Intensity'
        CASE('q')
          varstr = 'Turb: Q Criterion'
        CASE('r')
          varstr = 'Turb: Ratio Mu_t/Mu_l'
        CASE('t')
          varstr = 'Turb: Total Viscosity'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "e" hit for internal energy
    CASE(101)
      key2 = key1
      varstr = 'Energy: Internal'
      WRITE(*,*) '  Enter desired energy option:'
      WRITE(*,*) ' e  Internal Energy'
      WRITE(*,*) ' r  Rho*Internal Energy'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('e')
          varstr = 'Energy: Internal'
        CASE('r')
          varstr = 'Energy: Rho*Internal'
        CASE DEFAULT
          key2=-1
      END SELECT

!=======================================================================
! "o" hit for other
    CASE(111)
      WRITE(*,*) '  Enter desired option for other scalars:'
      WRITE(*,*) ' b  IBlanking'
      WRITE(*,*) ' g  Gamma'
      WRITE(*,*) ' i  Processor ID number'
      WRITE(*,*) ' n  Block Number'
      WRITE(*,*) ' o  Omega scalar value'
      WRITE(*,*) ' v  Cell volume'
      WRITE(*,*) ' s  Cell skew'
      WRITE(*,*) ' r  Local Reynolds number'
      WRITE(*,*) ' t  Residence time'
      READ*,inchar
      key2=ICHAR(inchar)
      SELECT CASE(inchar)
        CASE('b')
          varstr = 'IBlanking'
        CASE('g')
          varstr = 'Gamma'
        CASE('i')
          varstr = 'Client ID'
        CASE('n')
          varstr = 'Block Number'
        CASE('o')
          varstr = 'Omega'
        CASE('v')
          varstr = 'Cell Volumes'
        CASE('s')
          varstr = 'Cell skew'
        CASE('r')
          varstr = 'Local Reynolds num'
        CASE('t')
          varstr = 'Residence time'
        CASE DEFAULT
          key2=-1
      END SELECT

  END SELECT

END SUBROUTINE getkey2

!#######################################################################
SUBROUTINE getkey3(keyfft, keymode)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(OUT) :: keyfft,keymode
  CHARACTER inchar
  
  WRITE(*,*) '  Enter desired fft option:'
  WRITE(*,*) ' m  Magnitude'
  WRITE(*,*) ' p  Phase'
  WRITE(*,*) ' r  Real'
  WRITE(*,*) ' i  Imaginary'
  READ*,inchar
  keyfft=ICHAR(inchar)
  IF(keyfft.EQ.ICHAR('m') .OR. keyfft.EQ.ICHAR('p') .OR. &
     keyfft.EQ.ICHAR('r') .OR. keyfft.EQ.ICHAR('i'))THEN
3001 CONTINUE
    WRITE(*,*) ''
    WRITE(*,*) '  Enter mode (0 <-> ntime-1)'
    READ(*,*,ERR=3001) keymode
  ELSE
    keyfft=-1
    keymode=-1
  ENDIF

END SUBROUTINE getkey3

!#######################################################################
SUBROUTINE getkeyvm(key)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(OUT) :: key
  CHARACTER inchar

  WRITE(*,*) '  Enter desired Viz Math option:'
  WRITE(*,*) ' c  Curl'
  WRITE(*,*) ' d  Divergence'
  WRITE(*,*) ' g  Gradient'
  WRITE(*,*) ' l  Laplacian'
  READ*,inchar
  key=ICHAR(inchar)
  IF(key.EQ.ICHAR('c') .OR. key.EQ.ICHAR('d') .OR. &
     key.EQ.ICHAR('g') .OR. key.EQ.ICHAR('l'))RETURN

  key = -1

END SUBROUTINE getkeyvm

!#######################################################################
SUBROUTINE getkeyvm2(key1,key)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(IN)  :: key1
  INTEGER,INTENT(OUT) :: key
  CHARACTER inchar

  SELECT CASE(key1)
    CASE(ICHAR('c'))
      WRITE(*,*) '  Enter desired curl option:'

    CASE(ICHAR('d'))
      key=ICHAR('x') ! There can be only one
      RETURN

    CASE(ICHAR('g'))
      WRITE(*,*) '  Enter desired gradient option:'

    CASE(ICHAR('l'))
      key=ICHAR('x') ! There can be only one
      RETURN

  END SELECT

  WRITE(*,*) ' h  Theta-component'
  WRITE(*,*) ' r  r-component'
  WRITE(*,*) ' s  Streamwise component (absolute)'
  WRITE(*,*) ' S  Streamwise component (relative)'
  WRITE(*,*) ' t  Absolute total'
  WRITE(*,*) ' T  Relative total'
  WRITE(*,*) ' x  X-component'
  WRITE(*,*) ' y  Y-component'
  WRITE(*,*) ' z  Absolute Z-component'
  WRITE(*,*) ' Z  Relative Z-component'
  READ*,inchar
  key=ICHAR(inchar)
  IF(key.EQ.ICHAR('h') .OR. key.EQ.ICHAR('r') .OR. &
     key.EQ.ICHAR('s') .OR. key.EQ.ICHAR('S') .OR. &
     key.EQ.ICHAR('t') .OR. key.EQ.ICHAR('T') .OR. &
     key.EQ.ICHAR('x') .OR. key.EQ.ICHAR('y') .OR. &
     key.EQ.ICHAR('z') .OR. key.EQ.ICHAR('Z'))RETURN

  key = -1

END SUBROUTINE getkeyvm2

!#######################################################################
SUBROUTINE getkeyfx(key)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(OUT) :: key
  CHARACTER inchar

  WRITE(*,*) '  Enter desired FX extract:'
  WRITE(*,*) ' C  Vortex Cores'
  WRITE(*,*) ' S  Shock Surfaces'
  WRITE(*,*) ' L  Separation and Attachment Lines'
  WRITE(*,*) ' B  Boundary Layer/Wake Surfaces'
  READ*,inchar
  key=ICHAR(inchar)
  IF(key.EQ.ICHAR('C') .OR. key.EQ.ICHAR('S') .OR. &
     key.EQ.ICHAR('L') .OR. key.EQ.ICHAR('B'))RETURN

  key = -1

END SUBROUTINE getkeyfx
