#include "parameters.h"
!#######################################################################
SUBROUTINE ImageScriptProcessBatch(iwin, itype, ie, je, istate, winid,stat)
!#######################################################################
  USE general,       ONLY: MakeUpper
  USE server_common, ONLY: numcs, rstate
  USE keydata,       ONLY: keyfilename, reloadstatus, isprocess
# ifdef PV3SERIAL
    USE readflow,    ONLY: ReloadFlow
# endif

  IMPLICIT NONE

  INTEGER*BSIZE, INTENT(INOUT) :: iwin
  INTEGER,INTENT(OUT) :: stat
  INTEGER, INTENT(INOUT) :: itype, ie, je, istate
  INTEGER*BSIZE, DIMENSION(9), INTENT(IN) :: winid

  INTEGER*BSIZE :: ivec(12)=0
  INTEGER :: tmpint=0, i=0
  REAL :: rvec(12)=0.
  CHARACTER(LEN=20) :: str=''

  CHARACTER(LEN=MAXSTRLEN),SAVE :: commandline=' '
  CHARACTER(LEN=NSTRLEN) :: command=' '

  stat=0

# ifndef PV3SERIAL
!=======================================================================
! Determine if clients are ready
    IF(.NOT. ALL(rstate.EQ.RSTATE_READY))RETURN
# endif
  
!=======================================================================
! Begin parsing request file
  CALL ISPBExtractToSpace(commandline,command)
  CALL MakeUpper(command,NSTRLEN)

  SELECT CASE(TRIM(ADJUSTL(command)))
    CASE('RELOADFLOW')
      CALL ISPBExtractToSpace(commandline,keyfilename)
      reloadstatus = 2
      WRITE(*,*) ' Reloading flow file ',TRIM(keyfilename)
#     ifdef PV3SERIAL
        CALL ReloadFlow(keyfilename)
#     endif

    CASE('REDRAW')
      WRITE(*,*) ' Redrawing...'

    CASE('DUMPIMAGE')
      WRITE(*,*) ' Dumping image...'
      CALL ISPBExtractToSpace(commandline,command)
      READ(command,*,ERR=7000) tmpint
      IF(tmpint.GE.1 .AND. tmpint.LE.3)THEN
      ! Set a response, in this case the default image name
        ivec(1) = 0
        str = ''
        stat=1
#       ifndef PV3SERIAL
          CALL pV_SetState(8, ivec, rvec, str)
#       endif
        iwin = winid(tmpint)
        itype = 2
        ie = 1
        je = 1
        istate = ICHAR('~')
      ELSE
        WRITE(*,*) ' ERROR: Script file, iwin is not 1, 2, or 3.'
      ENDIF

    CASE('DUMPPVB')
      WRITE(*,*) ' Dumping PVB file...'
#     ifdef PV3SERIAL
        stat=2
#     else
        CALL GetExtractData()
#     endif

    CASE('EXIT')
      iwin = winid(3)
      itype = 2
      ie = 1
      je = 1
      istate = 27

    CASE('')
    CASE DEFAULT
      WRITE(*,*) ' Unknown script command: ',TRIM(ADJUSTL(command))

  END SELECT

  RETURN

7000 CONTINUE
     WRITE(*,*) ' ERROR reading window number from file: not an int.'
     CLOSE(IMAGEUNIT)
     isprocess = .FALSE.
     RETURN

END SUBROUTINE ImageScriptProcessBatch

!#######################################################################
SUBROUTINE ISPBExtractToSpace(strin, strout)
!#######################################################################
  USE keydata, ONLY: isprocess
  IMPLICIT NONE

  CHARACTER(LEN=MAXSTRLEN), INTENT(INOUT) :: strin
  CHARACTER(LEN=NSTRLEN), INTENT(OUT) :: strout

  INTEGER :: i
  INTEGER, SAVE :: linenm = 0

  IF(TRIM(ADJUSTL(strin)).EQ.'')THEN
    READ(IMAGEUNIT,"(A120)",ERR=7000,END=9000) strin
    linenm = linenm + 1
  ENDIF

  strin = ADJUSTL(strin)
  strout = ' '

  IF(strin(1:1).EQ.'!')THEN
    strin=''
    strout=''
  ENDIF

  i = 1
  DO WHILE(strin(i:i).NE.' ')
    strout(i:i) = strin(i:i)
    strin(i:i) = ' '
    i = i + 1
  ENDDO
  
  strin = ADJUSTL(strin)

  RETURN

7000 CONTINUE
     WRITE(*,*) '  ERROR reading from script file at line ',linenm
9000 CONTINUE
     WRITE(*,*) '  Closing image scripting file.'
     CLOSE(IMAGEUNIT)
     linenm = 0
     isprocess = .FALSE.
     strin=''
     strout=''
     RETURN
  
END SUBROUTINE ISPBExtractToSpace
