#include "parameters.h"
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
MODULE mod_clear
  IMPLICIT NONE

  INTERFACE ClearVar
    MODULE PROCEDURE ClearVarR1, ClearVarR2, ClearVarI1, ClearVarI2, &
                     ClearVar2R1, ClearVarL1
  END INTERFACE

CONTAINS

!#######################################################################
  SUBROUTINE ClearVarR1(ptr)
!#######################################################################
    REAL,POINTER,DIMENSION(:) :: ptr
    IF(ASSOCIATED(ptr))THEN
      DEALLOCATE(ptr)
      NULLIFY(ptr)
    ENDIF
  END SUBROUTINE ClearVarR1

!#######################################################################
  SUBROUTINE ClearVarR2(ptr)
!#######################################################################
    REAL,POINTER,DIMENSION(:,:) :: ptr
    IF(ASSOCIATED(ptr))THEN
      DEALLOCATE(ptr)
      NULLIFY(ptr)
    ENDIF
  END SUBROUTINE ClearVarR2

!#######################################################################
  SUBROUTINE ClearVarI1(ptr)
!#######################################################################
    INTEGER,POINTER,DIMENSION(:) :: ptr
    IF(ASSOCIATED(ptr))THEN
      DEALLOCATE(ptr)
      NULLIFY(ptr)
    ENDIF
  END SUBROUTINE ClearVarI1

!#######################################################################
  SUBROUTINE ClearVarI2(ptr)
!#######################################################################
    INTEGER,POINTER,DIMENSION(:,:) :: ptr
    IF(ASSOCIATED(ptr))THEN
      DEALLOCATE(ptr)
      NULLIFY(ptr)
    ENDIF
  END SUBROUTINE ClearVarI2

!#######################################################################
  SUBROUTINE ClearVar2R1(ptr2, ptrb)
!#######################################################################
    REAL,POINTER,DIMENSION(:) :: ptrb,ptr2
    IF(ASSOCIATED(ptr2))THEN
      IF (.NOT.ASSOCIATED(ptr2,ptrb)) THEN
         DEALLOCATE(ptr2)
      ENDIF
      NULLIFY(ptr2)
    ENDIF
  END SUBROUTINE ClearVar2R1

!#######################################################################
  SUBROUTINE ClearVarL1(ptr)
!#######################################################################
    LOGICAL,POINTER,DIMENSION(:) :: ptr
    IF(ASSOCIATED(ptr))THEN
      DEALLOCATE(ptr)
      NULLIFY(ptr)
    ENDIF
  END SUBROUTINE ClearVarL1

END MODULE mod_clear
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
