#include "parameters.h"
#define FLOW pfw(n)%
#define GRID pgr(c)%
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
MODULE readfunc
  IMPLICIT NONE

CONTAINS
!#######################################################################
  SUBROUTINE Get_Func()
!#######################################################################
    USE common_area, ONLY: ffmt, ntime, funcarr, runmode

    INTEGER :: i
    CHARACTER(LEN=NSTRLEN) :: fnam

    SELECT CASE(runmode)
      CASE(-1,1,2,11)
        IF(ffmt.NE.FFMTPLOT3D)RETURN
        DO i=1,ntime
          fnam = TRIM(ADJUSTL(funcarr(i)))
          IF(fnam.NE.'' .AND. fnam.NE.'xxx')THEN
            CALL Rd_P3DT_Func(funcarr(i),i,1)
          ENDIF
        ENDDO
        
      CASE(3)
        DO i=1,ntime
          fnam = TRIM(ADJUSTL(funcarr(i)))
          IF(fnam.NE.'' .AND. fnam.NE.'xxx')THEN
            CALL Rd_P3DT_Func(funcarr(i),i,1)
          ENDIF
        ENDDO

    END SELECT

  END SUBROUTINE Get_Func

!#######################################################################
  SUBROUTINE Rd_P3DT_Func(fnam, n, c)
!#######################################################################
    USE common_area, ONLY: nfunc, pfw, pgr

    INTEGER, INTENT(IN) :: n, c
    CHARACTER(LEN=NSTRLEN),INTENT(IN) :: fnam

    INTEGER :: m,i,j,k,q, nblk, idum, id, jd, kd, s

    WRITE(*,*) 'Reading Plot3D Function File: ',fnam
    OPEN(UNIT=FUNIT,FILE=fnam,FORM='unformatted')
    READ(FUNIT) nblk
    READ(FUNIT) (idum,idum,idum, nfunc, m = 1, nblk)
    ALLOCATE(FLOW funk(nfunc,GRID tpts))
    DO m = 1, pgr(c)%nblks
      s=0
      id = GRID li(m)
      jd = GRID lj(m)
      kd = GRID lk(m)
      DO i = 1, m-1, 1
        s = s + GRID mvmax(i)
      ENDDO
      READ(QUNIT) ((((FLOW funk(q,s+i+(j-1)*id+(k-1)*id*jd), i=1,id),j=1,jd),k=1,kd),q=1,nfunc)
    ENDDO
    CLOSE(FUNIT)
    WRITE(*,"(A,I6,A)") 'Successfully read ',nfunc,' variables'

  END SUBROUTINE Rd_P3DT_Func

END MODULE readfunc
!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
