!***********************************************************************
! PARAMETERS
!***********************************************************************
#define NMX 100
#define PI 3.141592653589793

!***********************************************************************
! FILE I/O UNITS
!***********************************************************************
#define COLUNIT 8
#define INUNIT 10
#define BCSUNIT 12
#define EQUNIT 14
#define GUNIT 20
#define FUNIT 20
#define QUNIT 20
#define TECUNIT 60
#define POVUNIT 62
#define IMAGEUNIT 91
#define SCRIPTUNIT 98
#define JOURNALIUNIT 100
#define JOURNALOUNIT 101
#define JOURNALSUNIT 102

!***********************************************************************
! STRING LENGTHS
!***********************************************************************
#define MAXSTRLEN 120
#define NSTRLEN 40

!***********************************************************************
! READINESS STATES
!***********************************************************************
#define RSTATE_RELOAD_GRID 1
#define RSTATE_RELOAD_FLOW 2
#define RSTATE_READY 0
#define RSTATE_WAITING -1

!***********************************************************************
! SIGNALS
!***********************************************************************
#define SIG_STV_UPDATE 422
#define SIG_TIM_UPDATE 423
#define SIG_STIM_UPDATE 424
#define SIG_RELOAD_GRID 450
#define SIG_RELOAD_FLOW 451
#define SIG_RSTATE_CLEAR 452

!***********************************************************************
! COORDINATE SYSTEMS
!***********************************************************************
#define CARTESIAN 0
#define CYLINDRICAL 1
#define RHCYLINDRICAL 2

!***********************************************************************
! FILE FORMATS
!***********************************************************************
#define FFMTFORMATTED 0
#define FFMTUNFORMATTED 1
#define FFMTBINARY 2
#define FFMTVSTAGE 1
#define FFMTPLOT3D 2

!***********************************************************************
! RUN MODES
!***********************************************************************
#define MODETACOMA 11

!***********************************************************************
! EXTRACT TYPES
!***********************************************************************
#define EXT_SURF_PLANAR 2
#define EXT_SURF_BLOCK 3
#define EXT_SURF_GEOMETRIC 4
#define EXT_SURF_DOMAIN 5
#define EXT_SURF_ISO 7
#define EXT_STREAMLINE 18
#define EXT_PARTICLES 19
#define EXT_VCLOUDS 20
#define EXT_POINTS 21

#define EXT_CLIENTDATA 200
#define EXT_VORTEX 101
#define EXT_SHOCKS 102
#define EXT_SEPATT 103
#define EXT_RESIDENCE 104
#define EXT_BLWAKE 105

!***********************************************************************
! DEBUG COMMANDS
!***********************************************************************
#ifdef DEBUG
#  if DEBUG==0
#    define DEBUG1(EXP)
#    define DEBUG2(EXP)
#    define DEBUG3(EXP)
#    define DEBUG4(EXP)
#  endif
#  if DEBUG==1
#    define DEBUG1(EXP) PRINT*,EXP
#    define DEBUG2(EXP)
#    define DEBUG3(EXP)
#    define DEBUG4(EXP)
#  endif
#  if DEBUG==2
#    define DEBUG1(EXP) PRINT*,EXP
#    define DEBUG2(EXP) PRINT*,EXP
#    define DEBUG3(EXP)
#    define DEBUG4(EXP)
#  endif
#  if DEBUG==3
#    define DEBUG1(EXP) PRINT*,EXP
#    define DEBUG2(EXP) PRINT*,EXP
#    define DEBUG3(EXP) PRINT*,EXP
#    define DEBUG4(EXP)
#  endif
#  if DEBUG==4
#    define DEBUG1(EXP) PRINT*,EXP
#    define DEBUG2(EXP) PRINT*,EXP
#    define DEBUG3(EXP) PRINT*,EXP
#    define DEBUG4(EXP) PRINT*,EXP
#  endif
#else
#  define DEBUG1(EXP)
#  define DEBUG2(EXP)
#  define DEBUG3(EXP)
#  define DEBUG4(EXP)
#endif

!***********************************************************************
! PV3 AND V3 CALLS
!***********************************************************************
#ifdef PV3SERIAL
#  define GETSTRUC V3_GetStruc
#  define SETSTATE V3_SetState
#  define GETSTATE V3_GetState
#  define CURSOR V3_Cursor
#  define EVENTS V3PEvents
#else
#  define GETSTRUC pV_GetStruc
#  define SETSTATE pV_SetState
#  define GETSTATE pV_GetState
#  define CURSOR pV_Cursor
#  define EVENTS pVEvents
#endif
