  fwctr = fwctr + 1
  WRITE(*,"(A,I4,A)") '*** Generating POV/TEC ',fwctr,' Output ***'

  CALL WriteDataHeader(fwctr)

! Get necessary data structures
  CALL V3_GetStruc(301, pPOVxyz, nnode)
  CALL V3_GetStruc(302, pPOVs, nnode)
  CALL V3_GetStruc(303, pPOVt, nnode)

!=======================================================================
! Check the dynamic surface
  CALL V3_GetState(15, ivec, rvec, cstr)
  plotmask = ivec(1)
  CALL PlotMaskModifyV3(plotmask)
  IF(BTEST(plotmask,0))THEN
    ivec(1) = -1
    CALL V3_GetState(3, ivec, rvec, cstr)
    typ = ivec(1)
    IF(typ.NE.0)THEN
      nam = 'Dynamic Surface     '
      CALL V3_GetStruc(201, pPOVnode2d, knode2)
      CALL V3_GetStruc(203, pPOVdterp, knode2)
      CALL V3_GetStruc(204, pPOVcell, kcell)
      IF(knode2.NE.0 .AND. kcell.NE.0)THEN
        WRITE(POVUNIT) knode2, kcell, typ, nam, plotmask
        WRITE(*,*) knode2,kcell,typ,nam,plotmask
        DO i = 1, knode2
          POVtmpx = POVxyz(1,POVnode2d(1,i)) + POVdterp(i) * &
&                   (POVxyz(1,POVnode2d(2,i))-POVxyz(1,POVnode2d(1,i)))
          POVtmpy = POVxyz(2,POVnode2d(1,i)) + POVdterp(i) * &
&                   (POVxyz(2,POVnode2d(2,i))-POVxyz(2,POVnode2d(1,i)))
          POVtmpz = POVxyz(3,POVnode2d(1,i)) + POVdterp(i) * &
&                   (POVxyz(3,POVnode2d(2,i))-POVxyz(3,POVnode2d(1,i)))
          WRITE(POVUNIT) POVtmpx,POVtmpy,POVtmpz
        ENDDO
        IF(.NOT. BTEST(plotmask,2))THEN
          DO i = 1, knode2
            POVtmps = POVs(POVnode2d(1,i)) + POVdterp(i) * &
&                   (POVs(POVnode2d(2,i))-POVs(POVnode2d(1,i)))
            WRITE(POVUNIT) POVtmps
          ENDDO
        ENDIF
        IF(BTEST(plotmask,3))THEN
          DO i = 1, knode2
            POVtmpt = POVt(POVnode2d(1,i)) + POVdterp(i) * &
&                     (POVt(POVnode2d(2,i))-POVt(POVnode2d(1,i)))
            WRITE(POVUNIT) POVtmpt
          ENDDO
        ENDIF
        DO i = 1, kcell
          WRITE(POVUNIT) (POVcell(j,i), j = 1, 3)
        ENDDO
      ENDIF
    ENDIF
  ENDIF

!=======================================================================
! Check the domain surfaces and the static surfaces
  CALL V3_GetState(10, ivec, rvec, cstr)
  maxnsurf = ivec(4)
  domsurfctr = 0
  DO k = 1, maxnsurf
    ivec(1) = k
    ivec(2) = 65536
    rvec(10) = -1.
    rvec(11) = -1.
    rvec(12) = -1.
    rvec(13) = -1.
    cstr = ''
    CALL V3_SetState(10, ivec, rvec, cstr)
    CALL V3_GetState(10, ivec, rvec, cstr)
    plotmask = ivec(2)
    CALL PlotMaskModifyV3(plotmask)
    typ = ivec(3)
    IF(typ.EQ.1)domsurfctr = domsurfctr + 1
    nam = cstr(1:20)
    IF(BTEST(plotmask,0))THEN
      SELECT CASE(typ)
        CASE(1) ! Domain Surface
!         THIS DOES NOT ACCOUNT FOR TRIANGLES IN DOMAIN SURFACES !!!
          typ = 5
          CALL V3_GetStruc(321, pPOVnsurf, knsurf)
          CALL V3_GetStruc(324, pPOVscel, ksurf)
          IF(domsurfctr.EQ.1)THEN
            domstart = 1
          ELSE
            domstart = POVnsurf(1,domsurfctr-1) + 1
          ENDIF
          kcell = 2*(POVnsurf(1,domsurfctr)-domstart+1) ! converting to tris
          knode2 = 2*kcell ! Must use all points, unfortunately
          IF(knode2.NE.0 .AND. kcell.NE.0)THEN
            WRITE(POVUNIT) knode2, kcell, typ, nam, plotmask
            WRITE(*,*) knode2,kcell,typ,nam,plotmask
            DO i = domstart, POVnsurf(1,domsurfctr)
              WRITE(POVUNIT) (POVxyz(j,POVscel(1,i)), j = 1, 3)
              WRITE(POVUNIT) (POVxyz(j,POVscel(2,i)), j = 1, 3)
              WRITE(POVUNIT) (POVxyz(j,POVscel(3,i)), j = 1, 3)
IF(POVscel(4,i).EQ.0)PRINT*,'ERROR: FOUND TRIANGLE IN DOMAIN SURFACE'
              WRITE(POVUNIT) (POVxyz(j,POVscel(4,i)), j = 1, 3)
            ENDDO
            IF(.NOT. BTEST(plotmask,2))THEN
              DO i = domstart, POVnsurf(1,domsurfctr)
                WRITE(POVUNIT) POVs(POVscel(1,i))
                WRITE(POVUNIT) POVs(POVscel(2,i))
                WRITE(POVUNIT) POVs(POVscel(3,i))
                WRITE(POVUNIT) POVs(POVscel(4,i))
              ENDDO
            ENDIF
            IF(BTEST(plotmask,3))THEN
              DO i = domstart, POVnsurf(1,domsurfctr)
                WRITE(POVUNIT) POVt(POVscel(1,i))
                WRITE(POVUNIT) POVt(POVscel(2,i))
                WRITE(POVUNIT) POVt(POVscel(3,i))
                WRITE(POVUNIT) POVt(POVscel(4,i))
              ENDDO
            ENDIF
            ctr = 0
            DO i = domstart, POVnsurf(1,domsurfctr)
              WRITE(POVUNIT) ctr+1, ctr+2, ctr+3
              WRITE(POVUNIT) ctr+1, ctr+3, ctr+4
              ctr = ctr+4
            ENDDO
          ENDIF

        CASE(2,4,7) ! Planar,Program,Iso
          CALL V3_GetStruc(211, pPOVnode2d, knode2)
          CALL V3_GetStruc(213, pPOVdterp, knode2)
          CALL V3_GetStruc(214, pPOVcell, kcell)
          IF(knode2.NE.0 .AND. kcell.NE.0)THEN
            WRITE(POVUNIT) knode2, kcell, typ, nam, plotmask
            WRITE(*,*) knode2,kcell,typ,nam,plotmask
            DO i = 1, knode2
              POVtmpx = POVxyz(1,POVnode2d(1,i)) + POVdterp(i) * &
&                       (POVxyz(1,POVnode2d(2,i))-POVxyz(1,POVnode2d(1,i)))
              POVtmpy = POVxyz(2,POVnode2d(1,i)) + POVdterp(i) * &
&                       (POVxyz(2,POVnode2d(2,i))-POVxyz(2,POVnode2d(1,i)))
              POVtmpz = POVxyz(3,POVnode2d(1,i)) + POVdterp(i) * &
&                       (POVxyz(3,POVnode2d(2,i))-POVxyz(3,POVnode2d(1,i)))
              WRITE(POVUNIT) POVtmpx,POVtmpy,POVtmpz
            ENDDO
            IF(.NOT. BTEST(plotmask,2))THEN
              DO i = 1, knode2
                POVtmps = POVs(POVnode2d(1,i)) + POVdterp(i) * &
&                         (POVs(POVnode2d(2,i))-POVs(POVnode2d(1,i)))
                WRITE(POVUNIT) POVtmps
              ENDDO
            ENDIF
            IF(BTEST(plotmask,3))THEN
              DO i = 1, knode2
                POVtmpt = POVt(POVnode2d(1,i)) + POVdterp(i) * &
&                         (POVt(POVnode2d(2,i))-POVt(POVnode2d(1,i)))
                WRITE(POVUNIT) POVtmpt
              ENDDO
            ENDIF
            DO i = 1, kcell
              WRITE(POVUNIT) (POVcell(j,i), j = 1, 3)
            ENDDO
          ENDIF

      END SELECT
    ENDIF
  ENDDO

!=======================================================================
! Get Bubbles/Particles
  CALL V3_GetState(12,ivec,rvec,cstr)
  maxnsurf = ivec(2) ! Number of bubbles
  typ = 19
  nam = 'Bubbles/Particles'
  CALL V3_GetState(16,ivec,rvec,cstr)
  plotmask = ivec(2)
  IF(maxnsurf.GT.0)THEN
    WRITE(POVUNIT) -19, maxnsurf, typ, nam, plotmask
    WRITE(*,*) -19, maxnsurf, typ, nam, plotmask
    DO k = 1, maxnsurf
      CALL V3_SetState(12,k,rvec,cstr) ! Set the bubble index
      CALL V3_GetState(12,ivec,rvec,cstr)
      ivec(1) = ivec(4)
      DO i = 1, 8
        nodeweights(i) = rvec(i)
      ENDDO
      CALL V3_GetState(-3,ivec,rvec,cstr)
      POVtmpx = 0.
      POVtmpy = 0.
      POVtmpz = 0.
      POVtmps = 0.
      POVtmpt = 0.
      DO i = 1, ivec(1)
        POVtmpx = POVtmpx + nodeweights(i)*POVxyz(1,ivec(1+i))
        POVtmpy = POVtmpy + nodeweights(i)*POVxyz(2,ivec(1+i))
        POVtmpz = POVtmpz + nodeweights(i)*POVxyz(3,ivec(1+i))
        POVtmps = POVtmps + nodeweights(i)*POVs(ivec(1+i))
!        POVtmpt = POVtmpt + nodeweights(i)*POVt(ivec(1+i))
      ENDDO
      WRITE(POVUNIT) POVtmpx,POVtmpy,POVtmpz,POVtmps!,POVtmpt
    ENDDO
  ENDIF

!=======================================================================
! Streamlines
  CALL V3_GetState(11,ivec,rvec,cstr)
  maxnsurf = ivec(2) ! Number of bubbles
  typ = 18
  nam = 'Streamlines'
  CALL V3_GetState(16,ivec,rvec,cstr)
  domstart = ivec(1)
  plotmask = ivec(2)
  IF(maxnsurf.GT.0)THEN
    DO k = 1, maxnsurf
      ivec(1) = k
      CALL V3_SetState(11,ivec,rvec,cstr)
      CALL V3_GetStruc(101,pPOVcellsl,kstream)
      CALL V3_GetStruc(102,pPOVweightsl,kstream)
      CALL V3_GetStruc(103,pPOVtimesl,kstream)
      CALL V3_GetStruc(104,pPOVanglesl,kstream)
      knode2 = 0
      IF(domstart.EQ.1 .OR. domstart.EQ.3) knode2 = kstream
      WRITE(*,*) knode2, kstream, typ, nam, plotmask
      WRITE(POVUNIT) knode2, kstream, typ, nam, plotmask
      DO i = 1, kstream
        ivec(1) = POVcellsl(i)
        CALL V3_GetState(-3,ivec,rvec,cstr)
        POVtmpx = 0.
        POVtmpy = 0.
        POVtmpz = 0.
        POVtmps = 0.
        DO j = 1, ivec(1)
          POVtmpx = POVtmpx + POVweightsl(j,i)*POVxyz(1,ivec(1+j))
          POVtmpy = POVtmpy + POVweightsl(j,i)*POVxyz(2,ivec(1+j))
          POVtmpz = POVtmpz + POVweightsl(j,i)*POVxyz(3,ivec(1+j))
          POVtmps = POVtmps + POVweightsl(j,i)*POVs(ivec(1+j))
        ENDDO
        WRITE(POVUNIT) POVtmpx,POVtmpy,POVtmpz,POVtmps,POVanglesl(i),POVtimesl(i)
      ENDDO
    ENDDO
  ENDIF


  pPOVxyz = 0
  pPOVs = 0
  pPOVt = 0
  pPOVnode2d = 0
  pPOVdterp = 0
  pPOVcell = 0
  CLOSE(POVUNIT)

  WRITE(*,"(A,I4,A)") '*** Generation ',fwctr,' Complete ***'
