#include "parameters.h"
#define MAGN 0.1
#ifdef PV3SERIAL
#  define GETSTATE V3_GetState
#else
#  define GETSTATE pV_GetState
#endif
!#######################################################################
SUBROUTINE pVDraw2D (istat)
!#######################################################################
  USE server_common, ONLY: ddtoggle2d
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: istat

  SELECT CASE(istat)
    CASE(0)
      IF(ddtoggle2d) CALL Draw2DDataDisplay
    CASE(1)
  END SELECT

END SUBROUTINE pVDraw2D

!#######################################################################
SUBROUTINE pVDraw1D (istat)
!#######################################################################
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: istat


END SUBROUTINE pVDraw1D

!#######################################################################
SUBROUTINE Draw2DDataDisplay()
!#######################################################################
  USE server_common, ONLY: winid
  IMPLICIT NONE
# ifdef PV3SERIAL
    INTEGER(KIND=BSIZE) :: ivec(8)
# else
    INTEGER :: ivec(8)
# endif
  REAL :: rvec(8)
  REAL :: fcol(3), fsize, fwidth, fxyz(3), ang
  CHARACTER :: str
  CHARACTER(LEN=32) :: strng

  fxyz  = (/.5,-1.,0./)
  ang = 0.
  fsize = MAGN/4.
  fwidth = 1.
  fcol = 1.

  CALL GETSTATE( 3, ivec, rvec, str )
  SELECT CASE(ivec(1))
    CASE(2)
      WRITE(strng,"(A)") 'Planar Cut z='
    CASE(4)
#     ifdef PV3SERIAL
        WRITE(strng,"(A,F8.4)") 'Prog Cut z=',rvec(1)
#     else
      SELECT CASE(ivec(2))
        CASE(1)
          WRITE(strng,"(A,F8.4)") 'M`-T Cut z=',rvec(1)
        CASE(2)
          WRITE(strng,"(A,F8.4)") 'R-Z Cut z=',rvec(1)
        CASE(3)
          WRITE(strng,"(A,F8.4)") 'R Cut z=',rvec(1)
        CASE(4)
          WRITE(strng,"(A,F8.4)") 'T Cut z=',rvec(1)
        CASE(5)
          WRITE(strng,"(A,F8.4)") 'Z Cut z=',rvec(1)
        CASE(6)
          WRITE(strng,"(A,F8.4)") 'X Cut z=',rvec(1)
        CASE(7)
          WRITE(strng,"(A,F8.4)") 'Y Cut z=',rvec(1)
      END SELECT
#     endif
    CASE(5)
      WRITE(strng,"(A)") 'Mapped Surface'
    CASE(6)
      WRITE(strng,"(A)") 'Mapped Surf with Function'
    CASE(7)
      WRITE(strng,"(A,F8.4)") 'Iso z=',rvec(1)
    CASE DEFAULT
      RETURN
  END SELECT
# ifdef PV3SERIAL
    CALL XftnString(winid(2), 2, fcol, fxyz, TRIM(ADJUSTL(strng)))
# else
    CALL pV_Annotate2D(0, fcol, fsize, fwidth, fxyz, ang, TRIM(ADJUSTL(strng)))
# endif

END SUBROUTINE Draw2DDataDisplay
