#include "parameters.h"
!#######################################################################
SUBROUTINE pVEquiv(listeq)
!#######################################################################
  USE common_area, ONLY: runmode, ffmt, equivlist, gequiv
  IMPLICIT NONE

  INTEGER,INTENT(OUT) :: listeq(2,*)
  INTEGER :: i

  DEBUG1(' \ pVEquiv')
  DO i = 1, gequiv
    listeq(1,i) = equivlist(1,i)
    listeq(2,i) = equivlist(2,i)
  ENDDO
  DEALLOCATE(equivlist)
  DEBUG1(' / pVEquiv')

END SUBROUTINE pVEquiv

!#######################################################################
SUBROUTINE ReadEquivFile(numeq)
!#######################################################################
  USE common_area, ONLY: equivlist, gequiv
  IMPLICIT NONE
  INTEGER,INTENT(INOUT) :: numeq

  INTEGER :: i
  LOGICAL :: exists

  INQUIRE(FILE='equivalences.dat.r4',EXIST=exists)
  IF(exists)THEN
    OPEN(UNIT=EQUNIT,FILE='equivalences.dat.r4',FORM='unformatted')
    READ(EQUNIT) numeq
    WRITE(*,*) 'There are ',numeq,' equivalence pairs'
    ALLOCATE(equivlist(2,numeq))
    i = 1
    DO WHILE(i.LE.numeq)
      READ(EQUNIT,ERR=7000,END=9000) equivlist(1,i),equivlist(2,i)
      IF(equivlist(1,i).EQ.equivlist(2,i))THEN
        numeq = numeq - 1
        i = i - 1
      ENDIF
      i = i + 1
    ENDDO
    CLOSE(EQUNIT)
  ELSE
    numeq = 0
  ENDIF
  gequiv = numeq
  RETURN

7000 CONTINUE
     WRITE(*,*) 'Error Parsing Equivalence File'
9000 CONTINUE
     WRITE(*,*) 'Stopping at line ',i
     WRITE(*,*) 'Skipping Equivalences'
     numeq = 0
     CLOSE(EQUNIT)

END SUBROUTINE ReadEquivFile
