#include "parameters.h"
!#######################################################################
SUBROUTINE pVSafe()
!#######################################################################
  USE server_common
  IMPLICIT NONE

  INTEGER :: ivec(12), i, j
  REAL :: rvec(12)
  LOGICAL, SAVE :: first = .TRUE.
  CHARACTER(LEN=20) :: str


  IF(first)THEN
    DEBUG1(' \ pVSafe -- first')

    ivec(1)=1
    CALL pV_GetState(-3, ivec, rvec, str)
    numcs=ivec(4)
    ALLOCATE(inbld(numcs), rstate(numcs))
    inbld = 0
    rstate = 0

!-----------------------------------------------------------------------
! Turn off all replication to start.  This allows faster drawing.
    DO i = 1, numcs
      ivec(1)=i
      CALL pV_GetState(23, ivec, rvec, str)
      DO j = 1, ivec(2), 1
        ivec(1:3) = (/i, j, 0/)
        CALL pV_SetState(24, ivec, rvec, str)
      ENDDO
      ivec(2)=0
      CALL pV_SetState(23, ivec, rvec, str)
    ENDDO

!-----------------------------------------------------------------------
! Extract to get data off of the clients
! 0 - Runmode,  size 1, length 1
! 1 - Coordsys, size 1, length 1
! 2 - nbld,     size 1, length 1
    CALL pVRegisterCD
    CALL pVRegisterVC
    CALL pVRegisterSF
    CALL pVRegisterSA
    CALL pVRegisterRT
    CALL pVRegisterBL

    first = .NOT. first

    DEBUG1(' / pVSafe -- first')
  ENDIF ! first


END SUBROUTINE pVSafe

!#######################################################################
SUBROUTINE pVRegisterCD()
!#######################################################################
  IMPLICIT NONE

  INTEGER :: indx, subtype(12), subsize(12), subopt(12), subloc(12), exnum
  CHARACTER(LEN=20) :: nam

  EXTERNAL XRenderCD

  indx = 200
  nam = 'Client Data         '
  subtype = (/ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/)
  subsize = (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subopt  = (/ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/)
  subloc  = (/-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/)
  CALL pV_Register(indx, nam, subtype, subsize, subopt, subloc, XRenderCD, exnum)

END SUBROUTINE pVRegisterCD

!#######################################################################
SUBROUTINE pVRegisterVC()
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER :: indx, subtype(12), subsize(12), subopt(12), subloc(12), exnum
  CHARACTER(LEN=20) :: nam

  EXTERNAL XRenderVC

  extracton(1) = .FALSE.

  indx = 101
  nam = 'Vortex Cores        '
  subtype = (/ 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subsize = (/ 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subopt  = (/ 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subloc  = (/-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/)
  CALL pV_Register(indx, nam, subtype, subsize, subopt, subloc, XRenderVC, exnum)

END SUBROUTINE pVRegisterVC

!#######################################################################
SUBROUTINE pVRegisterSF()
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER :: indx, subtype(12), subsize(12), subopt(12), subloc(12), exnum
  CHARACTER(LEN=20) :: nam

  EXTERNAL XRenderSF

  extracton(2) = .FALSE.

  indx = 102
  nam = 'Shock Surfaces      '
  subtype = (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subsize = (/ 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subopt  = (/ 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subloc  = (/-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/)
  CALL pV_Register(indx, nam, subtype, subsize, subopt, subloc, XRenderSF, exnum)

END SUBROUTINE pVRegisterSF

!#######################################################################
SUBROUTINE pVRegisterSA()
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER :: indx, subtype(12), subsize(12), subopt(12), subloc(12), exnum
  CHARACTER(LEN=20) :: nam

  EXTERNAL XRenderSA

  extracton(3) = .FALSE.

  indx = EXT_SEPATT
  nam = 'Sep & Att Lines     '
  subtype = (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subsize = (/ 3, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subopt  = (/ 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subloc  = (/-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/)
  CALL pV_Register(indx, nam, subtype, subsize, subopt, subloc, XRenderSA, exnum)

END SUBROUTINE pVRegisterSA

!#######################################################################
SUBROUTINE pVRegisterRT()
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER :: indx, subtype(12), subsize(12), subopt(12), subloc(12), exnum
  CHARACTER(LEN=20) :: nam

  EXTERNAL XRenderRT

  extracton(5) = .FALSE.

  indx = EXT_RESIDENCE
  nam = 'Residence Time      '
  subtype = (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subsize = (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subopt  = (/ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subloc  = (/-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/)
  CALL pV_Register(indx, nam, subtype, subsize, subopt, subloc, XRenderRT, exnum)

END SUBROUTINE pVRegisterRT

!#######################################################################
SUBROUTINE pVRegisterBL()
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER :: indx, subtype(12), subsize(12), subopt(12), subloc(12), exnum
  CHARACTER(LEN=20) :: nam

  EXTERNAL XRenderBL

  extracton(5) = .FALSE.

  indx = EXT_BLWAKE
  nam = 'Boundary Layer/Wake '
  subtype = (/ 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subsize = (/ 3, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subopt  = (/ 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1/)
  subloc  = (/-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1/)
  CALL pV_Register(indx, nam, subtype, subsize, subopt, subloc, XRenderBL, exnum)

END SUBROUTINE pVRegisterBL
