#include "parameters.h"
!#######################################################################
SUBROUTINE pVSend(idisc)
!#######################################################################
  USE keydata, ONLY: timedisp, dimdisp, timesav, dt, reloadstatus, keyfilename
  USE server_common, ONLY: rstate
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: idisc
  INTEGER, SAVE :: timedisplast=0
  INTEGER :: keyarr(2)
  INTEGER          :: iarr(3)=(/1,2,3/)
  REAL             :: farr(3)=(/1.,2.,3./)
  CHARACTER(LEN=3) :: carr='abc'


  DEBUG2('   \ pVSend')
!=======================================================================
! Send key data
  keyarr = (/timedisp, dimdisp/)

  CALL pV_SendData(idisc, -1, SIG_STV_UPDATE, &
&                  2, keyarr,                 &
&                  0, farr,                   &
&                  0, carr)

!=======================================================================
! Send time-step data if necessary
  IF(timedisplast.NE.timedisp .AND. timedisp.EQ.2)THEN
    farr = (/dt, timesav, 0./)
    CALL pV_SendData(idisc, -1, SIG_TIM_UPDATE, &
&                    0, iarr,                   &
&                    3, farr,                   &
&                    0, carr)
  ENDIF

  timedisplast=timedisp

!=======================================================================
! Send command to reload a file
  SELECT CASE(reloadstatus)
    CASE(RSTATE_RELOAD_GRID) ! Reload grid file
! This is actually a very dangerous option. The structure of the grid
! must remain identical or I must change it...
      CALL pV_SendData(idisc, -1, SIG_RELOAD_GRID, 0, iarr, 0, farr, 80, keyfilename)
      rstate = RSTATE_RELOAD_GRID

    CASE(RSTATE_RELOAD_FLOW) ! Reload flow file
      CALL pV_SendData(idisc, -1, SIG_RELOAD_FLOW, 0, iarr, 0, farr, 80, keyfilename)
      rstate = RSTATE_RELOAD_FLOW

  END SELECT
  reloadstatus = 0

  IF(ALL(rstate.EQ.RSTATE_WAITING))THEN
    CALL pV_SendData(idisc, -1, SIG_RSTATE_CLEAR, 0, iarr, 0, farr, 0, carr)
    rstate = RSTATE_READY
  ENDIF

  DEBUG2('   / pVSend')
END SUBROUTINE pVSend

!#######################################################################
SUBROUTINE pVRubber (idwin, itype)
!#######################################################################
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: idwin, itype
  

END SUBROUTINE pVRubber
