#include "parameters.h"
!#######################################################################
SUBROUTINE pVSetExtract(indx, exnum, plotmask, reqmask, ival, rvec)
!#######################################################################
  USE server_common, ONLY: extracton
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: indx, exnum
  INTEGER,INTENT(OUT) :: plotmask,reqmask,ival
  REAL,INTENT(OUT) :: rvec(9)

  INTEGER*BSIZE :: ex
  INTEGER*BSIZE :: nextex
  INTEGER :: ivec(11), i, n, idisc
  INTEGER :: typ,num,numcs
  CHARACTER(LEN=20) :: str='', nam=''

  CALL pV_GetState(22, ivec, rvec, str)
  idisc = ivec(1)

  plotmask = 0
  reqmask = 0
  SELECT CASE(indx)
    CASE( EXT_VORTEX )
      ival = 0
      IF(extracton(1))THEN
        plotmask = 1
        reqmask = 1 + 2
      ENDIF

    CASE( EXT_SHOCKS )
      ival = 4
      rvec = .2
      IF(extracton(2))THEN
        plotmask = 1
        reqmask = 1
      ENDIF

    CASE( EXT_SEPATT )
      IF(extracton(3))THEN
        CALL pV_GetState(10, ivec, rvec, str)
        ival = 0
        ex = 0
        nextex = -1
        DO WHILE(nextex.NE.0)
          CALL pV_GetExtract(ex, typ, num, ivec, rvec, nam, nextex)
          n = 0
          DO i = 1, 20
            IF(str(i:i).NE.nam(i:i)) n = n + 1
          ENDDO
          IF(n.EQ.0)THEN
            ival = num
            EXIT
          ENDIF
          ex = nextex
        ENDDO

        IF(ival.EQ.0)THEN
          WRITE(*,*) ' pVSetExtract: Surface ',str,' NOT Found!'
          RETURN
        ENDIF
        plotmask = 1
        reqmask = 1 + 2
      ENDIF

    CASE( EXT_CLIENTDATA )
      reqmask = 1 ! Get first sub-extract only
      ival = 0
      rvec = 0.

    CASE( EXT_RESIDENCE )
    CASE( EXT_BLWAKE )
      ival = 0
      rvec = 0.
      IF(extracton(5))THEN
        plotmask = 1
        reqmask = 1 + 4
      ENDIF

  END SELECT

END SUBROUTINE pVSetExtract
