#include "parameters.h"
!#######################################################################
SUBROUTINE pVSurf(isurf, xpc, ypc, halfw)
!#######################################################################
  USE common_area, ONLY: runmode, diam
  USE keydata, ONLY: keym_1, keym_2
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: isurf
  REAL,INTENT(OUT) :: xpc, ypc, halfw

  INTEGER :: itype, nnode
  REAL :: rave, tave, zave, xave, yave, rdev, tdev, zdev, xdev, ydev
  REAL :: ave1,ave2,dev1,dev2

  COMMON /prime/ itype, rave, tave, zave, xave, yave, rdev, tdev, zdev, xdev, ydev, nnode

!  IF(xdev.EQ.0. .AND. ydev.EQ.0. .AND. zdev.EQ.0. .AND. rdev.EQ.0. .AND. tdev.EQ.0.)CALL MappingCalculations()
  SELECT CASE(keym_1)
    CASE(ICHAR('r'))
      ave1 = rave
      dev1 = rdev
    CASE(ICHAR('t'))
      ave1 = tave*diam
      dev1 = tdev*diam
    CASE(ICHAR('z'))
      ave1 = zave
      dev1 = zdev
    CASE(ICHAR('x'))
      ave1 = xave
      dev1 = xdev
    CASE(ICHAR('y'))
      ave1 = yave
      dev1 = ydev
    CASE(ICHAR('i')) ! NOT DONE YET
      ave1 = rave
      dev1 = rdev
    CASE(ICHAR('j')) ! NOT DONE YET
      ave1 = rave
      dev1 = rdev
    CASE(ICHAR('k')) ! NOT DONE YET
      ave1 = rave
      dev1 = rdev
  END SELECT
  SELECT CASE(keym_2)
    CASE(ICHAR('r'))
      ave2 = rave
      dev2 = rdev
    CASE(ICHAR('t'))
      ave2 = tave*diam
      dev2 = tdev*diam
    CASE(ICHAR('z'))
      ave2 = zave
      dev2 = zdev
    CASE(ICHAR('x'))
      ave2 = xave
      dev2 = xdev
    CASE(ICHAR('y'))
      ave2 = yave
      dev2 = ydev
    CASE(ICHAR('i')) ! NOT DONE YET
      ave2 = rave
      dev2 = rdev
    CASE(ICHAR('j')) ! NOT DONE YET
      ave2 = rave
      dev2 = rdev
    CASE(ICHAR('k')) ! NOT DONE YET
      ave2 = rave
      dev2 = rdev
  END SELECT
  xpc = ave1
  ypc = ave2
  halfw = (dev1+dev2)/FLOAT(nnode)

END SUBROUTINE pVSurf

!#######################################################################
SUBROUTINE pVXYSurf(kn, xyz, n, xyp)
!#######################################################################
  USE common_area, ONLY: runmode, coordsys, pgr, igrid, diam
  USE calc_coord, ONLY: Calc_CoordR, Calc_CoordT, Calc_CoordI, &
                        Calc_CoordJ, Calc_CoordK
  USE keydata, ONLY: keym_1, keym_2
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: n
  INTEGER,INTENT(IN) :: kn(n)
  REAL,INTENT(IN) :: xyz(3,*)
  REAL,INTENT(OUT) :: xyp(2,n)

  INTEGER :: i, k, nnode
  INTEGER :: itype
  REAL :: rave, tave, zave, xave, yave, rdev, tdev, zdev, xdev, ydev

  COMMON /prime/ itype, rave, tave, zave, xave, yave, rdev, tdev, zdev, xdev, ydev, nnode

  SELECT CASE(keym_1)
    CASE(ICHAR('r'))
      DO i = 1, n
        k = kn(i)
        xyp(1,i) = pgr(igrid)%r(k)
      ENDDO
    CASE(ICHAR('t'))
      DO i = 1, n
        k = kn(i)
        xyp(1,i) = pgr(igrid)%t0(k)*diam
      ENDDO
    CASE(ICHAR('z'))
      DO i = 1, n
        k = kn(i)
        xyp(1,i) = xyz(3,k)
      ENDDO
    CASE(ICHAR('x'))
      DO i = 1, n
        k = kn(i)
        xyp(1,i) = xyz(1,k)
      ENDDO
    CASE(ICHAR('y'))
      DO i = 1, n
        k = kn(i)
        xyp(1,i) = xyz(2,k)
      ENDDO
    CASE(ICHAR('i')) ! NOT FINISHED YET
    CASE(ICHAR('j')) ! NOT FINISHED YET
    CASE(ICHAR('k')) ! NOT FINISHED YET
  END SELECT
  SELECT CASE(keym_2)
    CASE(ICHAR('r'))
      DO i = 1, n
        k = kn(i)
        xyp(2,i) = pgr(igrid)%r(k)
      ENDDO
    CASE(ICHAR('t'))
      DO i = 1, n
        k = kn(i)
        xyp(2,i) = pgr(igrid)%t0(k)*diam
      ENDDO
    CASE(ICHAR('z'))
      DO i = 1, n
        k = kn(i)
        xyp(2,i) = xyz(3,k)
      ENDDO
    CASE(ICHAR('x'))
      DO i = 1, n
        k = kn(i)
        xyp(2,i) = xyz(1,k)
      ENDDO
    CASE(ICHAR('y'))
      DO i = 1, n
        k = kn(i)
        xyp(2,i) = xyz(2,k)
      ENDDO
    CASE(ICHAR('i')) ! NOT FINISHED YET
    CASE(ICHAR('j')) ! NOT FINISHED YET
    CASE(ICHAR('k')) ! NOT FINISHED YET
  END SELECT

END SUBROUTINE pVXYSurf
