#include "parameters.h"
!#######################################################################
SUBROUTINE pVThres(jkey, xyz, t)
!#######################################################################
  USE common_area
  USE keydata
  USE calc_coord, ONLY: Calc_CoordI, Calc_CoordJ, Calc_CoordK
  IMPLICIT NONE

  REAL, INTENT(IN)    :: xyz(3,*)
  REAL, INTENT(INOUT) :: t(*)
  INTEGER, INTENT(IN) :: jkey
  INTEGER m, mvmax

  DEBUG2('   \ pVThres')
  mvmax = pgr(igrid)%tpts
  SELECT CASE(key2_t)
    CASE(ICHAR('i'))
      IF(.NOT. ASSOCIATED(pgr(igrid)%i)) CALL Calc_CoordI
      DO m = 1, mvmax
        t(m) = pgr(igrid)%i(m)
      ENDDO
    CASE(ICHAR('j'))
      IF(.NOT. ASSOCIATED(pgr(igrid)%j)) CALL Calc_CoordJ
      DO m = 1, mvmax
        t(m) = pgr(igrid)%j(m)
      ENDDO
    CASE(ICHAR('k'))
      IF(.NOT. ASSOCIATED(pgr(igrid)%k)) CALL Calc_CoordK
      DO m = 1, mvmax
        t(m) = pgr(igrid)%k(m)
      ENDDO
    CASE(ICHAR('x'))
      DO m = 1, mvmax
        t(m) = xyz(1,m)
      ENDDO
    CASE(ICHAR('y'))
      DO m = 1, mvmax
        t(m) = xyz(2,m)
      ENDDO
    CASE DEFAULT
      DO m = 1, mvmax
        t(m) = xyz(3,m)
      ENDDO
  END SELECT
  DEBUG2('   / pVThres')

END SUBROUTINE pVThres
