#include "parameters.h"
#define FLOW pfw(itime)%
!#######################################################################
SUBROUTINE pVVect(key, v)
!#######################################################################
  USE keydata
  USE common_area
  USE calc_vel, ONLY: Calc_VelocityXRel, Calc_VelocityYRel, &
                      Calc_VelocityXAbs, Calc_VelocityYAbs
  USE calc_vrtc, ONLY: Calc_Vort, Calc_VorticityX, Calc_VorticityY, &
                       Calc_VorticityZabs
  USE mod_events
  IMPLICIT NONE

  REAL, DIMENSION(3,*) :: v
  REAL omgr
  INTEGER m,mvmax
  INTEGER,INTENT(IN) :: key
  INTEGER,SAVE :: ctr = 0

  DEBUG2('   \ pVVect')
  ctr = ctr + 1
  mvmax = pgr(igrid)%tpts
  SELECT CASE(event_get_secondary(eventstr))
!=======================================================================
! Absolute Velocity
    CASE(1)
      CALL VKeyAllocStat(2)
      IF(.NOT.uvstat(2))THEN
        uvstat(2)=.TRUE.
        CALL Clear_Mem_VM
        CALL Clear_Mem_FX
      ENDIF
      IF(.NOT. ASSOCIATED(FLOW vxabs))CALL Calc_VelocityXAbs
      IF(.NOT. ASSOCIATED(FLOW vyabs))CALL Calc_VelocityYAbs
      SELECT CASE(coordsys)
        CASE(CARTESIAN)
          DO m=1,mvmax
            v(1,m) = FLOW vxabs(m)
            v(2,m) = FLOW vyabs(m)
            v(3,m) = FLOW vz(m)
          ENDDO
        CASE DEFAULT
          DO m=1,mvmax
            v(1,m) = FLOW vxabs(m)
            v(2,m) = FLOW vyabs(m)
            v(3,m) = -FLOW vz(m)
          ENDDO
      END SELECT
!=======================================================================
! Relative Vorticity
    CASE(4)
      CALL VKeyAllocStat(3)
      IF(.NOT.uvstat(3))THEN
        uvstat(3)=.TRUE.
        CALL Clear_Mem_VM
        CALL Clear_Mem_FX
      ENDIF
      IF(.NOT. ASSOCIATED(FLOW vortz))CALL Calc_Vort
      IF(.NOT. ASSOCIATED(FLOW vortx))CALL Calc_VorticityX
      IF(.NOT. ASSOCIATED(FLOW vorty))CALL Calc_VorticityY
      DO m=1,mvmax
        v(1,m) = FLOW vortx(m)
        v(2,m) = FLOW vorty(m)
        v(3,m)=-FLOW vortz(m)
      ENDDO
!=======================================================================
! Absolute Vorticity
    CASE(3)
      CALL VKeyAllocStat(4)
      IF(.NOT.uvstat(4))THEN
        uvstat(4)=.TRUE.
        CALL Clear_Mem_VM
        CALL Clear_Mem_FX
      ENDIF
      IF(.NOT. ASSOCIATED(FLOW vortz))CALL Calc_Vort
      IF(.NOT. ASSOCIATED(FLOW vortzabs))CALL Calc_VorticityZAbs
      IF(.NOT. ASSOCIATED(FLOW vortx))CALL Calc_VorticityX
      IF(.NOT. ASSOCIATED(FLOW vorty))CALL Calc_VorticityY
      DO m=1,mvmax
        v(1,m) = FLOW vortx(m)
        v(2,m) = FLOW vorty(m)
        v(3,m) = FLOW vortzabs(m)
      ENDDO
!=======================================================================
! Relative Velocity
    CASE DEFAULT ! CASE(2)
      CALL VKeyAllocStat(1)
      IF(.NOT.uvstat(1))THEN
        uvstat(1)=.TRUE.
        CALL Clear_Mem_VM
        CALL Clear_Mem_FX
      ENDIF
      IF(.NOT. ASSOCIATED(FLOW vx))CALL Calc_VelocityXRel
      IF(.NOT. ASSOCIATED(FLOW vy))CALL Calc_VelocityYRel
      SELECT CASE(coordsys)
        CASE(CARTESIAN)
          DO m=1,mvmax
            v(1,m)=FLOW vx(m)
            v(2,m)=FLOW vy(m)
            v(3,m)=FLOW vz(m)
          ENDDO
        CASE DEFAULT
          DO m=1,mvmax
            v(1,m)=FLOW vx(m)
            v(2,m)=FLOW vy(m)
            v(3,m)=-FLOW vz(m)
          ENDDO
      END SELECT
  END SELECT
  DEBUG2('   / pVVect')

END SUBROUTINE pVVect
