MODULE MOD_BCDefs

IMPLICIT NONE
!
! IBTYP=200-299 is reserved for plane-periodic condition with user-supplied overlap
!


!--------------------------------------------------------------------
! COMMON BC's




!--------------------------------------------------------------------
! CFD BC's
INTEGER, PARAMETER :: WALL_NA  = 1   !Wall, no slip, adiabatic
INTEGER, PARAMETER :: WALL_SA  = 2   !Wall, slip,    adiabatic
INTEGER, PARAMETER :: WALL_NI  = 3   !Wall, no slip, isothermal
INTEGER, PARAMETER :: WALL_SI  = 4   !Wall, slip,    isothermal

INTEGER, PARAMETER :: SYM_Y    = 12  !Symmetry in Y
INTEGER, PARAMETER :: OGRID   = 20  !O-Grid periodic
INTEGER, PARAMETER :: EXTRAP   = 35  !Extrapolation

INTEGER, PARAMETER :: V_IN     = 36  !Velocity Inflow
INTEGER, PARAMETER :: P_OUT    = 37  !Pressure outflow
INTEGER, PARAMETER :: FARFIELD = 38  !Farfield
INTEGER, PARAMETER :: CYL_OUT  = 39  !Outflow for cylindrical grids
INTEGER, PARAMETER :: PTTOT_IN = 40  !Total pressure and total temperatre inflow

INTEGER, PARAMETER :: nCFDBC = 40  !Maximum CFD boundary condition number
CHARACTER(len=40), DIMENSION(nCFDBC) :: CFDbcname = ''



!--------------------------------------------------------------------
! CEM BC's



!--------------------------------------------------------------------
! CEMPP BC's





CONTAINS



SUBROUTINE InitBCNames()

INTEGER :: n
CHARACTER(LEN=10) :: tmpstr

!Initilize to dummy names
DO n = 1, nCFDBC
   WRITE(tmpstr,"(I6)") n
   CFDbcname(n) = 'Unkown BC ' // ADJUSTL(TRIM(tmpstr))
ENDDO

!--------------------------------------------------------------------
! CFD BC's
CFDbcname(WALL_NA) = 'No Slip Adiabatic Wall'
CFDbcname(WALL_SA) = 'Slip Adiabatic Wall'
CFDbcname(WALL_NI) = 'No Slip Isothermal Wall'
CFDbcname(WALL_SI) = 'Slip Isothermal Wall'

CFDbcname(SYM_Y) = 'Y - Symmetry'
CFDbcname(OGRID) = 'OGrid Periodic'
CFDbcname(EXTRAP) = 'Extrapolation'

CFDbcname(V_IN) = 'Velocity Inflow'
CFDbcname(P_OUT) = 'Pressure Outflow'
CFDbcname(FARFIELD) = 'Farfield'
CFDbcname(CYL_OUT) = 'Cylindric Outflow'
CFDbcname(PTTOT_IN) = 'Total P&T Inflow'



END SUBROUTINE InitBCNames


END MODULE MOD_BCDefs
