!#######################################################################
!	an example of adding a function that adds a scripting capability
!
!      SUBROUTINE V3PScript(iwin, itype, ie, je, istate)
!
!	Programmed Events Loop - Check and use appropriate events
!
!	  called right after the event is pulled of the queue,
!	  therefore if this routine changes the event info, Visual3
!	  uses the changed data.  events can be ignored by resetting
!	  the window id to -1/0.  use V3_GetState(0, ...) to get
!	  window data.
!
!	where:	iwin 	- X window id of event
!			  -1 - no event and break out of event collection
!			   0 - no event but continue in tight loop
!		itype	- type of X event
!			   2 - KeyPress
!			   3 - KeyRelease
!			   4 - ButtonPress
!			   5 - ButtonRelease
!		ie	- x pixel number
!		je	- y pixel number
!		istate	- state info (key stroke or button #)
!
!	script entry:
!
!		iwin, itype, ie, je, istate	1x,6I13
!
!	special notes:
!		iwin is index to winid
!		   0 is SetState data
!		  -2 is an answer to a text question/mouse function
!		istate negative is index to keybin
!
!		4 more lines are used for SetState/Question:
!		   6 ivec values		1x,6I13
!		  12 rvecd (2 lines)		1x,6E13.6  (not for -2)
!		  string			A80
!
!#######################################################################
!      INTEGER, PARAMETER :: lun = 98
!
!      SAVE     keybin, winid, first, script, filenm, linenm, rw
!      SAVE     xform, cut, rvec5, tool, lastw, iopt, ltool
!      INTEGER*4    winid(8), keybin(32), ivec(6), iwin
!      REAL         rvecd(12), xform(12), cut(9), tool(7), rvec5(4)
!      LOGICAL      first, script, flag, rw
!      CHARACTER*80 scstr, filenm
!      DATA first/.TRUE./, script/.FALSE./
!
!-----------------------------------------------------------------------
!     the first time in - get window ids and special key bindings
!      IF(first)THEN
!        CALL V3_GetState( 0, winid,  rvecd, scstr)
!        CALL V3_GetState(-1, keybin, rvecd, scstr)
!        CALL V3_GetState(-2, ivec,   rvecd, scstr)
!        iopt  = ivec(1)
!        first = .FALSE.
!      ENDIF
!
!=======================================================================
!     3D window
!=======================================================================
      IF(winid(3) .EQ. iwin)THEN
!       "?" hit
!        IF(itype .EQ. 2 .AND. istate .EQ. keybin(21))THEN
!          WRITE(*,*) ' E - Toggle Scripting Read'
!          WRITE(*,*) ' Q - Toggle Scripting Write'
!        ENDIF
!-----------------------------------------------------------------------
! "E" hit
        IF((itype .EQ. 2 .AND. istate .EQ. ICHAR('E')).OR.dodemo)THEN
          script = .NOT. script
          IF(script)THEN
            rw = .TRUE.
!           get filename
            IF(dodemo)THEN
              filenm=demoscript
              dodemo = .NOT. dodemo
            ELSE
              CALL V3_Cursor(.TRUE.)
 7001         WRITE(*,*) ' Enter Script Filename'
              READ(*,'(a)') filenm
              WRITE(*,*) ' '
              INQUIRE(FILE=filenm, EXIST=flag)
              IF(.NOT. flag)THEN
                WRITE(*,*) ' ERROR - File does NOT exist!'
                WRITE(*,*) ' '
                GOTO 7001
              ENDIF
              CALL V3_Cursor(.FALSE.)
            ENDIF
            CALL ExtraDemoDat(1)
            OPEN(UNIT=lun, FILE=filenm, STATUS='old')
            linenm = 0
          ELSE
            CLOSE(lun)
            WRITE(*,*) ' Script Processing off!'
            WRITE(*,*) ' '
          ENDIF
        ENDIF 

!-----------------------------------------------------------------------
! "Q" hit
        IF(itype.EQ.2 .AND. istate.EQ.ICHAR('Q'))THEN
          script = .NOT. script
          IF(script)THEN
            rw = .FALSE.
            CALL V3_Cursor(.TRUE.)
!       get filename
            WRITE(*,*) ' Enter Script Filename [Default: demo.out]'
            READ(*,'(a)') filenm
            WRITE(*,*) ' '
            IF(TRIM(filenm).EQ.'')THEN
              filenm='demo.out'
            ENDIF
            CALL V3_Cursor(.FALSE.)
            CALL ExtraDemoDat(0)
            OPEN(UNIT=lun, FILE=filenm, STATUS='unknown')
!       Transformation matrix for the 3D view
            CALL V3_GetState(1, ivec, xform, scstr)
            WRITE(lun,1000) 0,1,0,0,0
            WRITE(lun,1000) ivec
            WRITE(lun,1001) (xform(i),i=1,6)
            WRITE(lun,1001) (xform(i),i=7,12)
            WRITE(lun,1002) scstr
!       Current planar cut coordinates
            CALL V3_GetState(2, ivec, cut, scstr)
            WRITE(lun,1000) 0,2,0,0,0
            WRITE(lun,1000) ivec
            WRITE(lun,1001) (cut(i),i=1,6)
            WRITE(lun,1001) (cut(i),i=7,9)
            WRITE(lun,1002) scstr
!       Current scalar tool / cut planes
            CALL V3_GetState(3, ivec, tool, scstr)
            WRITE(lun,1000) 0,3,0,0,0
            WRITE(lun,1000) ivec
            WRITE(lun,1001) (tool(i),i=1,5)
            WRITE(lun,1001) (rvecd(i),i=7,12)
            WRITE(lun,1002) scstr
            WRITE(lun,*) udefsrf
!       Current scalar state
            CALL V3_GetState(5, ivec5, rvec5, scstr)
            WRITE(lun,1000) 0,5,0,0,0
            WRITE(lun,1000) ivec5
            WRITE(lun,1001) (rvec5(i),i=1,6)
            WRITE(lun,1001) (rvec5(i),i=7,9)
            WRITE(lun,1002) scstr
            WRITE(lun,*) key1_1, key2_1
!       Current vector state
            CALL V3_GetState(6, ivec6, rvec6, scstr)
            WRITE(lun,1000) 0,6,0,0,0
            WRITE(lun,1000) ivec6
            WRITE(lun,1001) (rvec6(i),i=1,6)
            WRITE(lun,1001) (rvec6(i),i=7,9)
            WRITE(lun,1002) scstr
!       Current threshold state
            CALL V3_GetState(7, ivec7, rvec7, scstr)
            WRITE(lun,1000) 0,7,0,0,0
            WRITE(lun,1000) ivec7
            WRITE(lun,1001) (rvec7(i),i=1,6)
            WRITE(lun,1001) (rvec7(i),i=7,9)
            WRITE(lun,1002) scstr
!       Current bubble state
            CALL V3_GetState(12, ivec12, rvec12, scstr)
            WRITE(lun,1000) 0,12,0,0,0
            WRITE(lun,1000) ivec12
            WRITE(lun,1001) (rvec12(i),i=1,6)
            WRITE(lun,1001) (rvec12(i),i=7,8)
            WRITE(lun,1002) scstr

            lastw = 0
            ltool = 0
          ELSE
            CLOSE(lun)
            WRITE(*,*) ' Script Processing off!'
            WRITE(*,*) ' '
          ENDIF
        ENDIF
      ENDIF

!=======================================================================
!  save events if writing the script
!=======================================================================
      IF(script .AND. .NOT.rw)THEN

!-----------------------------------------------------------------------
!  has an answer been made?
        CALL V3_GetState(8, ivec, rvecd, scstr)
        IF((ivec(1).NE.0 .OR. scstr.NE.' ') .AND. lastw.NE.-2)THEN
          WRITE(lun,1000) -2
          WRITE(lun,1000) ivec
          WRITE(lun,1002) scstr
          WRITE(lun,1000) -1
          lastw = -2
        ENDIF

!-----------------------------------------------------------------------
!  has the viewing transformation changed?
        CALL V3_GetState(1, ivec, rvecd, scstr)
        flag = .FALSE.
        DO i = 1, 12
          IF(rvecd(i) .NE. xform(i)) flag = .TRUE.
          xform(i) = rvecd(i)
        ENDDO
        IF(flag)THEN
          WRITE(lun,1000) 0,1,0,0,0
          WRITE(lun,1000) ivec
          WRITE(lun,1001) (rvecd(i),i=1,6)
          WRITE(lun,1001) (rvecd(i),i=7,12)
          WRITE(lun,1002) scstr
        ENDIF

!-----------------------------------------------------------------------
!  have the other scalar tools changed?
        ivec(1) = -1
        CALL V3_GetState(3, ivec, rvecd, scstr)
        itool = ivec(1)
        IF(itool.EQ.ltool)THEN
          IF(itool.GE.4 .AND. itool.LE.7)THEN
            flag = .FALSE.
            len = 5
            IF(itool.EQ.7) len = 1
            DO i = 1, len
              IF(rvecd(i).NE.tool(i)) flag = .TRUE.
              tool(i) = rvecd(i)
            ENDDO
            IF(flag)THEN
              WRITE(lun,1000) 0,3,0,0,0
!       ivec does not contain any valuable data, so we will force
!       an update of the rvec with the -1 option for V3_SetState(3)
!              WRITE(lun,1000) ivec
              WRITE(lun,1000) -1,0,0,0,0,0
              WRITE(lun,1001) (rvecd(i),i=1,6)
              WRITE(lun,1001) (rvecd(i),i=7,12)
              WRITE(lun,1002) scstr
              WRITE(lun,*) udefsrf
            ENDIF
          ENDIF
        ENDIF

!-----------------------------------------------------------------------
!  has the scalar state changed?
        CALL V3_GetState(5, ivec, rvecd, scstr)
        flag = .FALSE.
        DO i = 1, 2
          IF(ivec(i).NE.ivec5(i)) flag = .TRUE.
          ivec5(i) = ivec(i)
        ENDDO
        DO i = 1, 2
          IF(rvecd(i) .NE. rvec5(i)) flag = .TRUE.
          rvec5(i) = rvecd(i)
        ENDDO
        IF(flag)THEN
          WRITE(lun,1000) 0,5,0,0,0
          WRITE(lun,1000) ivec
          WRITE(lun,1001) (rvecd(i),i=1,6)
          WRITE(lun,1001) (rvecd(i),i=7,12)
          WRITE(lun,1002) scstr
          WRITE(lun,*) key1_1, key2_1
        ENDIF

!-----------------------------------------------------------------------
!  has the vector state changed?
        CALL V3_GetState(6, ivec, rvecd, scstr)
        flag = .FALSE.
        DO i = 1, 1
          IF(ivec(i).NE.ivec6(i)) flag = .TRUE.
          ivec6(i) = ivec(i)
        ENDDO
        DO i = 1, 1
          IF(rvecd(i) .NE. rvec6(i)) flag = .TRUE.
          rvec6(i) = rvecd(i)
        ENDDO
        IF(flag)THEN
          WRITE(lun,1000) 0,6,0,0,0
          WRITE(lun,1000) ivec
          WRITE(lun,1001) (rvecd(i),i=1,6)
          WRITE(lun,1001) (rvecd(i),i=7,12)
          WRITE(lun,1002) scstr
        ENDIF

!-----------------------------------------------------------------------
!  has the threshold state changed?
        CALL V3_GetState(7, ivec, rvecd, scstr)
        flag = .FALSE.
        DO i = 1, 3
          IF(ivec(i).NE.ivec7(i)) flag = .TRUE.
          ivec7(i) = ivec(i)
        ENDDO
        DO i = 1, 2
          IF(rvecd(i) .NE. rvec7(i)) flag = .TRUE.
          rvec7(i) = rvecd(i)
        ENDDO
        IF(flag)THEN
          WRITE(lun,1000) 0,7,0,0,0
          WRITE(lun,1000) ivec
          WRITE(lun,1001) (rvecd(i),i=1,6)
          WRITE(lun,1001) (rvecd(i),i=7,12)
          WRITE(lun,1002) scstr
        ENDIF

!-----------------------------------------------------------------------
!  has the bubble state changed?
        CALL V3_GetState(12, ivec, rvecd, scstr)
        flag = .FALSE.
        DO i = 1, 4
          IF(ivec(i).NE.ivec12(i)) flag = .TRUE.
          ivec12(i) = ivec(i)
        ENDDO
        DO i = 1, 8
          IF(rvecd(i) .NE. rvec12(i)) flag = .TRUE.
          rvec12(i) = rvecd(i)
        ENDDO
        IF(flag)THEN
          WRITE(lun,1000) 0,12,0,0,0
          WRITE(lun,1000) ivec
          WRITE(lun,1001) (rvecd(i),i=1,6)
          WRITE(lun,1001) (rvecd(i),i=7,12)
          WRITE(lun,1002) scstr
        ENDIF

!-----------------------------------------------------------------------
!  has the Pointer/2D window pointer state changed
        IF(iwin .EQ. winid(2))THEN
          ivec(1) = ie
          ivec(2) = je
          ivec(3) = 0
          ivec(4) = 0
          CALL V3_GetState(-4, ivec, rvecd, scstr)
          IF(ivec(3).NE.0)THEN
            genpart = .TRUE.
            flag = .FALSE.
            DO i = 1, 4
              IF(ivec(i).NE.ivecm4(i)) flag = .TRUE.
              ivecm4(i) = ivec(i)
            ENDDO
            DO i = 1, 8
              IF(rvecd(i) .NE. rvecm4(i)) flag = .TRUE.
              rvecm4(i) = rvecd(i)
            ENDDO
            IF(flag .AND. ivec(3).NE.0)THEN
              WRITE(lun,1000) 0,-4,0,0,0
              WRITE(lun,1000) ivec
              WRITE(lun,1001) (rvecd(i),i=1,6)
              WRITE(lun,1001) (rvecd(i),i=7,12)
              WRITE(lun,1002) scstr
            ENDIF
          ELSE
            genpart = .FALSE.
          ENDIF
        ELSEIF(genpart)THEN
              WRITE(lun,1000) 0,-4,0,0,0
              WRITE(lun,1000) ivecm4
              WRITE(lun,1001) (rvecm4(i),i=1,6)
              WRITE(lun,1001) (rvecm4(i),i=7,12)
              WRITE(lun,1002) scstr
        ENDIF

!-----------------------------------------------------------------------
!  has the planar cut position changed?
        IF((itool.EQ.2 .AND. ltool.EQ.2) .OR. itool.NE.2)THEN
          CALL V3_GetState(2, ivec, rvecd, scstr)
          flag = .FALSE.
          DO i = 1, 9
            IF(rvecd(i).NE.cut(i)) flag = .TRUE.
            cut(i) = rvecd(i)
          ENDDO
          IF(flag)THEN
            WRITE(lun,1000) 0,2,0,0,0
            WRITE(lun,1000) ivec
            WRITE(lun,1001) (rvecd(i),i=1,6)
            WRITE(lun,1001) (rvecd(i),i=7,12)
            WRITE(lun,1002) scstr
          ENDIF
        ENDIF
        IF(iwin.EQ.-1) ltool = itool

!-----------------------------------------------------------------------
!  write the current event
        iwini = -1
        DO i = 1, 7
          IF(iwin.EQ.winid(i)) iwini = i
        ENDDO
        istati = istate
        IF(itype.EQ.2 .OR. itype.EQ.3)THEN
          DO i = 1, 32
            IF(istate.EQ.keybin(i)) istati = -i
          ENDDO
          IF(istati .gt. 255) iwini = -1
        ENDIF

!-----------------------------------------------------------------------
!  supress multiple -1s (redraws) - NOTE: this may cause problems
!	with streamline animation
        IF(iwini.EQ.-1)THEN
          IF(lastw.GT.0 .OR. iopt.NE.0)THEN
            WRITE(lun,1000) iwini
            lastw = iwini
          ENDIF
        ELSEIF(itype .NE. 3 .AND. itype .NE. 5)THEN
          WRITE(lun,1000) iwini, itype, ie, je, istati
          lastw = iwini
        ENDIF

      ENDIF

!=======================================================================
!  no more X events to process and reading from script
!  get next event from file
!=======================================================================
!      IF(iwin.EQ.-1 .AND. script .AND. rw .AND. scriptsent)THEN
      IF(iwin.EQ.-1 .AND. script .AND. rw)THEN
 7003   linenm = linenm + 1
        READ(lun,1000,END=7002,ERR=7099) iwin, itype, ie, je, istate

!-----------------------------------------------------------------------
!  get the current Xwindow id
        IF(iwin.GT.0)THEN
          IF(iwin.LE.7)THEN
            iwin = winid(iwin)
          ELSE
            iwin = -1
          ENDIF
!-----------------------------------------------------------------------
!  get the correct state for special keys
          IF(itype.EQ.2 .OR. itype.EQ.3)THEN
            IF(istate.LT.0 .AND. istate.GT.-32) istate = keybin(-istate)
          ENDIF
!-----------------------------------------------------------------------
!  do we need to pre-set an answer/mouse clicks?
          linenm = linenm + 1
          READ(lun,1000,END=7002,ERR=7099) iflag
          IF(iflag.EQ.-2)THEN
            linenm = linenm + 1
            READ(lun,1000,END=7002,ERR=7099) ivec
            linenm = linenm + 1
            READ(lun,1002,END=7002,ERR=7099) scstr
            CALL V3_SetState(8, ivec, rvecd, scstr)
          ELSE
            linenm = linenm - 1
            BACKSPACE lun
          ENDIF
!-----------------------------------------------------------------------
!  internal change of state (possibly from dial moves)
        ELSEIF(iwin.EQ.0)THEN
          linenm = linenm + 1
          READ(lun,1000,END=7002,ERR=7099) ivec
          linenm = linenm + 1
          READ(lun,1001,END=7002,ERR=7099) (rvecd(i),i=1,6)
          linenm = linenm + 1
          READ(lun,1001,END=7002,ERR=7099) (rvecd(i),i=7,12)
          linenm = linenm + 1
          READ(lun,1002,END=7002,ERR=7099) scstr
! These are actions which must be done before the setstate
          SELECT CASE(itype)
            CASE(-4)
              ivec(1)=ivec(3)
              ivec(2)=0
            CASE(3)
              linenm = linenm + 1
              READ(lun,*,END=7002,ERR=7099) udefsrf
            CASE(5) ! Scalar state update
              linenm = linenm + 1
              READ(lun,*,END=7002,ERR=7099) key1_1, key2_1
          END SELECT
          CALL V3_SetState(itype, ivec, rvecd, scstr)
! Resetting the inputs to v3pevents to cause appropriate actions
! on the part of the libraries
          SELECT CASE(itype)
            CASE(5,6,7) ! Scalar/Vector/Threshold state update
              CALL V3_SetState(0, ivec, rvecd, scstr)
          END SELECT
        ENDIF
      ENDIF

      RETURN

!=======================================================================
!	file handling
!=======================================================================
 7002 REWIND lun
      linenm = 0
      !GOTO 7003
      WRITE(*,*) ' END of Script file'
      WRITE(*,*) ' '
      script = .FALSE.
      CLOSE(lun)
      WRITE(*,*) ' Script Processing off!'
      WRITE(*,*) ' '
      iwin = -1
      RETURN
!
 7099 WRITE(*,*) ' ERROR in Script file at line #',linenm
      WRITE(*,*) ' '
      script = .FALSE.
      CLOSE(lun)
      WRITE(*,*) ' Script Processing off!'
      WRITE(*,*) ' '
      iwin = -1
      RETURN
!
 1000 FORMAT(1x,6i13)
 1001 FORMAT(1x,6e13.6)
 1002 FORMAT(a80)

!      END SUBROUTINE V3PScript
