#include <stdio.h>

#ifdef WIN32
#  define PREFIX __stdcall
#else
#  define PREFIX
#  ifdef UNDERSCORE
#    define PRINTTIMESTAMP printtimestamp_
#    define PRINTPV3VERSION printpv3version_
#    define GETSTEREOMODE getstereomode_
#  else
#    define PRINTTIMESTAMP printtimestamp
#    define PRINTPV3VERSION printpv3version
#    define GETSTEREOMODE getstereomode
#  endif
#endif

/*
  Time stamp and machinename data for compilation.
*/
void PREFIX
PRINTTIMESTAMP ()
{
   char *compdate=__DATE__;
   char *comptime=__TIME__;
   fprintf(stdout," Compilation timestamp: %11s %8s\n",compdate,comptime);
   fflush(stdout);
}

/*
  In order to help with versioning, a header named pv3.hdr has been created.
  Of course it requires C syntax and is printed at the very beginning of
  file execution.
*/
void PREFIX
PRINTPV3VERSION ()
{
#  include "pv3.hdr"
   fprintf(stdout," Running TV3 Version: %1d.%1d.%1d\n",majorversion,minorversion,subversion);
   fflush(stdout);
}

/*
  Returns the stereo mode for V3 applications
*/
int PREFIX
GETSTEREOMODE ()
{
  char *ster;

  ster=getenv("V3Stereo");
  if (ster==NULL) return 0;
  if ((strcmp(ster,"on")==0) || (strcmp(ster,"oN")==0) ||
      (strcmp(ster,"ON")==0) || (strcmp(ster,"On")==0)) {
    return 1;
  } else {
    return 0;
  }
}
