#ifndef WIIV3_H
#define WIIV3_H

#include <time.h>
/* Fortran inputs */

#define WIIMOTECONNECT 1
#define WIIMOTEDISCONNECT -1

#define MtnStrSiz    6
#define PI  3.14159265358979323
#define SMALL 0.000000001
#define DIALSTEPS 1024
#define DEADBAND 10


/* Wiimote Header */

struct WiiMotion {
      double a_x[MtnStrSiz];
      double a_y[MtnStrSiz];
      double a_z[MtnStrSiz];
      double a[MtnStrSiz];
      double pitch[MtnStrSiz];
      double roll[MtnStrSiz];
      double yaw[MtnStrSiz];
};
typedef struct WiiMotion WV3Motion_t;
WV3Motion_t WV3Motion;

struct acc {
      unsigned char x;
      unsigned char y;
      unsigned char z;
};
struct stick {
      int valid;
      int x;
      int y;
      int max[2];
      int min[2];
};

enum wiiv3mode {
      NOMODE,
      WIIMOTE_BTN,
      WIIMOTE_ACC_REL,
      WIIMOTE_ACC_ABS,
      WIIMOTE_IR,
      LASTMODE
};
struct WIIStatus {
      int update;
      int dails[9];
      enum wiiv3mode mode;
      int IRLocX;
      int IRLocY;
      unsigned char buttons;
      unsigned char nc_buttons;
      clock_t tyme[2];
};
typedef struct WIIStatus WV3Status_t;

double sensitivity;
int WMConnect();
int WMDisconnect();
WV3Status_t WMGetState();
int WMSetLED(unsigned char);
int WMSetRumble();
int WMStartMotion();
void WMClrIRData();
int WMSetReport();

#endif