!#######################################################################
SUBROUTINE XRenderCD(istat, exnum, plotmask, cid, cnt, len0, sub0, len1, sub1, &
                   len2, sub2, len3, sub3, len4, sub4, len5, sub5, len6, sub6, &
                 len7, sub7, len8, sub8, len9, sub9, len10, sub10, len11, sub11)
!#######################################################################
! This routine is really non-existent in terms of rendering.  This call
! is, however, advantageous because now I can set some variables.
  USE server_common
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: istat, exnum, plotmask, cid, cnt
  INTEGER,INTENT(INOUT) :: len0, len1, len2, len3, len4, len5, len6, &
                           len7, len8, len9, len10, len11
  INTEGER,DIMENSION(*) :: sub0, sub1, sub2, sub3, sub4, sub5, sub6, sub7, &
                          sub8, sub9, sub10, sub11

  INTEGER :: i

  IF(len0.EQ.5)THEN
    runmode = sub0(1)
    coordsys = sub0(2)
    inbld(cid) = sub0(3)
    rstate(cid) = sub0(4)
    nfunc = sub0(5)
  ENDIF

END SUBROUTINE XRenderCD

!#######################################################################
SUBROUTINE XRenderVC(istat, exnum, plotmask, cid, cnt, len0, sub0, len1, sub1, &
                   len2, sub2, len3, sub3, len4, sub4, len5, sub5, len6, sub6, &
                 len7, sub7, len8, sub8, len9, sub9, len10, sub10, len11, sub11)
!#######################################################################
! This routine renders the vortex cores.  Currently, the strength of the
! core is located in sub2, but it is not being used.  The set of values
! needs to be scaled to the current color field (strength 0 is min color
! and strength 1 is max color, non-dimensionally)
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: istat, exnum, plotmask, cid, cnt
  INTEGER,INTENT(INOUT) :: len0, len1, len2, len3, len4, len5, len6, &
                           len7, len8, len9, len10, len11
  INTEGER,DIMENSION(*) :: sub1
  REAL,DIMENSION(*) :: sub0, sub2, sub3, sub4, sub5, sub6, sub7, &
                       sub8, sub9, sub10, sub11

  INTEGER :: i, m, n
  REAL :: dummy(3)=(/0.,0.,0./)

  IF(plotmask.EQ.0 .OR. len0.LT.2)RETURN
  m = 0
  DO i = 1, len1
    n = sub1(i)-m
    CALL pV_Object3D(4, -1, sub0(3*m+1), dummy, dummy, n)
    m = sub1(i)
  ENDDO

END SUBROUTINE XRenderVC

!#######################################################################
SUBROUTINE XRenderSF(istat, exnum, plotmask, cid, cnt, len0, sub0, len1, sub1, &
                   len2, sub2, len3, sub3, len4, sub4, len5, sub5, len6, sub6, &
                 len7, sub7, len8, sub8, len9, sub9, len10, sub10, len11, sub11)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: istat, exnum, plotmask, cid, cnt
  INTEGER,INTENT(INOUT) :: len0, len1, len2, len3, len4, len5, len6, &
                           len7, len8, len9, len10, len11
  REAL,DIMENSION(*) :: sub0, sub1, sub2, sub3, sub4, sub5, sub6, sub7, &
                       sub8, sub9, sub10, sub11
  REAL :: dummy(3)=(/0.,0.,0./)

  IF(plotmask.EQ.0 .OR. len0.LT.3)RETURN
  CALL pV_Object3D(1, 0, sub0, dummy, dummy, len0);

END SUBROUTINE XRenderSF

!#######################################################################
SUBROUTINE XRenderSA(istat, exnum, plotmask, cid, cnt, len0, sub0, len1, sub1, &
                   len2, sub2, len3, sub3, len4, sub4, len5, sub5, len6, sub6, &
                 len7, sub7, len8, sub8, len9, sub9, len10, sub10, len11, sub11)
!#######################################################################
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: istat, exnum, plotmask, cid, cnt
  INTEGER,INTENT(INOUT) :: len0, len1, len2, len3, len4, len5, len6, &
                           len7, len8, len9, len10, len11
  REAL,DIMENSION(*) :: sub0, sub1, sub2, sub3, sub4, sub5, sub6, sub7, &
                       sub8, sub9, sub10, sub11
  REAL :: dummy(3)=(/0.,0.,0./)

  IF(plotmask.EQ.0)RETURN
  IF(len0.GT.1) CALL pV_Object3D(3, -1, sub0, dummy, dummy, len0-1);
  IF(len1.GT.1) CALL pV_Object3D(3, 0, sub1, dummy, dummy, len1-1);

END SUBROUTINE XRenderSA

!#######################################################################
SUBROUTINE XRenderRT(istat, exnum, plotmask, cid, cnt, len0, sub0, len1, sub1, &
                   len2, sub2, len3, sub3, len4, sub4, len5, sub5, len6, sub6, &
                 len7, sub7, len8, sub8, len9, sub9, len10, sub10, len11, sub11)
!#######################################################################
! Tris -- sub0
! XYZ  -- sub2
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: istat, exnum, plotmask, cid, cnt
  INTEGER,INTENT(INOUT) :: len0, len1, len2, len3, len4, len5, len6, &
                           len7, len8, len9, len10, len11
  REAL,DIMENSION(*) :: sub0, sub1, sub2, sub3, sub4, sub5, sub6, sub7, &
                       sub8, sub9, sub10, sub11

  IF(plotmask.EQ.0)RETURN

END SUBROUTINE XRenderRT

!#######################################################################
SUBROUTINE XRenderBL(istat, exnum, plotmask, cid, cnt, len0, sub0, len1, sub1, &
                   len2, sub2, len3, sub3, len4, sub4, len5, sub5, len6, sub6, &
                 len7, sub7, len8, sub8, len9, sub9, len10, sub10, len11, sub11)
!#######################################################################
! Tris -- sub0
! XYZ -- sub2
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: istat, exnum, plotmask, cid, cnt
  INTEGER,INTENT(INOUT) :: len0, len1, len2, len3, len4, len5, len6, &
                           len7, len8, len9, len10, len11
  REAL,DIMENSION(*) :: sub0, sub1, sub2, sub3, sub4, sub5, sub6, sub7, &
                       sub8, sub9, sub10, sub11
  REAL :: dummy(3)=(/0.,0.,0./)

  IF(plotmask.EQ.0)RETURN

END SUBROUTINE XRenderBL
