PROGRAM pivplane
  IMPLICIT NONE

  REAL x,y

  INTEGER :: mfl,msp,mbb,mle,mte,mtp,nbld,mvmax
  INTEGER :: i,j,k
  INTEGER :: side, jplane,dir
  REAL,ALLOCATABLE,DIMENSION(:) :: r,t,z
  REAL :: pspan,dist,newr,mindist,rmax,rmin
  REAL :: tmp1,tmp2
  REAL,DIMENSION(3) :: pnt1,pnt2,pnt3,vect1,vect2,cprod
  REAL,DIMENSION(3) :: xyz1,xyz2,xyz3
  CHARACTER(LEN=80) :: fnam
  LOGICAL :: ios


! Read Vstage grid
  ios=.FALSE.
  DO WHILE(.NOT.ios)
    WRITE(*,*) ' Enter grid file name ==>'
    READ(*,*) fnam
    INQUIRE(FILE=fnam,EXIST=ios)
  ENDDO

  OPEN(UNIT=10,FILE=fnam,FORM='unformatted')
  READ(10) mfl,msp,mbb,mle,mte,mtp,nbld
  WRITE(*,*) mfl,msp,mbb,mle,mte,mtp,nbld
  mvmax = mfl*msp*mbb
  ALLOCATE(r(mvmax),t(mvmax),z(mvmax))
  DO j = 1, msp
    READ(10) &
      ((z(i+(j-1)*mbb+(k-1)*mbb*msp),k=1,mfl),i=1,mbb), &
      ((r(i+(j-1)*mbb+(k-1)*mbb*msp),k=1,mfl),i=1,mbb), &
      ((t(i+(j-1)*mbb+(k-1)*mbb*msp),k=1,mfl),i=1,mbb)
  ENDDO
  CLOSE(10)

! Gather info
  WRITE(*,*) ' Enter percent span (0-100) ==>'
  READ(*,*) pspan
  WRITE(*,*) ' Enter b2b point (1-',mbb,') ==>'
  READ(*,*) side

  pspan = pspan/100.

! Extract %span that matches pspan closest
  rmax = MAXVAL(r)
  rmin = MINVAL(r)
  newr = pspan*(rmax-rmin)+rmin
  PRINT*,' looking for ',newr,' between ',rmin,' and ',rmax
  i = side
  DO j = 2, msp
    tmp1 = r(i+(j-1)*mbb+(mle-1)*mbb*msp)
    tmp2 = r(i+(j-2)*mbb+(mle-1)*mbb*msp)
    IF(tmp1.GE.newr .AND. tmp2.LE.newr)THEN
      PRINT*,' Found leading edge'
      pnt1(1) = newr
      pnt1(2) = (tmp1-newr)/(tmp1-tmp2)*t(i+(j-1)*mbb+(mle-1)*mbb*msp) + &
&               (newr-tmp2)/(tmp1-tmp2)*t(i+(j-2)*mbb+(mle-1)*mbb*msp)
      pnt1(3) = (tmp1-newr)/(tmp1-tmp2)*z(i+(j-1)*mbb+(mle-1)*mbb*msp) + &
&               (newr-tmp2)/(tmp1-tmp2)*z(i+(j-2)*mbb+(mle-1)*mbb*msp)
      pnt3(1) = newr+rmax
      pnt3(2) = pnt1(2)
      pnt3(3) = pnt1(3)
    ENDIF
    tmp1 = r(i+(j-1)*mbb+(mte-1)*mbb*msp)
    tmp2 = r(i+(j-2)*mbb+(mte-1)*mbb*msp)
    IF(tmp1.GE.newr .AND. tmp2.LE.newr)THEN
      PRINT*,' Found trailing edge'
      pnt2(1) = newr
      pnt2(2) = (tmp1-newr)/(tmp1-tmp2)*t(i+(j-1)*mbb+(mte-1)*mbb*msp) + &
&               (newr-tmp2)/(tmp1-tmp2)*t(i+(j-2)*mbb+(mte-1)*mbb*msp)
      pnt2(3) = (tmp1-newr)/(tmp1-tmp2)*z(i+(j-1)*mbb+(mte-1)*mbb*msp) + &
&               (newr-tmp2)/(tmp1-tmp2)*z(i+(j-2)*mbb+(mte-1)*mbb*msp)
    ENDIF
  ENDDO

  xyz1 = (/x(pnt1),y(pnt1),pnt1(3)/)
  xyz2 = (/x(pnt2),y(pnt2),pnt2(3)/)
  xyz3 = (/x(pnt3),y(pnt3),pnt3(3)/)

  vect1 = xyz2-xyz1
  vect2 = xyz3-xyz1

  cprod(1) = vect1(2)*vect2(3)-vect1(3)*vect2(2)
  cprod(2) = vect1(3)*vect2(1)-vect1(1)*vect2(3)
  cprod(3) = vect1(1)*vect2(2)-vect1(2)*vect2(1)

  xyz3 = xyz1 + cprod

  WRITE(*,*) xyz1
  WRITE(*,*) xyz2
  WRITE(*,*) xyz3

  STOP
END PROGRAM pivplane

REAL FUNCTION x(rtz)
  IMPLICIT NONE
  REAL,INTENT(IN) :: rtz(3)
  x = rtz(1)*SIN(rtz(2))
END FUNCTION x

REAL FUNCTION y(rtz)
  IMPLICIT NONE
  REAL,INTENT(IN) :: rtz(3)
  y = rtz(1)*COS(rtz(2))
END FUNCTION y
