PROGRAM probeplace
  IMPLICIT NONE

  INTEGER :: mfl,msp,mbb,mle,mte,mtp,nbld
  INTEGER :: i,j,k,mvmax,nump
  INTEGER :: mink
  REAL,ALLOCATABLE,DIMENSION(:) :: z,r,t
  REAL :: pspan,tethick,rmin,rmax
  REAL :: tmp,mdist
  REAL :: deltat
  CHARACTER(LEN=80) :: fnam
  CHARACTER(LEN=2) :: pos
  LOGICAL :: ios

! Input
  ios = .FALSE.
  DO WHILE(.NOT.ios)
    WRITE(*,*) ' Enter File Name ==>'
    READ(*,*) fnam
    INQUIRE(FILE=fnam,EXIST=ios)
  ENDDO
  WRITE(*,*) ' Enter number of te points ==>'
  READ(*,*) nump

! Read Vstage Grid
  OPEN(UNIT=10,FILE=fnam,FORM='unformatted')
  READ(10) mfl,msp,mbb,mle,mte,mtp,nbld
  WRITE(*,*) mfl,msp,mbb,mle,mte,mtp,nbld
  mvmax = mfl*msp*mbb
  ALLOCATE(z(mvmax),r(mvmax),t(mvmax))
  deltat = 2*3.14159265/FLOAT(nbld)
  DO j = 1, msp
    READ(10) &
      ((z(i+(j-1)*mbb+(k-1)*mbb*msp),k=1,mfl),i=1,mbb), &
      ((r(i+(j-1)*mbb+(k-1)*mbb*msp),k=1,mfl),i=1,mbb), &
      ((t(i+(j-1)*mbb+(k-1)*mbb*msp),k=1,mfl),i=1,mbb)
  ENDDO
  CLOSE(10)
  WRITE(*,*) ' The grid file has been successfully read'
  rmin = MINVAL(r)
  rmax = MAXVAL(r)
  
! Determine le/te radius at given %span and suggest a probe location
  OPEN(UNIT=11,FILE='probeplace.spreadsheet.txt',FORM='formatted')
  WRITE(11,*) 'J(spanwise) %span TE_thickness Err Min-K'
  DO j=1,msp
    i=1
    k=mte
    pspan=(r(i+(j-1)*mbb+(k-1)*mbb*msp)-rmin)/(rmax-rmin)
    tmp = ABS(t(mbb+(j-1)*mbb+(mte-nump-1)*mbb*msp)-t(1+(j-1)*mbb+(mte-nump-1)*mbb*msp))
    tethick = (deltat - tmp)*r(i+(j-1)*mbb+(mte-1)*mbb*msp)
    mdist = 1000.
    mink = mte
    DO k=mte+1,mfl
      tmp = ABS(z(i+(j-1)*mbb+(mte-1)*mbb*msp)+2.*tethick - z(i+(j-1)*mbb+(k-1)*mbb*msp))
      IF(tmp.LE.mdist)THEN
        mdist = tmp
        mink = k
      ENDIF
    ENDDO
    WRITE(11,*) j, pspan, tethick, mdist, mink
  ENDDO
  CLOSE(11)

  STOP
END PROGRAM probeplace
