!#######################################################################
SUBROUTINE equivsub
!#######################################################################
  USE general, ONLY: patches, iblck, surfnames, isurf, trueint, eqpairs
  IMPLICIT NONE

  INTEGER :: i, j, k, r, s, cntr
  INTEGER :: outint

  CHARACTER(LEN=20) :: interfacetmp

  interfacetmp='interface'

  ALLOCATE(trueint(isurf))
  DO i=1,isurf
    CALL keywordsub(surfnames(i),interfacetmp,outint)
    PRINT*, ' outint:', outint
    IF(outint.GT.0) then
      trueint(i)=.TRUE.
      PRINT*, ' TURE', i
    ELSE
      trueint(i)=.FALSE.
      PRINT*, ' FALSE', i
    ENDIF
  ENDDO

  cntr=0
  DO i=1,iblck
    DO j=1,patches(i)%nptch
      IF(trueint(patches(i)%ptch(j,7))) then
        IF(patches(i)%ptch(j,9).NE.0) then
          DO k=patches(i)%ptch(j,1),patches(i)%ptch(j,4)
            DO r=patches(i)%ptch(j,2),patches(i)%ptch(j,5)
              DO s=patches(i)%ptch(j,3),patches(i)%ptch(j,6)
                cntr=cntr+1
              ENDDO
            ENDDO
          ENDDO
        ENDIF
      ENDIF
    ENDDO
  ENDDO

  eqpairs=cntr/2
  END SUBROUTINE equivsub

!#######################################################################
  SUBROUTINE fillequiv(tol,beqcntr)
!#######################################################################
  USE general, ONLY: patches, iblck, trueint, eqpairnodes, eqpairs
  USE common_area, ONLY: pgr
  IMPLICIT NONE

  INTEGER :: i, j, k, r, s, q, p
  INTEGER :: ip, jp, kp, rp, sp
  INTEGER :: ijk2nod
  INTEGER :: allnumc, allnump
  INTEGER :: eqcntr, beqeq, tries, cntrp, cntrcur
  INTEGER, INTENT(INOUT) :: beqcntr

  REAL, INTENT(IN) :: tol
  REAL, ALLOCATABLE, DIMENSION(:) :: Xcur, Ycur, Zcur
  REAL, ALLOCATABLE, DIMENSION(:) :: Xpair, Ypair, Zpair
  INTEGER, POINTER, DIMENSION(:) :: nnumcur, nnumpair 

  DO i=1,iblck
    ALLOCATE(patches(i)%used(patches(i)%nptch))
    DO j=1,patches(i)%nptch
      patches(i)%used(j)=.TRUE.
    ENDDO
  ENDDO

  ALLOCATE(eqpairnodes(2,eqpairs))
  eqcntr=0
  beqcntr=0
  DO i=1,iblck
    DO j=1,patches(i)%nptch
      IF(patches(i)%used(j)) then
        patches(i)%used(j)=.FALSE.
        IF(trueint(patches(i)%ptch(j,7))) then
          IF(patches(i)%ptch(j,9).NE.0) then
            patches(patches(i)%ptch(j,9))%used(patches(i)%ptch(j,10))=.FALSE.

            allnumc=(patches(i)%ptch(j,4)-patches(i)%ptch(j,1)+1)* &
                    (patches(i)%ptch(j,5)-patches(i)%ptch(j,2)+1)* &
                    (patches(i)%ptch(j,6)-patches(i)%ptch(j,3)+1)
            ALLOCATE(nnumcur(allnumc)) 
            ALLOCATE(Xcur(allnumc))
            ALLOCATE(Ycur(allnumc))
            ALLOCATE(Zcur(allnumc))
            cntrcur=0
            DO k=patches(i)%ptch(j,1),patches(i)%ptch(j,4)
              DO r=patches(i)%ptch(j,2),patches(i)%ptch(j,5)
                DO s=patches(i)%ptch(j,3),patches(i)%ptch(j,6)
                   cntrcur=cntrcur+1
                   nnumcur(cntrcur)=ijk2nod(k,r,s,pgr(1)%li(i),pgr(1)%lj(i),i)
                   Xcur(cntrcur)=pgr(1)%x(nnumcur(cntrcur))
                   Ycur(cntrcur)=pgr(1)%y(nnumcur(cntrcur))
                   Zcur(cntrcur)=pgr(1)%z(nnumcur(cntrcur))
                ENDDO
              ENDDO
            ENDDO
 

            ip=patches(i)%ptch(j,9)
            jp=patches(i)%ptch(j,10)

            allnump=(patches(ip)%ptch(jp,4)-patches(ip)%ptch(jp,1)+1)* &
                    (patches(ip)%ptch(jp,5)-patches(ip)%ptch(jp,2)+1)* &
                    (patches(ip)%ptch(jp,6)-patches(ip)%ptch(jp,3)+1)
            ALLOCATE(nnumpair(allnump))
            ALLOCATE(Xpair(allnump))
            ALLOCATE(Ypair(allnump))
            ALLOCATE(Zpair(allnump))
            cntrp=0
            DO kp=patches(ip)%ptch(jp,1),patches(ip)%ptch(jp,4)
              DO rp=patches(ip)%ptch(jp,2),patches(ip)%ptch(jp,5)
                DO sp=patches(ip)%ptch(jp,3),patches(ip)%ptch(jp,6)
                   cntrp=cntrp+1
                   nnumpair(cntrp)=ijk2nod(kp,rp,sp,pgr(1)%li(ip),pgr(1)%lj(ip),ip)
                   Xpair(cntrp)=pgr(1)%x(nnumpair(cntrp))
                   Ypair(cntrp)=pgr(1)%y(nnumpair(cntrp))
                   Zpair(cntrp)=pgr(1)%z(nnumpair(cntrp))
!                   PRINT*, ' Xp, Yp, Zp', Xpair(cntrp), Ypair(cntrp), Zpair(cntrp)
                ENDDO
              ENDDO
            ENDDO

            IF(cntrcur.NE.cntrp) then
!              WRITE(*,*) 'The number of points for the paired faces do not match.'
              exit
            ELSE
              DO q=1,cntrcur
                tries=1
                DO p=1,cntrp
                  IF(ABS(Xcur(q)-Xpair(p)).LE.tol .AND. ABS(Ycur(q)-Ypair(p)).LE.tol &
                   .AND. ABS(Zcur(q)-Zpair(p)).LE.tol) then
                    eqcntr=eqcntr+1
                    eqpairnodes(1,eqcntr)=nnumcur(q)
                    eqpairnodes(2,eqcntr)=nnumpair(p)
                    goto 10
                  ELSE
                    tries=tries+1
                  ENDIF
                ENDDO
!                PRINT*, ' Xc, Yc, Zc', Xcur(q), Ycur(q), Zcur(q)
                beqcntr=beqcntr+1
10              CYCLE  
              ENDDO
            ENDIF
            DEALLOCATE(nnumcur,Xcur,Ycur,Zcur,nnumpair,Xpair,Ypair,Zpair)

          ENDIF
        ENDIF
      ENDIF
    ENDDO
  ENDDO

  beqeq=beqcntr+eqcntr
  PRINT*, ' Total # of Correct pairs:', eqcntr
  PRINT*, ' Total # of Incorrect pairs:', beqcntr
  PRINT*, ' Total # of Correct pairs + Incorrect pairs:', beqeq
  PRINT*, ' The number of equivalent pairs', eqpairs

  RETURN

END SUBROUTINE fillequiv

!#######################################################################
INTEGER FUNCTION ijk2nod(i,j,k,il,jl,bn)
!#######################################################################
  USE common_area, ONLY: pgr
  IMPLICIT NONE

  INTEGER,INTENT(IN) :: i,j,k,il,jl,bn
  INTEGER :: s,q

  s = 0
  DO q = 1, bn-1, 1
    s = s + pgr(1)%mvmax(q)
  ENDDO
  ijk2nod = i + (j-1)*il + (k-1)*il*jl + s

END FUNCTION ijk2nod
