MODULE readgrid
  USE general
!  USE common_area

  IMPLICIT NONE

CONTAINS

!#######################################################################
  SUBROUTINE Init_Pgr()
!#######################################################################
    USE common_area, ONLY: ngrid, pgr
    
    INTEGER i

    DO i=1,ngrid
      NULLIFY(pgr(i)%x)
      NULLIFY(pgr(i)%y)
      NULLIFY(pgr(i)%z)
      NULLIFY(pgr(i)%em)
      NULLIFY(pgr(i)%r)
      NULLIFY(pgr(i)%t)
      NULLIFY(pgr(i)%t0)
      NULLIFY(pgr(i)%ph)
      NULLIFY(pgr(i)%i)
      NULLIFY(pgr(i)%j)
      NULLIFY(pgr(i)%k)
      NULLIFY(pgr(i)%w)

      NULLIFY(pgr(i)%iblank)

      NULLIFY(pgr(i)%li)
      NULLIFY(pgr(i)%lj)
      NULLIFY(pgr(i)%lk)
      NULLIFY(pgr(i)%gis)
      NULLIFY(pgr(i)%gjs)
      NULLIFY(pgr(i)%gks)
      NULLIFY(pgr(i)%mvmax)
    ENDDO

  END SUBROUTINE Init_Pgr

!#######################################################################
  SUBROUTINE Rd_P3DT_Grd(fnam,n)
!#######################################################################
    USE common_area, ONLY: coordsys, NSTRLEN, pgr, liblank

    LOGICAL :: ios
    CHARACTER(LEN=NSTRLEN) :: fnam
    INTEGER :: i,j,k,s,id,jd,kd,m,n,mvmax,nblks

    coordsys = 0

    WRITE(*,*) ' Reading grid file',n,fnam
    CALL Check_File_Exist(fnam,ios)
    CALL Fatal_Error(ios,'*** Grid file does not exist ***')

    OPEN(UNIT=20,FILE=fnam,FORM='unformatted')

    READ(20) nblks
    pgr(n)%nblks = nblks
    ALLOCATE(pgr(n)%lk(nblks),pgr(n)%lj(nblks),pgr(n)%li(nblks))
    READ(20) (pgr(n)%li(i),pgr(n)%lj(i),pgr(n)%lk(i),i=1,nblks)

    mvmax = 0
    ALLOCATE(pgr(n)%gis(nblks), pgr(n)%gjs(nblks), &
             pgr(n)%gks(nblks), pgr(n)%mvmax(nblks))
    DO m = 1, nblks
      pgr(n)%gis(m)=0
      pgr(n)%gjs(m)=0
      pgr(n)%gks(m)=0
      pgr(n)%mvmax(m)=pgr(n)%lk(m)*pgr(n)%lj(m)*pgr(n)%li(m)
      mvmax=mvmax+pgr(n)%mvmax(m)
    ENDDO
    pgr(n)%tpts = mvmax

    ALLOCATE(pgr(n)%x(mvmax),pgr(n)%y(mvmax),pgr(n)%z(mvmax))
    IF(liblank)THEN
      ALLOCATE(pgr(n)%iblank(mvmax))
    ENDIF
    DO m=1,pgr(n)%nblks
      s=0
      id = pgr(n)%li(m)
      jd = pgr(n)%lj(m)
      kd = pgr(n)%lk(m)
      WRITE(*,*) '    Block ',m,id,jd,kd
      DO i=1,m-1,1
        s=s+pgr(n)%mvmax(i)
      ENDDO
      IF(liblank)THEN
        READ(20) (((pgr(n)%x(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd), &
                 (((pgr(n)%y(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd), &
                 (((pgr(n)%z(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd), &
            (((pgr(n)%iblank(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd)
      ELSE
        READ(20) (((pgr(n)%x(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd), &
                 (((pgr(n)%y(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd), &
                 (((pgr(n)%z(s+i+(j-1)*id+(k-1)*id*jd),i=1,id),j=1,jd),k=1,kd)
      ENDIF
    ENDDO

  END SUBROUTINE Rd_P3DT_Grd
END MODULE readgrid
