SUBROUTINE parsesub2(filnm)
  USE general, ONLY: MakeUpper, patches, iblck, surfnames, isurf
  IMPLICIT NONE
  
  CHARACTER(LEN=80),INTENT(IN) :: filnm

  INTEGER :: i, j, ibld, idummy, ibp
  INTEGER :: bp, cntr, linenumber, mylength
  INTEGER :: ib, npatch
  INTEGER :: int1, int2, int3
  REAL :: ribld
  CHARACTER(LEN=80) :: strin, inter

  OPEN(unit=20,file=filnm,form='formatted')


!Find the number of blades
  linenumber=0
10   READ(20,"(A80)",ERR=7000,END=9000) strin
  linenumber=linenumber+1

  strin=TRIM(ADJUSTL(strin))

  IF(strin.EQ.'# Topology Data')THEN
    READ(20,"(A80)",ERR=7000,END=9000) strin
    READ(20,*,ERR=7000,END=9000) ribld
    linenumber=linenumber+2
  ELSE
    goto 10
  ENDIF

  ibld=FLOOR(ribld)

  PRINT*, 'number of blades:', ibld
  PRINT*, 'line number:', linenumber


!Find the number of blocks
20   READ(20,"(A80)",ERR=7000,END=9000) strin
  linenumber=linenumber+1

  strin=TRIM(ADJUSTL(strin))

  IF(strin.EQ.'# Block names / shafts')THEN
    READ(20,"(A80)",ERR=7000,END=9000) strin
    READ(20,*,ERR=7000,END=9000) iblck
    linenumber=linenumber+2
  ELSE
    goto 20
  ENDIF

  PRINT*, 'number of blocks:', iblck
  PRINT*, 'line number:', linenumber


!Find the number of surfaces and surface names
30   READ(20,"(A80)",ERR=7000,END=9000) strin
  linenumber=linenumber+1

  IF(strin.EQ.'# Surface/Group definitions')THEN
    READ(20,"(A80)",ERR=7000,END=9000) strin
    READ(20,"(A80)",ERR=7000,END=9000) strin
    READ(20,*,ERR=7000,END=9000) isurf
    linenumber=linenumber+3
  ELSE
    goto 30
  ENDIF

  PRINT*, 'number of surfaces:', isurf
  PRINT*, 'line number:', linenumber

  ALLOCATE(surfnames(isurf))

  
  bp=0
  inter='INTERFACE'
  WRITE(*,*) 'the surface names are:'
  DO i=1,isurf
    READ(20,"(I2,A80)",ERR=7000,END=9000) idummy, strin
    linenumber=linenumber+1

    mylength = LEN_TRIM(strin)
    CALL MakeUpper(strin,mylength)
    surfnames(i)=TRIM(ADJUSTL(strin))
    PRINT*, surfnames(i)
  ENDDO


!=======================================================================
! Read patches
  ALLOCATE(patches(iblck))

  ib=-1
  DO WHILE(ib.NE.0)
7100 CONTINUE
    READ(20,*,ERR=7100,END=9000) ib, npatch

    IF(ib.EQ.0) exit

    ! Read ib, npatch
    ALLOCATE(patches(ib)%ptch(npatch,10), patches(ib)%nam(npatch))
    patches(ib)%nptch = npatch

    DO i=1,npatch
7200 CONTINUE
      READ(20,*,ERR=7200,END=9000) int1, int2, int3
        patches(ib)%ptch(i,1)=int1
        patches(ib)%ptch(i,2)=int2
        patches(ib)%ptch(i,3)=int3
  
      READ(20,*,ERR=7300,END=9000) int1, int2, int3
        patches(ib)%ptch(i,4)=int1
        patches(ib)%ptch(i,5)=int2
        patches(ib)%ptch(i,6)=int3

      READ(20,*,ERR=7300,END=9000) int1, int2
        patches(ib)%ptch(i,7)=int1
        patches(ib)%ptch(i,8)=int2
      READ(20,"(I4,I5)",ERR=7300,END=9000) int1, int2
        patches(ib)%ptch(i,9)=int1
        patches(ib)%ptch(i,10)=int2

      CYCLE
7300 CONTINUE
    ENDDO
  ENDDO


  RETURN

7000 CONTINUE
     WRITE(*,*) '  ERROR reading from script file '
9000 CONTINUE
     WRITE(*,*) '  Closing image scripting file.'
     CLOSE(20)

END SUBROUTINE parsesub2
